#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- 18 modifications in this file -------------*/

#endif
/* --------------------------------------------------------------------------------------
			G_INTERFACE1.C
   ------------------------------------------------------------------------------------*/
/* cree les Widgets de G_neuron, les variables correspondantes
   sont declarees dans "G_interface.h" */

# if 0
			    top_levelG	(cf G_neuron2.c)
				|
	--------------------- Form_G --------------------
	|			|			|
   Drawing_A1			Row_Column_Menu		Push_Button_Calcul
   Drawing_A2			|
   Drawing_A3		  Menu_Bar_Main
(fabrique_drawing_areas())	|
		---------------------------------
		|				|
		File				Parameters
		  - Read Neuron			  - Conductance -> fabrique_scrolled_window_conductance()
		  - Write Back Neuron		  - PSP		-> fabrique_scrolled_window_PSP()
		  - Save Neuron As		  - NMDA	-> fabrique_form_NMDA()
		  - Plot Potential		  - Equilibrium	-> fabrique_scrolled_window_equilibrium()
		  - Quit			  - Activ-Inact -> fabrique_scrolled_window_activ()
						  - Simulation	-> fabrique_form_simulation()
		                                  - Scales      -> fabrique_form_Echelles()
# endif



#undef MAIN

#include "G_neuron.h"
#include "G_interface.h"
#include "G_synap.h"

XmString  result;
int       n;
Arg       wargs[10];

Pixmap	equa_bits, equa_pix;
GC	eq_gc;
unsigned int equa_width, equa_height;


void fabrique_scrolled_window_conductance();
void fabrique_scrolled_window_PSP();
void fabrique_form_NMDA();
void fabrique_scrolled_window_activ();

#define	DIAL_WIDTH	230
#define	DIAL_HEIGHT	270

/*   f o n c t i o n    u t i l e */

/*-------------------------------------------------------*/			
void fabrique_scrolled_window_conductance()
/*-------------------------------------------------------*/
# if 0
		Top_Level_Conductance
			|
		Scrolled_Window_Conductance
			|
		Row_Column_Conductance
			|
			widgets DeXDDial :
			DeXInput_Mb_Capacity
			DeXInput_G_Syn_EPSP
			DeXInput_G_Na
			DeXInput_G_Ca
			DeXInput_G_K_Ia
			DeXInput_G_K_Iahp
			DeXInput_Input_Crt
			DeXInput_G_Syn_IPSP
			DeXInput_G_K
			DeXInput_G_K_Im
			DeXInput_G_K_Ic
			DeXInput_G_Leak
# endif
{

        int		n;
	Arg		wargs[50];
	XmString	titre,
	                string1,
			string2,
			string3,
			string4,
			string5,
			string6,
			string7,
			string8,
			string9,
			string10,
			string11,
			string21,
			string22,
			string23,
			string24,
			string25;
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	XmString	string26;
#endif

	XColor		rgb,
			def;


	if(flag_conductance != 0)	/* si flag = 1 : la fenetre existe deja */
	{
		XtPopup(Top_Level_Conductance,XtGrabNone);
		return;
	} 


	
	/*---------- toplevel pour les parametres de conductance ----------*/

	Top_Level_Conductance = XtCreateApplicationShell("topc",
							 topLevelShellWidgetClass,
							 wargs,
							 0);
	sprintf(buffer,"Conductance models [%s]",model_name);
	XtVaSetValues(Top_Level_Conductance,
		      XmNtitle, buffer,
		      XmNx, w_x_1,
		      XmNy, (flag_horizontal? w_y_h1: w_y_v1), NULL);

	
	/*---- scrolledwindow pour la conductance ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, (Dimension)((screen_height - 120)/2));n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	XtSetArg(wargs[n], XmNwidth, (.46 * (screen_width - 20)));n++;
	Scrolled_Window_Conductance = XtCreateManagedWidget("conductance",
							   xmScrolledWindowWidgetClass,
							   Top_Level_Conductance,
							   wargs, n);
	XtAddCallback(Top_Level_Conductance, XmNdestroyCallback, fermeture_Conductance, NULL);
							   
	/*---- container pour les widgets de conductance ----*/

	/*************************************/
	
	n = 0;
	XtSetArg(wargs[n], XmNresizePolicy, XmRESIZE_GROW); n++;
	/*
	XtSetArg(wargs[n], XmNwidth, (screen_width/2)); n++;
	XtSetArg(wargs[n], XmNheight, (screen_height - 55)); n++;
	*/
	conductance_form = XmCreateForm(Scrolled_Window_Conductance,
		"form",
		wargs, 
		n);
	XtManageChild(conductance_form);


	/* Couleur de la fleche */
	XAllocNamedColor(XtDisplay(Top_Level_Conductance),
			 DefaultColormap(XtDisplay(Top_Level_Conductance),
			 DefaultScreen(XtDisplay(Top_Level_Conductance))),
			 "red", &def, &rgb);


	/* les conductances */
	
	n = 0;

	string1 = XmStringCreateSimple("Conductances in mS/cm2");	

	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNx, 250); n++;
	XtSetArg(wargs[n], XmNy, 450); n++;
	XtSetArg(wargs[n], XmNwidth, 286); n++;
	XtSetArg(wargs[n], XmNheight, 30); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopWidget, separator1); n++;
	XtSetArg(wargs[n], XmNtopOffset, 5); n++;
	XtSetArg(wargs[n], XmNleftOffset, 200); n++;
	label_conductances = XmCreateLabel(conductance_form,
		"label",
		wargs, 
		n);
	XtManageChild(label_conductances);
	XmStringFree(string1);
	
	n = 0;

	string1 = XmStringCreateSimple("No current selected                ");	

	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNx, 10); n++;
	XtSetArg(wargs[n], XmNy, 590); n++;
	XtSetArg(wargs[n], XmNheight, 30); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 5); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	label_selection = XmCreateLabel(conductance_form,
		"label_select",
		wargs, 
		n);
	XtManageChild(label_selection);
	XmStringFree(string1);
	
	n = 0;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 35); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNwidth, DIAL_WIDTH);n++;
	XtSetArg(wargs[n], XmNheight, DIAL_HEIGHT);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], DeXNindicatorColor, def.pixel); n++;
	XtSetArg(wargs[n], DeXNincrement, 1L); n++;
	XtSetArg(wargs[n], DeXNminimum, 0L); n++;
	XtSetArg(wargs[n], DeXNmaximum, 100L); n++;
	XtSetArg(wargs[n], DeXNturnStep,1L);  n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0); n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
	XtSetArg(wargs[n], DeXNvalue, 0L); n++;
	XtSetArg(wargs[n], DeXNlabelString, " "); n++;
	Dial_Conductances = XtCreateManagedWidget("dialconductances",
					      DeXdDialWidgetClass,
					      conductance_form,
					      wargs, n);
	register_widget_CB(Dial_Conductances, (XtPointer)ID_Dial_Conductances, NULL);
	create_event_CB(Dial_Conductances, (XtPointer)ID_Dial_Conductances, NULL);
	XtAddCallback(Dial_Conductances, DeXNvalueChangedCallback, (XtPointer)callback_conductances, NULL);

	/* Appel des parametres */

	n = 0;
	string1 = XmStringCreateSimple("Act/Inac para"); 
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNx, 10); n++;
	XtSetArg(wargs[n], XmNy, 570); n++;
	XtSetArg(wargs[n], XmNwidth, DIAL_WIDTH); n++;
	XtSetArg(wargs[n], XmNheight, 40); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 310); n++;
	param_pushButton = XmCreatePushButton(conductance_form,
		"param_pushButton",
		wargs,
		n);
	register_widget_CB(param_pushButton, (XtPointer)ID_param_pushButton, NULL);
	create_event_CB(param_pushButton, (XtPointer)ID_param_pushButton, NULL);
	XtManageChild(param_pushButton);
	XmStringFree(string1);

	
	
	string1 = XmStringCreateSimple("Integration method"); 
	string2 = XmStringCreateSimple("Exponential"); 
	string3 = XmStringCreateSimple("Euler"); 
	string4 = XmStringCreateSimple("Runge_Kutta"); 
/*	string5 = XmStringCreateSimple("Runge_Kutta var. step"); */
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
	string6 = XmStringCreateSimple("Integration method:"); 

#endif
	integration_toggleButton = XmVaCreateSimpleOptionMenu(conductance_form,
		"integration_OM",
		string1, 'I', 0, (XtPointer)callback_toggle_integration,
		XmVaPUSHBUTTON, string2, 'E', NULL, NULL,
		XmVaPUSHBUTTON, string3, 'U', NULL, NULL,
		XmVaPUSHBUTTON, string4, 'R', NULL, NULL,
/*		XmVaPUSHBUTTON, string5, 'V', NULL, NULL,*/
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
		XmVaPUSHBUTTON, string6, 'M', NULL, NULL,
#endif
		XmNorientation, XmVERTICAL,
		NULL);
	register_widget_CB(integration_toggleButton, (XtPointer)ID_integration_toggleButton, NULL);
	create_event_CB(integration_toggleButton, (XtPointer)ID_integration_toggleButton, NULL);
	XtManageChild(integration_toggleButton);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, DIAL_WIDTH); n++;
	XtSetArg(wargs[n], XmNheight, 50); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNtopWidget, param_pushButton); n++;
	XtSetArg(wargs[n], XmNtopOffset, 10); n++;
	XtSetValues(integration_toggleButton,wargs,n);
	XmStringFree(string1);
	XmStringFree(string2);
	XmStringFree(string3);
	XmStringFree(string4);
	/* XmStringFree(string5);*/

	/* Les radioBoxes */

	sprintf(buffer,"G Na: %.3f",g_Na);
	string1 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G Na pers: %.3f",g_Nap);
	string2 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G K: %.3f",g_K);
	string3 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G K for Ia: %.3f",g_A);
	string4 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G K for Im: %.3f",g_M);
	string5 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G K for Ic: %.3f",g_C);
	string6 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G K for Ih: %.3f",g_H);
	string23 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G K for Iahp: %.3f",g_ahp);
	string7 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G Ca HVA: %.3f",g_Ca);
	string8 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G Ca LVA: %.3f",g_Cab);
	string9 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G Leak: %.3f",g_fuite);
	string10 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G NMDA: %.3f",g_NMDA);
	string11 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G Syn EPSP: %.3f",g_Syn_pos);
	string21 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G Syn IPSP: %.3f",g_Syn_neg);
	string22 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G Na Leak: %.3f",g_fuite_Na);
	string24 = XmStringCreateSimple(buffer);
	sprintf(buffer,"G K Leak: %.3f",g_fuite_K);
	string25 = XmStringCreateSimple(buffer);
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	sprintf(buffer,"G INew: %.3f",g_Syn_neg);
	string26 = XmStringCreateSimple(buffer);
#endif

	n = 0;
	XtSetArg(wargs[n], XmNshadowType, XmSHADOW_IN); n++;
	XtSetArg(wargs[n], XmNx, 250); n++;
	XtSetArg(wargs[n], XmNy, 620); n++;
	XtSetArg(wargs[n], XmNwidth, 200); n++;
	XtSetArg(wargs[n], XmNheight, 376); n++; 
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 250); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 35); n++;
	frame_RB = XmCreateFrame(conductance_form,"frameRB1",wargs,n);
	XtManageChild(frame_RB);

	
	/*---- scrolledwindow pour la radio_box ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, 370);n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	XtSetArg(wargs[n], XmNwidth, 250);n++;
	frame_scrolled = XtCreateManagedWidget("frame_scrolled",
							   xmScrolledWindowWidgetClass,
							   frame_RB,
							   wargs, n);

	n = 0;
	XtSetArg(wargs[n], XmNisHomogeneous, False); n++;
	radioBox = XmCreateRadioBox(frame_scrolled,
		"radioBox",
		wargs, 
		n);
	register_widget_CB(frame_scrolled, (XtPointer)ID_radioBox, NULL);
	create_event_CB(frame_scrolled, (XtPointer)ID_radioBox, NULL);
	XtManageChild(radioBox);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	toggleButton1 = XmCreateToggleButton(radioBox,
		"toggleButton1",
		wargs, 
		n);
	XtManageChild(toggleButton1);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string2); n++;
	toggleButton2 = XmCreateToggleButton(radioBox,
		"toggleButton2",
		wargs, 
		n);
	XtManageChild(toggleButton2);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string3); n++;
	toggleButton3 = XmCreateToggleButton(radioBox,
		"toggleButton3",
		wargs, 
		n);
	XtManageChild(toggleButton3);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string4); n++;
	toggleButton4 = XmCreateToggleButton(radioBox,
		"toggleButton4",
		wargs, 
		n);
	XtManageChild(toggleButton4);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string5); n++;
	toggleButton5 = XmCreateToggleButton(radioBox,
		"toggleButton5",
		wargs, 
		n);
	XtManageChild(toggleButton5);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string6); n++;
	toggleButton6 = XmCreateToggleButton(radioBox,
		"toggleButton6",
		wargs, 
		n);
	XtManageChild(toggleButton6);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string7); n++;
	toggleButton7 = XmCreateToggleButton(radioBox,
		"toggleButton7",
		wargs, 
		n);
	XtManageChild(toggleButton7);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string23); n++;
	toggleButton23 = XmCreateToggleButton(radioBox,
		"toggleButton23",
		wargs, 
		n);
	XtManageChild(toggleButton23);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string8); n++;
	toggleButton8 = XmCreateToggleButton(radioBox,
		"toggleButton8",
		wargs, 
		n);
	XtManageChild(toggleButton8);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string9); n++;
	toggleButton9 = XmCreateToggleButton(radioBox,
		"toggleButton9",
		wargs, 
		n);
	XtManageChild(toggleButton9);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string10); n++;
	toggleButton10 = XmCreateToggleButton(radioBox,
		"toggleButton10",
		wargs, 
		n);
	XtManageChild(toggleButton10);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string24); n++;
	toggleButton24 = XmCreateToggleButton(radioBox,
		"toggleButton24",
		wargs, 
		n);
	XtManageChild(toggleButton24);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string25); n++;
	toggleButton25 = XmCreateToggleButton(radioBox,
		"toggleButton25",
		wargs, 
		n);
	XtManageChild(toggleButton25);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string11); n++;
	toggleButton11 = XmCreateToggleButton(radioBox,
		"toggleButton11",
		wargs, 
		n);
	XtManageChild(toggleButton11);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 200); n++;
	XtSetArg(wargs[n], XmNheight, 28); n++;
	XtSetArg(wargs[n], XmNlabelString, string24); n++;
	toggleButton24 = XmCreateToggleButton(radioBox1,
		"toggleButton24",
		wargs, 
		n);
	XtManageChild(toggleButton24);
#endif

	XmStringFree(string1);
	XmStringFree(string2);
	XmStringFree(string3);
	XmStringFree(string4);
	XmStringFree(string5);
	XmStringFree(string6);
	XmStringFree(string7);
	XmStringFree(string8);
	XmStringFree(string9);
	XmStringFree(string10);
	XmStringFree(string11);
#if 0
	XmStringFree(string21);
	XmStringFree(string22);
#endif
	XmStringFree(string23);
	XmStringFree(string24);
	XmStringFree(string25);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	XmStringFree(string24);
#endif

	XtAddCallback(toggleButton1,  XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)1);
	XtAddCallback(toggleButton2,  XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)2);
	XtAddCallback(toggleButton3,  XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)3);
	XtAddCallback(toggleButton4,  XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)4);
	XtAddCallback(toggleButton5,  XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)5);
	XtAddCallback(toggleButton6,  XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)6);
	XtAddCallback(toggleButton7,  XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)7);
	XtAddCallback(toggleButton8,  XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)8);
	XtAddCallback(toggleButton9,  XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)9);
	XtAddCallback(toggleButton10, XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)10);
	XtAddCallback(toggleButton11, XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)11);
	XtAddCallback(toggleButton23, XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)23);
	XtAddCallback(toggleButton24, XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)24);
	XtAddCallback(toggleButton25, XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)25);
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	XtAddCallback(toggleButton24, XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)24);
#endif

#if 0
	XtAddCallback(toggleButton21, XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)21);
	XtAddCallback(toggleButton22, XmNvalueChangedCallback, (XtPointer)retour_conductances, (XtPointer)22);
#endif

	XtAddCallback(param_pushButton,  XmNactivateCallback, (XtPointer)callback_activ, NULL);
	
	

	XtManageChild(Scrolled_Window_Conductance);
	XtRealizeWidget(Top_Level_Conductance);

	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_Conductance), palette);

	XmToggleButtonSetState(toggleButton1,TRUE,TRUE);

	flag_conductance = 1;
}

/*---------------------------------------------------*/
	void fabrique_scrolled_window_PSP()
/*---------------------------------------------------*/
# if 0
				Top_Level_PSP
					|
				Scrolled_Window_PSP
					|
				Row_Column_PSP
					|
				Widgets DeXInput:
                                  DeXInput_Pos_Rev_Pot
                                  DeXInput_Neg_Rev_Pot  
				  DeXInput_Tau_EPSP_A
				  DeXInput_Tau_EPSP_D
				  DeXInput_Tau_IPSP_A
				  DeXInput_Tau_IPSP_D
                                  Separator_Parametre1
				  DeXInput_Bckg_Noise_Mean
				  DeXInput_Bckg_Noise_Sd
				  DeXInput_Bckg_Noise_Resistance
                                  Separator_Parametre2
				  DeXInput_Holding_Potential
				  DeXInput_Command_Potential
				  PushButton
# endif
{
	int		n;
	Arg		wargs[20];
	XmString	string1;

	if(flag_PSP != 0)
	{
		XtPopup(Top_Level_PSP,XtGrabNone);
		return;
	} 


	/*---------- toplevel pour les parametres PSP ----------*/

	Top_Level_PSP = XtCreateApplicationShell("toppsp",
						 topLevelShellWidgetClass,
						 wargs,
						 0);
	XtVaSetValues(Top_Level_PSP,
		      XmNtitle, "Noise and Clamping Parameters",
		      XmNx, 600,
		      XmNy, 30,
		      NULL);
	
	/*---- scrolledwindow pour PSP ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, 800);n++;
	XtSetArg(wargs[n], XmNwidth, 265);n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	Scrolled_Window_PSP = XtCreateManagedWidget("scrolledwpsp",
						    xmScrolledWindowWidgetClass,
						    Top_Level_PSP,
						    wargs, n);
	/* PushButton de fermeture */
	string1 = XmStringCreateSimple("Close");	

	n = 0;
	XtSetArg(wargs[n], XmNx, 75);n++;
	XtSetArg(wargs[n], XmNy, 720);n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNwidth, 100); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_CENTER); n++;
	Close_PSP = XtCreateManagedWidget("close_PSP",
						  xmPushButtonWidgetClass,
						  Scrolled_Window_PSP,
						  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Close_PSP, XmNactivateCallback, (XtPointer)callback_close_PSP, NULL);

	/*---- container pour les widgets PSP ----*/
	n = 0;
	XtSetArg(wargs[n], XmNnumColumns, 1);n++;
	XtSetArg(wargs[n], XmNorientation, XmVERTICAL);n++;
	XtSetArg(wargs[n], XmNborderWidth, 0);n++;
	XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	Row_Collumn_PSP = XtCreateManagedWidget("rcPSP",
						xmRowColumnWidgetClass,
						Scrolled_Window_PSP,
						wargs, n);

	/*---- widgets DeXInput ----*/
#if 0
	if (flag_phenom)
	{
		/* 1 Pos Rev Pot */
		n = 0;
		XtSetArg(wargs[n], XmNborderWidth, 1);n++;
		XtSetArg(wargs[n], XmNwidth, 250);n++;
		XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
		XtSetArg(wargs[n], DeXNdefaultValue, -1000);n++;
		XtSetArg(wargs[n], DeXNvalue, (int) (rev_pot_pos * 100));n++;
		XtSetArg(wargs[n], DeXNlabelString, "Pos Rev Pot. (mV)");n++;
		DeXInput_Pos_Rev_Pot = XtCreateManagedWidget("posrevpot",
							     DeXinputWidgetClass,
							     Row_Collumn_PSP,
							     wargs, n);
		XtAddCallback(DeXInput_Pos_Rev_Pot, DeXNokCallback, (XtPointer)callback_Pos_Rev_Pot, NULL);
	}
#endif	
#if 0		
	
	/* 3 Tau_EPSP_A */
	
	
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 250);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (tau_attack_epsp * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Tau EPSP attack (ms) //\\");
	DeXInput_Tau_EPSP_A = XtCreateManagedWidget("tauepspa",
						     DeXinputWidgetClass,
						     Row_Collumn_PSP,
						     wargs, n);
	XtAddCallback(DeXInput_Tau_EPSP_A, DeXNokCallback, (XtPointer)callback_tau_EPSP_a, NULL);
	
	/* 4 Tau_EPSP_D */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 1000);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (tau_decay_epsp * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Tau EPSP decay (ms) /\\\\");
	DeXInput_Tau_EPSP_D = XtCreateManagedWidget("tauepspd",
						     DeXinputWidgetClass,
						     Row_Collumn_PSP,
						     wargs, n);
	XtAddCallback(DeXInput_Tau_EPSP_D, DeXNokCallback, (XtPointer)callback_tau_EPSP_d, NULL);
	
	/* 5 Tau_IPSP_A */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 250);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (tau_attack_ipsp * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Tau IPSP attack (ms) \\\\/");
	DeXInput_Tau_IPSP_A = XtCreateManagedWidget("tauipspa",
					     DeXinputWidgetClass,
					     Row_Collumn_PSP,
					     wargs, n);
	XtAddCallback(DeXInput_Tau_IPSP_A, DeXNokCallback, (XtPointer)callback_tau_IPSP_a, NULL);
	
	/* 6 Tau_IPSP_D */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 1000);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (tau_decay_ipsp * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Tau IPSP decay (ms) \\//");
	DeXInput_Tau_IPSP_D = XtCreateManagedWidget("tauipspd",
					     DeXinputWidgetClass,
					     Row_Collumn_PSP,
					     wargs, n);
	XtAddCallback(DeXInput_Tau_IPSP_D, DeXNokCallback, (XtPointer)callback_tau_IPSP_d, NULL);
	
#endif	
#if 0
	if (flag_phenom)
	{
		/* 2 Neg Rev Pot */

		XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
		XtSetArg(wargs[n-3], DeXNdefaultValue, -9000);
		XtSetArg(wargs[n-2], DeXNvalue, (int) (rev_pot_neg * 100));
		XtSetArg(wargs[n-1], DeXNlabelString, "Neg Rev Pot. (mV)");
		DeXInput_Neg_Rev_Pot = XtCreateManagedWidget("negrevpot",
							     DeXinputWidgetClass,
							     Row_Collumn_PSP,
							     wargs, n);
		XtAddCallback(DeXInput_Neg_Rev_Pot, DeXNokCallback, (XtPointer)callback_Neg_Rev_Pot, NULL);
	}
#endif

	/* 7 Bckg_Noise_Mean */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 0);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (backgrd_noise_m * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Bckg Noise Mean");
	DeXInput_Bckg_Noise_Mean = XtCreateManagedWidget("bckgnoisemean",
							 DeXinputWidgetClass,
							 Row_Collumn_PSP,
							 wargs, n);
	XtAddCallback(DeXInput_Bckg_Noise_Mean, DeXNokCallback, (XtPointer)callback_bckg_noise_mean, NULL);
	
	/* 8 Bckg_Noise_Sd */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 0);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (backgrd_noise_sd * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Bckg Noise Sd");
	DeXInput_Bckg_Noise_Sd = XtCreateManagedWidget("bckgnoisesd",
						       DeXinputWidgetClass,
						       Row_Collumn_PSP,
						       wargs, n);
	XtAddCallback(DeXInput_Bckg_Noise_Sd, DeXNokCallback, (XtPointer)callback_bckg_noise_sd, NULL);
	
	/* 8 Filter Resistance for Kohn noise */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 500);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (backgrd_noise_resistance * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Noise Filter Resistance");
	DeXInput_Bckg_Noise_Resistance = XtCreateManagedWidget("bckgnoisesd",
						       DeXinputWidgetClass,
						       Row_Collumn_PSP,
						       wargs, n);
	XtAddCallback(DeXInput_Bckg_Noise_Resistance, DeXNokCallback, (XtPointer)callback_bckg_noise_resistance, NULL);
	
	/* 9 Holding_Potential */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, (int) E_fuite * 100);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (clamp_pot * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Holding Pot. (mV)");
	DeXInput_Holding_Potential = XtCreateManagedWidget("holdingpotential",
							   DeXinputWidgetClass,
							   Row_Collumn_PSP,
							   wargs, n);
	XtAddCallback(DeXInput_Holding_Potential, DeXNokCallback, (XtPointer)callback_holding_potential, NULL);
							  
	/* 10 Command_Potential */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 0);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (input_volt * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Command Pot. (mV)");
	DeXInput_Command_Potential = XtCreateManagedWidget("commandpotential",
							   DeXinputWidgetClass,
							   Row_Collumn_PSP,
							   wargs, n);
	XtAddCallback(DeXInput_Command_Potential, DeXNokCallback, (XtPointer)callback_command_potential, NULL);
	

	XtAddCallback(Top_Level_PSP, XmNdestroyCallback, fermeture_PSP, NULL);

	XtManageChild(Scrolled_Window_PSP);
	XtRealizeWidget(Top_Level_PSP);
	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_PSP), palette);

	if (voltage_clamp)
	{
	  XtSetSensitive(DeXInput_Command_Potential, True);
	  XtSetSensitive(DeXInput_Holding_Potential, True);
	}
	else
	{
	  XtSetSensitive(DeXInput_Command_Potential, False);
	  XtSetSensitive(DeXInput_Holding_Potential, False);
	}

	flag_PSP = 1;
}

/*------------------------------------------------*/
	void fabrique_form_NMDA()
/*------------------------------------------------*/
# if 0
			Top_Level_NMDA
				|
			Scrolled_Window_NMDA
				|
			Row_Collumn_NMDA (BulletinBoard)
				|
			Widgets DeXInput:
			DeXInput_Magnesium
			DeXInput_Tau_NMDA_A
			DeXInput_Tau_NMDA_D
			DeXInput_No_NMDA
			DeXInput_G_NMDA (DEXDDial)
			DeXInput_Eta_NMDA
			DeXInput_Gamma_NMDA
			DeXInput_E_NMDA
			DeXInput_Nb_NMDA
			DeXInput_Weight_NMDA
			DeXInput_Time_NMDA
# endif
{
	int	n,i;
	Arg	wargs[20];
	XmString	string1;
	XColor		rgb,
			def;
	if(flag_NMDA)
	{
		XtPopup(Top_Level_NMDA,XtGrabNone);
		return;
	} 
	
	flag_NMDA= 1;

	/*---------- toplevel pour les parametres NMDA ----------*/

	Top_Level_NMDA = XtCreateApplicationShell("topNMDA",
						  topLevelShellWidgetClass,
						  wargs,
						  0);
	XtVaSetValues(Top_Level_NMDA,
		      XmNtitle, "NMDA Parameters",
		      XmNx, 605,
		      XmNy, 800,
		      NULL);
	
	/*---- form pour les parametres de NMDA ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, 800);n++;
	XtSetArg(wargs[n], XmNwidth, 605);n++;
	XtSetArg(wargs[n], XmNfractionBase, 100);n++;
	Form_NMDA = XtCreateManagedWidget("formNMDA",
						xmFormWidgetClass,
						Top_Level_NMDA,
						wargs, n);

	XtAddCallback(Form_NMDA, XmNunmapCallback, fermeture_NMDA, NULL);

	/*---- les DeXinputs ----*/


	/* Tau_NMDA_A */

	n=0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2 );n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;

	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 8000);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (tau_attack_NMDA * 100));n++;
	XtSetArg(wargs[n], DeXNlabelString, "Tau NMDA attack (ms) //\\");n++;
	DeXInput_Tau_NMDA_A = XtCreateManagedWidget("taunmdaa",
						    DeXinputWidgetClass,
						    Form_NMDA,
						    wargs, n);
	XtAddCallback(DeXInput_Tau_NMDA_A, DeXNokCallback, (XtPointer)callback_tau_nmda_a, NULL);

	/* Tau_NMDA_D */

	n=0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, -86);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Tau_NMDA_A);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 51);n++;
	XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 66);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (tau_decay_NMDA * 100));n++;
	XtSetArg(wargs[n], DeXNlabelString, "Tau NMDA decay (ms) /\\\\");n++;
	DeXInput_Tau_NMDA_D = XtCreateManagedWidget("taunmdad",
						    DeXinputWidgetClass,
						    Form_NMDA,
						    wargs, n);
	XtAddCallback(DeXInput_Tau_NMDA_D, DeXNokCallback, (XtPointer)callback_tau_nmda_d, NULL);
	

	/* Eta_NMDA */

	n=0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, 3);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Tau_NMDA_A);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 33);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (eta_NMDA * 100));n++;
	XtSetArg(wargs[n], DeXNlabelString, "Eta NMDA (1/mM)");n++;
	DeXInput_Eta_NMDA = XtCreateManagedWidget("etanmda",
						   DeXinputWidgetClass,
						   Form_NMDA,
						   wargs, n);
	XtAddCallback(DeXInput_Eta_NMDA, DeXNokCallback, (XtPointer)callback_eta_nmda, NULL);
	
	/* Gamma_NMDA */

	n=0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, -86);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Eta_NMDA);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 51);n++;
	XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 6);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (gamma_NMDA * 100));n++;
	XtSetArg(wargs[n], DeXNlabelString, "Gamma NMDA (1/mV)");n++;
	DeXInput_Gamma_NMDA = XtCreateManagedWidget("gammanmda",
						    DeXinputWidgetClass,
						    Form_NMDA,
						    wargs, n);
	XtAddCallback(DeXInput_Gamma_NMDA, DeXNokCallback, (XtPointer)callback_gamma_nmda, NULL);

	/* E NMDA */


	n=0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, 3);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Eta_NMDA);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (rev_pot_NMDA * 100));n++;
	XtSetArg(wargs[n], DeXNlabelString, "E NMDA (mV)");n++;
	DeXInput_E_NMDA = XtCreateManagedWidget("enmda",
						DeXinputWidgetClass,
						Form_NMDA,
						wargs, n);
	XtAddCallback(DeXInput_E_NMDA, DeXNokCallback, (XtPointer)callback_E_NMDA, NULL);





	/* Magnesium */


	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, -86);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_E_NMDA);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 51);n++;
	XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNx, 0);n++;
	XtSetArg(wargs[n], XmNy, 294);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 100);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (magnesium * 100));n++;
	XtSetArg(wargs[n], DeXNlabelString, "[Mg++] Extracellular (mM)");n++;
	DeXInput_Magnesium = XtCreateManagedWidget("magnesium",
						   DeXinputWidgetClass,
						   Form_NMDA,
						   wargs, n);
	XtAddCallback(DeXInput_Magnesium, DeXNokCallback, (XtPointer)callback_magnesium, NULL);

	/* separateur  */

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 16);n++;
	XtSetArg(wargs[n], XmNheight, 16);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_E_NMDA);n++;
	Separator_NMDA_1 = XtCreateManagedWidget("separatorNMDA1",
						   xmSeparatorGadgetClass,
						   Form_NMDA,
						   wargs, n);



	/* Nb_NMDA */

	
	n=0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_NMDA_1);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0);n++;
	XtSetArg(wargs[n], DeXNvalue, nb_connexions_NMDA);n++;
	XtSetArg(wargs[n], DeXNlabelString, "Number of NMDA connections");n++;
	DeXInput_Nb_NMDA = XtCreateManagedWidget("nbnmda",
						 DeXinputWidgetClass,
						 Form_NMDA,
						 wargs, n);
	XtAddCallback(DeXInput_Nb_NMDA, DeXNokCallback, (XtPointer)callback_Nb_NMDA, NULL);


	/************************************/
	
	n = 0;
	XtSetArg(wargs[n], XmNshadowType, XmSHADOW_IN); n++;
	XtSetArg(wargs[n], XmNheight, 300); n++; 
	XtSetArg(wargs[n], XmNtopOffset, 10); n++;
	XtSetArg(wargs[n], XmNleftOffset, 6); n++;
	XtSetArg(wargs[n], XmNrightOffset, 6); n++;
	
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Nb_NMDA);n++;
	frame_NMDA = XmCreateFrame(Form_NMDA,"frameNMDA",wargs,n);
	XtManageChild(frame_NMDA);

	

	/*---- scrolledwindow pour la RowColumn des parametres NMDA ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, 300);n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	Scrolled_Window_NMDA = XtCreateManagedWidget("scrollednmda",
						     xmScrolledWindowWidgetClass,
						     frame_NMDA,
						     wargs, n);
	
	/*---- containers pour les widgets des parametres NMDA ----*/

	

	n = 0;
	XtSetArg(wargs[n], XmNnumColumns, 2);n++;
	XtSetArg(wargs[n], XmNorientation, XmVERTICAL);n++;
	XtSetArg(wargs[n], XmNborderWidth, 0);n++;
	XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	Row_Collumn_NMDA = XtCreateManagedWidget("rcNMDA",
						   xmRowColumnWidgetClass,
						   Scrolled_Window_NMDA,
						   wargs, n);

	if (flag_button_NMDA)
	  {
	    for (i = 0 ; i < nb_connexions_NMDA ; i++) 
	      {
		sprintf(buffer,"scalebuttonNMDA%d", (int)(i)); 
		sprintf(buffer1,"%d Time arrival in %%  ", (int )(i+1) );
		string1 = XmStringCreate (buffer1, XmSTRING_DEFAULT_CHARSET); 
		Scale_Buttons_NMDA[i] =
		  xs_create_scale_button(Row_Collumn_NMDA, buffer, string1 );
		XmStringFree (string1);
		
	       	XtAddCallback (Scale_Buttons_NMDA[i], 
			       XmNvalueChangedCallback, 
			       (XtPointer)callback_Time_NMDA,
			       (XtPointer)i); 
	      }

	   
	    for (i = 0 ; i < nb_connexions_NMDA ; i++) 
	      {
		sprintf(buffer,"dexinputbuttonNMDA%d", (int)(i));
		sprintf(buffer1,"%d connection Weight ", (int)(i+1));
		DeXInput_Buttons_NMDA[i] =
		  xs_create_dexinput_button(Row_Collumn_NMDA, buffer, buffer1, 200, 2, 0, 0 );
		
	       	XtAddCallback(DeXInput_Buttons_NMDA[i],
			      DeXNokCallback, 
			      (XtPointer)callback_Weight_NMDA, 
			      (XtPointer)i);
	      } 
	    

	  }
	
	/****************************/
	
	/* separateur  */


	n = 0;
	XtSetArg(wargs[n], XmNwidth, 16);n++;
	XtSetArg(wargs[n], XmNheight, 16);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopWidget, frame_NMDA);n++;
	Separator_NMDA_2 = XtCreateManagedWidget("separatorNMDA2",
						 xmSeparatorGadgetClass,
						 Form_NMDA,
						 wargs, n);
	

	/* PushButton de fermeture */
	

	string1 = XmStringCreateSimple("Close");	
	
	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_NMDA_2);n++;
	XtSetArg(wargs[n], XmNleftPosition, 10);n++;
	XtSetArg(wargs[n], XmNrightPosition, 40);n++;
	
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNwidth, 100); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_CENTER); n++;
	Close_NMDA = XtCreateManagedWidget("close_NMDA",
					   xmPushButtonWidgetClass,
					  Form_NMDA,
					   wargs, n);
	XmStringFree(string1);
	
	XtAddCallback(Close_NMDA, XmNactivateCallback, (XtPointer)callback_close_NMDA, NULL);

	
	/* PushButton de l'equation */
	

	string1 = XmStringCreateSimple("Equation");	
	
	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_NMDA_2);n++;
	XtSetArg(wargs[n], XmNleftPosition, 60);n++;
	XtSetArg(wargs[n], XmNrightPosition, 90);n++;
		
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNwidth, 100); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_CENTER); n++;
	Equa_NMDA = XtCreateManagedWidget("equa_NMDA",
					  xmPushButtonWidgetClass,
					  Form_NMDA,
					  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Equa_NMDA, XmNactivateCallback, (XtPointer)callback_Equation_Activ, NULL);
	
	
	XtAddCallback(Top_Level_NMDA, XmNdestroyCallback, fermeture_NMDA, NULL);

	
	XtManageChild(Form_NMDA);
	XtRealizeWidget(Top_Level_NMDA);
	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_NMDA), palette);

	flag_NMDA = set_g_NMDA = 1;
}


/* 
 *  Window for the activation/inactivation parameters and curves
 *  (only for conductance models 
 */

/*--------------------------------------------------------*/
	void fabrique_scrolled_window_activ()
/*--------------------------------------------------------*/
# if 0
			Top_Level_Activ
			       |
		        Scrolled_Window_Activ
                               |
			Widgets DeXInput:
			Label_Vide1
			Label_Vide2
			Label_Vide3
			DeXInput_V_Na
			DeXInput_V_K
			DeXInput_V_Ca
			DeXInput_V_Ia_A
			DeXInput_V_Ia_B
			DeXInput_A_Na
			DeXInput_A_K
			DeXInput_A_Ca
			DeXInput_A_Ia_A
			DeXInput_A_Ia_B
			DeXInput_Pow_Na
			DeXInput_Pow_K
			DeXInput_Pow_Ca
			DeXInput_Pow_Ia_A
			DeXInput_Pow_Ia_B
			DeXInput_Tau_Ca
			DeXInput_Tau_Ia_B
			DeXInput_V_Ic
			DeXInput_A_Ic
			DeXInput_Lambda_Ic
			DeXInput_V_Ih
			DeXInput_A_Ih
			DeXInput_Lambda_Ih
			DeXInput_A_Im
			DeXInput_V_Im
			DeXInput_Lambda_Im
			Close_Activ
# endif
{
	int		n;
	Arg		wargs[30];
	XmString	string1;
	
	if (flag_activ)
	{
	  XtPopup(Top_Level_Activ,XtGrabNone);
	  return;
	} 
	flag_activ = True;
	if (flag_equation)
	{
	  if (Equa_text) XtDestroyWidget(Equa_text);
	  flag_equation = False;
	} /* fin du if */

	/*---------- toplevel pour les potentiels d'equilibre ----------*/


	Top_Level_Activ = XtCreateApplicationShell("topactiv",
						   topLevelShellWidgetClass,
						   wargs,
						   0);
	XtVaSetValues(Top_Level_Activ,
		      XmNtitle, "Activation/Inactivation Parameters",
		      XmNx, 0,
                      XmNy, 0,
                      XmNwidth, 890,
                      XmNheight, 710,
		      NULL);

	/*---- window pour les potentiels d'equilibre ----*/

	n = 0;
        XtSetArg(wargs[n], XmNborderWidth, 1);n++;
        XtSetArg(wargs[n], XmNwidth, 890);n++;
        XtSetArg(wargs[n], XmNheight, 710);n++;
        XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
        XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
        Scrolled_Window_form = XtCreateManagedWidget("scrolledactiv",
						     xmScrolledWindowWidgetClass,
						     Top_Level_Activ,
						     wargs, n);
	
	/*---- scrolledwindow pour les potentiels d'equilibre ----*/
        n = 0;
        XtSetArg(wargs[n], XmNwidth, 886);n++;
        XtSetArg(wargs[n], XmNheight, 700);n++;
        Scrolled_Window_Activ = XtCreateManagedWidget("scrolledactiv",
                                                            xmFormWidgetClass,
                                                            Scrolled_Window_form,
                                                            wargs, n);
	/* Titre du courant */
	string1 = XmStringCreateSimple("Current");	

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 10); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNx, 10); n++;
	XtSetArg(wargs[n], XmNy, 10); n++;
	XtSetArg(wargs[n], XmNwidth, 300); n++;
	XtSetArg(wargs[n], XmNheight, 40); n++;
	XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
	Courant_Choisi = XmCreateLabel(Scrolled_Window_Activ,
			      "courant_choisi",
			      wargs, 
			      n);
	XtManageChild(Courant_Choisi);
	XmStringFree(string1);
    
	string1 = XmStringCreateSimple("Browse the equations");	

	n = 0;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightOffset, 10); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 10); n++;
	XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_CENTER); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNx, 400); n++;
	XtSetArg(wargs[n], XmNy, 10); n++;
	XtSetArg(wargs[n], XmNwidth, 400); n++; 
	XtSetArg(wargs[n], XmNheight, 40); n++;
	Equation_Activ = XmCreatePushButton(Scrolled_Window_Activ,
			       "equation_activ",
			       wargs, 
			       n);
	XtManageChild(Equation_Activ);
	XmStringFree(string1);
	XtAddCallback(Equation_Activ, XmNactivateCallback, (XtPointer)callback_Equation_Activ, NULL);

	n = 0;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 50); n++;
	XtSetArg(wargs[n], XmNheight, 20); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 0); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightOffset, 0); n++;
	Trait_1 = XmCreateSeparator(Scrolled_Window_Activ,
				       "trait_1",
				       wargs, 
				       n);
	XtManageChild(Trait_1);
    
	string1 = XmStringCreateSimple("Activation (m)");	

	n = 0;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNwidth, 200); n++;
	XtSetArg(wargs[n], XmNheight, 30); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 60); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	Label_Activation = XmCreateLabel(Scrolled_Window_Activ,
			       "label_activation",
			       wargs, 
			       n);
	XtManageChild(Label_Activation);
	XmStringFree(string1);


	n = 0;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 180); n++;
	XtSetArg(wargs[n], XmNheight, 20); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 0); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightOffset, 0); n++;
	Trait_2 = XmCreateSeparator(Scrolled_Window_Activ,
				    "trait_2",
				    wargs, 
				    n);
	XtManageChild(Trait_2);


	string1 = XmStringCreateSimple("Inactivation (h)");
	
	n = 0;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 190); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNwidth, 200); n++;
	XtSetArg(wargs[n], XmNheight, 30); n++;
	Label_Inactivation = XmCreateLabel(Scrolled_Window_Activ,
			       "label_inactivation",
			       wargs, 
			       n);
	XtManageChild(Label_Inactivation);
	XmStringFree(string1);

        n = 0;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 310); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 0); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightOffset, 0); n++;
	XtSetArg(wargs[n], XmNheight, 20); n++;
	Trait_3 = XmCreateSeparator(Scrolled_Window_Activ,
				       "trait_3",
				       wargs, 
				       n);
	XtManageChild(Trait_3);
    

	/*---- container pour les widgets d'activation ----*/
	n = 0;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 90); n++;
	XtSetArg(wargs[n], XmNwidth, 840); n++;
	XtSetArg(wargs[n], XmNheight, 100); n++;
	XtSetArg(wargs[n], XmNnumColumns, 1);n++;
	XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL);n++;
	XtSetArg(wargs[n], XmNborderWidth, 0);n++;
	XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNrightOffset, 10); n++;
	Row_Collumn_Activ = XtCreateManagedWidget("rcActiv",
							xmRowColumnWidgetClass,
							Scrolled_Window_Activ,
							wargs, n);

	/*---- widgets DeXInput ----*/


	/* 1 V 1/2 m */
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 1);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0);n++;
	XtSetArg(wargs[n], DeXNvalue, 0);n++;
	XtSetArg(wargs[n], DeXNlabelString, "V 1/2 Activation (m) (E)");n++;
	DeXInput_V_demi = XtCreateManagedWidget("naactV",
						     DeXinputWidgetClass,
						     Row_Collumn_Activ,
						     wargs, n);
	
	/* 2 A  */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 0);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 1);
	XtSetArg(wargs[n-2], DeXNvalue, 0);
	XtSetArg(wargs[n-1], DeXNlabelString, "Coefficient A for m");
	DeXInput_Coef_A = XtCreateManagedWidget("naa",
					      DeXinputWidgetClass,
					      Row_Collumn_Activ,
					      wargs, n);
	
	
	/* 3 Exponent */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 0);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 1);
	XtSetArg(wargs[n-2], DeXNvalue, 0);
	XtSetArg(wargs[n-1], DeXNlabelString, "Exponent for m (p)");
	DeXInput_Power = XtCreateManagedWidget("powna",
					      DeXinputWidgetClass,
					      Row_Collumn_Activ,
					      wargs, n);
	
	/* 4 Tau lambda */

	XtSetArg(wargs[n-4], DeXNdecimalPoint, 0);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 1);
	XtSetArg(wargs[n-2], DeXNvalue, 0);
	XtSetArg(wargs[n-1], XmNlabelString, "Lambda for m");
	DeXInput_Lambda = XtCreateManagedWidget("lambda",
					      DeXinputWidgetClass,
					      Row_Collumn_Activ,
					      wargs, n);

	/*---- container pour les widgets d'inactivation ----*/
	n = 0;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 220); n++;
	XtSetArg(wargs[n], XmNwidth, 840); n++;
	XtSetArg(wargs[n], XmNheight, 100); n++;
	XtSetArg(wargs[n], XmNnumColumns, 1);n++;
	XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL);n++;
	XtSetArg(wargs[n], XmNborderWidth, 0);n++;
	XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNrightOffset, 10); n++;
	Row_Collumn_Inactiv = XtCreateManagedWidget("rcInActic",
							xmRowColumnWidgetClass,
							Scrolled_Window_Activ,
							wargs, n);

	/* 1 V 1/2 m */
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 1);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0);n++;
	XtSetArg(wargs[n], DeXNvalue, 0);n++;
	XtSetArg(wargs[n], DeXNlabelString, "V 1/2 Inactivation (h) (E)");n++;
	DeXInput_V_demi_h = XtCreateManagedWidget("nainactV",
						     DeXinputWidgetClass,
						     Row_Collumn_Inactiv,
						     wargs, n);
	
	/* 2 A  */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 0);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 1);
	XtSetArg(wargs[n-2], DeXNvalue, 0);
	XtSetArg(wargs[n-1], DeXNlabelString, "Coefficient A for h");
	DeXInput_Coef_A_h = XtCreateManagedWidget("naina",
					      DeXinputWidgetClass,
					      Row_Collumn_Inactiv,
					      wargs, n);
	
	
	/* 3 Exponent */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 0);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 1);
	XtSetArg(wargs[n-2], DeXNvalue, 0);
	XtSetArg(wargs[n-1], DeXNlabelString, "Exponent for h (q)");
	DeXInput_Power_h = XtCreateManagedWidget("powinna",
					      DeXinputWidgetClass,
					      Row_Collumn_Inactiv,
					      wargs, n);
	
	/* 4 Tau lambda */

	XtSetArg(wargs[n-4], DeXNdecimalPoint, 0);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 1);
	XtSetArg(wargs[n-2], DeXNvalue, 0);
	XtSetArg(wargs[n-1], XmNlabelString, "Lambda for h");
	DeXInput_Lambda_h = XtCreateManagedWidget("lambdain",
					      DeXinputWidgetClass,
					      Row_Collumn_Inactiv,
					      wargs, n);

	/* Trait_4 */
        n = 0;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 600); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 0); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightOffset, 0); n++;
	XtSetArg(wargs[n], XmNheight, 10); n++;
	Trait_4 = XmCreateSeparator(Scrolled_Window_Activ,
				       "trait_4",
				       wargs, 
				       n);
	XtManageChild(Trait_4);
    
                                                      
	/* PushButton de dessin */
	string1 = XmStringCreateSimple("Print curves");	

	n = 0;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 130); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNtopWidget, Trait_4); n++;
	XtSetArg(wargs[n], XmNtopOffset, 10); n++;

	XtSetArg(wargs[n], XmNleftPosition, 2 );n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;

	XtSetArg(wargs[n], XmNwidth, 180); n++;
	XtSetArg(wargs[n], XmNheight, 30); n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_CENTER); n++;
	Draw_Curves = XmCreatePushButton(Scrolled_Window_Activ,
					 "plot_curves",
					 wargs, 
					 n);
	XtManageChild(Draw_Curves);
	XmStringFree(string1);

	XtAddCallback(Draw_Curves, XmNactivateCallback, (XtPointer)callback_print_M_H_TAU, NULL);
    
	/* PushButton de fermeture */
	string1 = XmStringCreateSimple("Close");	

	n = 0;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightOffset, 130); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNtopWidget, Trait_4); n++;
	XtSetArg(wargs[n], XmNtopOffset, 10); n++;
	XtSetArg(wargs[n], XmNwidth, 180); n++;
	XtSetArg(wargs[n], XmNheight, 30); n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_CENTER); n++;
	Close_Activ = XtCreateManagedWidget("close_Activ",
						  xmPushButtonWidgetClass,
						  Scrolled_Window_Activ,
						  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Close_Activ, XmNactivateCallback, (XtPointer)callback_close_Activ, NULL);



	/* Drawing Area */
	
	n = 0;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftPosition, 0); n++;
	XtSetArg(wargs[n], XmNtopWidget, Trait_3); n++;
	XtSetArg(wargs[n], XmNbottomOffset, 11); n++;
	XtSetArg(wargs[n], XmNrightOffset, 0); n++;
	XtSetArg(wargs[n], XmNheight, 300); n++;
	XtSetArg(wargs[n], XmNbackground,WhitePixel(disp, screen)); n++;
	XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNbottomWidget, Trait_4); n++;
	Drawing_M_H_TAU = XtCreateWidget("drawing_M_H_TAU",
		xmDrawingAreaWidgetClass,
		Scrolled_Window_Activ,
		wargs,
		n);
	XtManageChild(Drawing_M_H_TAU);

	XtManageChild(Scrolled_Window_Activ);
	XtRealizeWidget(Top_Level_Activ);



	XtAddCallback(Drawing_M_H_TAU, XmNresizeCallback, (XtPointer)expose_resize_M_H_TAU, NULL);
	XtAddCallback(Drawing_M_H_TAU, XmNexposeCallback, (XtPointer)expose_resize_M_H_TAU, NULL);


	/* Les valeurs d'activation */

		/*---- widgets DeXInput ----*/

	/*---I Na----*/

	if (set_g_Na)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL )	
	      {
		string1 = XmStringCreateSimple("Na current (Michaelis-Menton model)");	
		XtSetArg(wargs[0], XmNlabelString, string1);
		XtSetValues(Courant_Choisi,wargs, 1);
		XmStringFree(string1);
	      }
	    if (model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )	
	      {
		string1 = XmStringCreateSimple("Na current (Hodgkin-Huxley model)");	
		XtSetArg(wargs[0], XmNlabelString, string1);
		XtSetValues(Courant_Choisi,wargs, 1);
		XmStringFree(string1);
	      }
	    /* Activation I Na */

	    /* 1 V 1/2 Na m */
	    if (model_type==MICHAELIS_MENTON_MODEL )	
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -310);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_Na * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Na Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_Na_A, NULL);
	      }
	    if (model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )	
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -310);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_INa_A * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Na Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_Na_A, NULL);
	      }
	    /* 2 A Na */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 65);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_Na * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Na a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_Na_A, NULL);
	      }
	    if (model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 56);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_INa_A * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Na a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_Na_A, NULL);
	      }
	    /* 3 Exp Na */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 3);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_Na));
		XtSetArg(wargs[3], DeXNlabelString, "Na exponent (p)");
		XtSetValues(DeXInput_Power,wargs,4);
		XtAddCallback(DeXInput_Power, DeXNokCallback, (XtPointer)callback_Pow_Na_A, NULL);
	      }
	    if (model_type==HH_SIMPLE_MODEL)	
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 3);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_INa_A));
		XtSetArg(wargs[3], DeXNlabelString, "Na exponent (p)");
		XtSetValues(DeXInput_Power,wargs,4);
		XtAddCallback(DeXInput_Power, DeXNokCallback, (XtPointer)callback_Pow_Na_A, NULL);
	      }
	    /* 4 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 3);
	    XtSetArg(wargs[2], DeXNvalue, Tau_INa_B);
	    XtSetArg(wargs[3], DeXNlabelString, "Tau Na (A)");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Lambda,wargs,4);
	    XtAddCallback(DeXInput_Lambda, DeXNokCallback, (XtPointer)callback_Tau_Na_A, NULL);

	    /* inactivation I Na */
	    /* 1 V 1/2 Na m */
	    if (model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)		
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -590);
		XtSetArg(wargs[2], DeXNvalue, (int ) (V_INa_B * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Na Inact 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi_h,wargs,4);
		XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_V_Na_B, NULL);
	      }
	    /* 2 A Na */
	    if (model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)		
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, -40);
		XtSetArg(wargs[2], DeXNvalue,(int) (A_INa_B * 1000) );
		XtSetArg(wargs[3], DeXNlabelString, "Na a (B)");
		XtSetValues(DeXInput_Coef_A_h,wargs,4);
		XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_A_Na_B, NULL);
	      }
	    /* 3 Exp Na */
	    if (model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 1);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_INa_B));
		XtSetArg(wargs[3], DeXNlabelString, "Na exponent (p)");
		XtSetValues(DeXInput_Power_h,wargs,4);
		XtAddCallback(DeXInput_Power_h, DeXNokCallback, (XtPointer)callback_Pow_Na_B, NULL);
	      }
	    /* 4 Tau Na */
	    if (model_type==HH_SIMPLE_MODEL ||  model_type==HH_PUMP_MODEL)		
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 1);
		XtSetArg(wargs[2], DeXNvalue, Tau_INa_B);
		XtSetArg(wargs[3], DeXNlabelString, "Tau Na (B)");
		XtSetArg(wargs[4], XmNsensitive,False);
		XtSetValues(DeXInput_Lambda_h,wargs,4);
		XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Tau_Na_B, NULL);
	      }
	  } /* fin du if */
	
	/*---I K----*/
	if (set_g_K)
	  {
	    
	    string1 = XmStringCreateSimple("K current");	
	    XtSetArg(wargs[0], XmNlabelString, string1);
	    XtSetValues(Courant_Choisi,wargs, 1);
	    XmStringFree(string1);
	    
	    
	    /* 5 V 1/2 K W */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -460);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_K * 10));
		XtSetArg(wargs[3], DeXNlabelString, "K Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_K_A, NULL);
	      }
	    if (model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )	
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -460);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_K * 10));
		XtSetArg(wargs[3], DeXNlabelString, "K Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_K_A, NULL);
	      }
	    /* 6 A K */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 55);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_K * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "K a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_K_A, NULL);
	      }
	    if (model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )	
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 55);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_K * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "K a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_K_A, NULL);
	      }
	    /* 7 Exp K */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 4);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_K));
		XtSetArg(wargs[3], DeXNlabelString, "K exponent (p)");
		XtSetValues(DeXInput_Power,wargs,4);
		XtAddCallback(DeXInput_Power, DeXNokCallback, (XtPointer)callback_Pow_K_A, NULL);
	      }
	    if (model_type==HH_SIMPLE_MODEL )
	      {
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 4);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_K));
		XtSetArg(wargs[3], DeXNlabelString, "K exponent (p)");
		XtSetValues(DeXInput_Power,wargs,4);
		XtAddCallback(DeXInput_Power, DeXNokCallback, (XtPointer)callback_Pow_K_A, NULL);
	      }
	    /* 8 Tau lambda_Ik */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 81);
		XtSetArg(wargs[2], DeXNvalue, (int) (lambda_Ik * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Lambda Ik");
		XtSetValues(DeXInput_Lambda,wargs,4);
		XtAddCallback(DeXInput_Lambda, DeXNokCallback, (XtPointer)callback_Lambda_Ik_A, NULL);
	      }
	    if (model_type==HH_SIMPLE_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 60);
		XtSetArg(wargs[2], DeXNvalue, (int) (lambda_Ik * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Lambda Ik");
		XtSetValues(DeXInput_Lambda,wargs,4);
		XtAddCallback(DeXInput_Lambda, DeXNokCallback, (XtPointer)callback_Lambda_Ik_A, NULL);
	      }
	    /* 1 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_V_demi_h,wargs,5);
	    XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 2 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Coef_A_h,wargs,5);
	    XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 3 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power_h,wargs,5);
	    XtAddCallback(DeXInput_Power_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 4 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Lambda_h,wargs,5);
	    XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	  } /* fin du if */
	
	/*---I Ca----*/
	
	if (set_g_Ca)
	  {
	    
	    string1 = XmStringCreateSimple("High Voltage Activated Ca current");	
	    XtSetArg(wargs[0], XmNlabelString, string1);
	    XtSetValues(Courant_Choisi,wargs, 1);
	    XmStringFree(string1);
	    
	    /* 9 V 1/2 Ca HVA W */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -400);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_Ca * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Ca HVA Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_Ca_A, NULL);
	      }
	    /* 10 A Ca */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 200);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_Ca * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Ca HVA a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_Ca_A, NULL);
	      }
	    
	    /* 11 Exp Ca */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 2);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_Ca));
		XtSetArg(wargs[3], DeXNlabelString, "Ca HVA exponent (p)");
		XtSetValues(DeXInput_Power,wargs,4);
		XtAddCallback(DeXInput_Power, DeXNokCallback, (XtPointer)callback_Pow_Ca_A, NULL);
	      }
	    /* 12 Tau Ca */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, 500);
		XtSetArg(wargs[2], DeXNvalue, (int) (Tau_Ca * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Tau Ca HVA (ms)");
		XtSetValues(DeXInput_Lambda,wargs,4);
		XtAddCallback(DeXInput_Lambda, DeXNokCallback, (XtPointer)callback_Tau_Ca_A, NULL);
	      }
	    /* 1 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_V_demi_h,wargs,5);
	    XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 2 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Coef_A_h,wargs,5);
	    XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 3 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power_h,wargs,5);
	    XtAddCallback(DeXInput_Power_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 4 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Lambda_h,wargs,5);
	    XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	  } /* fin du if */
	
	/*---I A----*/
	
	if (set_g_A)
	  {
	    
	    string1 = XmStringCreateSimple("K Ia current");	
	    XtSetArg(wargs[0], XmNlabelString, string1);
	    XtSetValues(Courant_Choisi,wargs, 1);
	    XmStringFree(string1);
	    
	    /*---I a activ----*/
	    
	    /* 13 V 1/2 Ia_A W */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -200);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_Ia_A * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Ia_A Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_Ia_A, NULL);
	      }
	    /* 14 A Ia_A */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 20);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_Ia_A * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Ia_A a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_Ia_A, NULL);
	      }
	    /* 15 Exp Ia_A */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 1);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_Ia_A));
		XtSetArg(wargs[3], DeXNlabelString, "Ia_A exponent (p)");
		XtSetValues(DeXInput_Power,wargs,4);
		XtAddCallback(DeXInput_Power, DeXNokCallback, (XtPointer)callback_Pow_Ia_A, NULL);
	      }
	    /* 16 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Lambda,wargs,5);
	    
	    /*---I a inactiv----*/
	    
	    /* 17 V 1/2 Ia_B W */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -700);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_Ia_B * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Ia_B Inact 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi_h,wargs,4);
		XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_V_Ia_B, NULL);
	      }
	    /* 18 A Ia_B */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     		
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, -100);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_Ia_B * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Ia_B a (A)");
		XtSetValues(DeXInput_Coef_A_h,wargs,4);
		XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_A_Ia_B, NULL);
	      }
	    /* 19 Exp Ia_B */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 1);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_Ia_B));
		XtSetArg(wargs[3], DeXNlabelString, "Ia_B exponent (q)");
		XtSetValues(DeXInput_Power_h,wargs,4);
		XtAddCallback(DeXInput_Power_h, DeXNokCallback, (XtPointer)callback_Pow_Ia_B, NULL);
	      }
	    /* 20 Tau Ia_B */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, 100);
		XtSetArg(wargs[2], DeXNvalue, (int) (Tau_Ia_B * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Tau Ia_B (ms)");
		XtSetValues(DeXInput_Lambda_h,wargs,4);
		XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Tau_Ia_B, NULL);
	      }
	  } /* fin du if */
#ifdef ADD_CURRENT
	
/*--------   To add a current copy, modify and adapt   -------*/
	/*---I New----*/
	
	if (set_g_New)
	  {
	    
	    string1 = XmStringCreateSimple("I New current");	
	    XtSetArg(wargs[0], XmNlabelString, string1);
	    XtSetValues(Courant_Choisi,wargs, 1);
	    XmStringFree(string1);
	    
	    /*---I New activ----*/
	    
	    /* 13 V 1/2 INew_A W */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -200);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_INew_A * 10));
		XtSetArg(wargs[3], DeXNlabelString, "INew_A Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_INew_A, NULL);
	      }
	    /* 14 A INew_A */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 20);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_INew_A * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "INew_A a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_INew_A, NULL);
	      }
	    
	    /* 15 Exp INew_A */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 1);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_INew_A));
		XtSetArg(wargs[3], DeXNlabelString, "INew_A exponent (p)");
		XtSetValues(DeXInput_Power,wargs,4);
		XtAddCallback(DeXInput_Power, DeXNokCallback, (XtPointer)callback_Pow_INew_A, NULL);
	      }
	    /* 16 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Lambda,wargs,5);
	    
	    /*---I New inactiv----*/
	    
	    /* 17 V 1/2 INew_B W */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -700);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_INew_B * 10));
		XtSetArg(wargs[3], DeXNlabelString, "INew_B Inact 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi_h,wargs,4);
		XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_V_INew_B, NULL);
	      }
	    /* 18 A INew_B */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, -100);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_INew_B * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "INew_B a (A)");
		XtSetValues(DeXInput_Coef_A_h,wargs,4);
		XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_A_INew_B, NULL);
	      }
	    
	    /* 19 Exp INew_B */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 1);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_INew_B));
		XtSetArg(wargs[3], DeXNlabelString, "INew_B exponent (q)");
		XtSetValues(DeXInput_Power_h,wargs,4);
		XtAddCallback(DeXInput_Power_h, DeXNokCallback, (XtPointer)callback_Pow_INew_B, NULL);
	      }
	    /* 20 Tau INew_B */
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, 100);
		XtSetArg(wargs[2], DeXNvalue, (int) (Tau_INew_B * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Tau INew_B (ms)");
		XtSetValues(DeXInput_Lambda_h,wargs,4);
		XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Tau_INew_B, NULL);
	      }
	  } /* fin du if */
#endif
	
	
	/*---I C----*/
	
	if (set_g_C)
	  {
	    
	    string1 = XmStringCreateSimple("K Ic current");	
	    XtSetArg(wargs[0], XmNlabelString, string1);
	    XtSetValues(Courant_Choisi,wargs, 1);
	    XmStringFree(string1);
	    
	    /* 21 V 1/2 Ic */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -900);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_Ic * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Ic Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_Ic_A, NULL);
	      }
	    /* 22 A Ic */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 2);
		XtSetArg(wargs[1], DeXNdefaultValue, 5);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_Ic * 100));
		XtSetArg(wargs[3], DeXNlabelString, "Ic a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_Ic_A, NULL);
	      }
	    /* 23 Vide */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 0);
		XtSetArg(wargs[2], DeXNvalue, 0);
		XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
		XtSetArg(wargs[4], XmNsensitive,False);
		XtSetValues(DeXInput_Power,wargs,5);
	      }
	    /* 24 Tau lambda_Ic */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, 50);
		XtSetArg(wargs[2], DeXNvalue, (int) (lambda_Ic * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Lambda Ic");
		XtSetValues(DeXInput_Lambda,wargs,4);
		XtAddCallback(DeXInput_Lambda, DeXNokCallback, (XtPointer)callback_Lambda_Ic_A, NULL);
	      }
	    /* 1 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_V_demi_h,wargs,5);
	    XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 2 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Coef_A_h,wargs,5);
	    XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 3 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power_h,wargs,5);
	    XtAddCallback(DeXInput_Power_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 4 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Lambda_h,wargs,5);
	    XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	  } /* fin du if */
	
	/*---I m----*/
	
	if (set_g_M)
	  {
	    string1 = XmStringCreateSimple("K Im current");	
	    XtSetArg(wargs[0], XmNlabelString, string1);
	    XtSetValues(Courant_Choisi,wargs, 1);
	    XmStringFree(string1);
	    
	    
	    /* 25 V 1/2 Im */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -350);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_Im * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Im Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_Im_A, NULL);
	      }
	    /* 26 A Im */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 2);
		XtSetArg(wargs[1], DeXNdefaultValue, 5);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_Im * 100));
		XtSetArg(wargs[3], DeXNlabelString, "Im a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_Im_A, NULL);
	      }
	    /* 27 Vide */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power,wargs,5);

	    /* 28 Tau lambda_Im */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 4);
		XtSetArg(wargs[1], DeXNdefaultValue, 30);
		XtSetArg(wargs[2], DeXNvalue, (int) (lambda_Im * 10000));
		XtSetArg(wargs[3], DeXNlabelString, "Lambda Im");
		XtSetValues(DeXInput_Lambda,wargs,4);
		XtAddCallback(DeXInput_Lambda, DeXNokCallback, (XtPointer)callback_Lambda_Im_A, NULL);
	      }
	    /* 1 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_V_demi_h,wargs,5);
	    XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 2 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Coef_A_h,wargs,5);
	    XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 3 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power_h,wargs,5);
	    XtAddCallback(DeXInput_Power_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 4 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Lambda_h,wargs,5);
	    XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
		
	  } /* fin du if */

	/*---I nap----*/
	
	if (set_g_Nap)
	  {
	    string1 = XmStringCreateSimple("Persistant Na current");	
	    XtSetArg(wargs[0], XmNlabelString, string1);
	    XtSetValues(Courant_Choisi,wargs, 1);
	    XmStringFree(string1);
	    
	    /* 29 V 1/2 Inap m */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);n++;
		XtSetArg(wargs[1], DeXNdefaultValue, -560);n++;
		XtSetArg(wargs[2], DeXNvalue, (int) (V_Inap * 10));n++;
		XtSetArg(wargs[3], DeXNlabelString, "Na pers Act 1/2 Pot. (mV) (E)");n++;
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_Inap_A, NULL);
	      }
	    /* 30 A Inap */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 70);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_Inap * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Na pers a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_Inap_A, NULL);
	      }
	    /* 31 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power,wargs,5);

	    /* 32 Lambda Inap */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 100);
		XtSetArg(wargs[2], DeXNvalue, (int) (lambda_Inap * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Lambda I Na pers");
		XtSetValues(DeXInput_Lambda,wargs,4);
		XtAddCallback(DeXInput_Lambda, DeXNokCallback, (XtPointer)callback_Lambda_Inap_A, NULL);
	      }
	    /* 1 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_V_demi_h,wargs,5);
	    XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 2 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Coef_A_h,wargs,5);
	    XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 3 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power_h,wargs,5);
	    XtAddCallback(DeXInput_Power_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 4 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Lambda_h,wargs,5);
	    XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	  } /* fin du if */
	
	/*---I Ca LVA ----*/
	
	if (set_g_Cab)
	  {
	    string1 = XmStringCreateSimple("Low Voltage Avtivated Ca current");	
	    XtSetArg(wargs[0], XmNlabelString, string1);
	    XtSetValues(Courant_Choisi,wargs, 1);
	    XmStringFree(string1);
	    
	    /*---I Ca LVA m----*/
	    
	    /* 33 V 1/2 Icab m */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -450);
		XtSetArg(wargs[2], DeXNvalue, (int) (Vm_Icab * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Ca LVA Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_Vm_Icab, NULL);
	      }
	    /* 34 A Icab m */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 100);
		XtSetArg(wargs[2], DeXNvalue, (int) (Am_Icab * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Ca LVA Act a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_Am_Icab, NULL);
	      }
	    /* 35 Exp Icab m */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 0);
		XtSetArg(wargs[1], DeXNdefaultValue, 3);
		XtSetArg(wargs[2], DeXNvalue, (int) (Pow_m_cab));
		XtSetArg(wargs[3], DeXNlabelString, "Ca LVA exponent (p)");
		XtSetValues(DeXInput_Power,wargs,4);
		XtAddCallback(DeXInput_Power, DeXNokCallback, (XtPointer)callback_Pow_m_cab, NULL);
	      }
	    /* 36 Tau Ca LVA m */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, 100);
		XtSetArg(wargs[2], DeXNvalue, (int) (tau_m_cab * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Tau activ Ca LVA (ms)");
		XtSetValues(DeXInput_Lambda,wargs,4);
		XtAddCallback(DeXInput_Lambda, DeXNokCallback, (XtPointer)callback_Tau_m_cab, NULL);
	      }

	    
	    /*---I Ca LVA h----*/
	    
	    
	    /* 37 V 1/2 Icab h */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -700);
		XtSetArg(wargs[2], DeXNvalue, (int) (Vh_Icab * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Ca LVA Inact 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi_h,wargs,4);
		XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_Vh_Icab, NULL);
	      }
	    /* 38 A Icab h */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 3);
		XtSetArg(wargs[1], DeXNdefaultValue, 100);
		XtSetArg(wargs[2], DeXNvalue, (int) (Ah_Icab * 1000));
		XtSetArg(wargs[3], DeXNlabelString, "Ca LVA Inact a (A)");
		XtSetValues(DeXInput_Coef_A_h,wargs,4);
		XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_Ah_Icab, NULL);
	      }
	    /* 39 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power,wargs,5);
	    
	    /* 40 Lambda Icab h */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 4);
		XtSetArg(wargs[1], DeXNdefaultValue, 50);
		XtSetArg(wargs[2], DeXNvalue, (int) (lambda_Icab * 10000));
		XtSetArg(wargs[3], DeXNlabelString, "Lambda I Ca LVA");
		XtSetValues(DeXInput_Lambda_h,wargs,4);
		XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Lambda_h_Icab, NULL);
	      }
	} /* fin du if */

	/*---I h----*/
	
	if (set_g_H)
	  {
	    string1 = XmStringCreateSimple("K Ih current");	
	    XtSetArg(wargs[0], XmNlabelString, string1);
	    XtSetValues(Courant_Choisi,wargs, 1);
	    XmStringFree(string1);
	    
	    /* 41 V 1/2 Ih */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 1);
		XtSetArg(wargs[1], DeXNdefaultValue, -750);
		XtSetArg(wargs[2], DeXNvalue, (int) (V_Ih * 10));
		XtSetArg(wargs[3], DeXNlabelString, "Ih Act 1/2 Pot. (mV) (E)");
		XtSetValues(DeXInput_V_demi,wargs,4);
		XtAddCallback(DeXInput_V_demi, DeXNokCallback, (XtPointer)callback_V_Ih_A, NULL);
	      }
	    /* 42 A Ih */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 2);
		XtSetArg(wargs[1], DeXNdefaultValue, 9);
		XtSetArg(wargs[2], DeXNvalue, (int) (A_Ih * 100));
		XtSetArg(wargs[3], DeXNlabelString, "Ih a (A)");
		XtSetValues(DeXInput_Coef_A,wargs,4);
		XtAddCallback(DeXInput_Coef_A, DeXNokCallback, (XtPointer)callback_A_Ih_A, NULL);
	      }
		
	    /* 27 Vide */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power,wargs,5);
	    
	    /* 29 Tau lambda_Ih */
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {	     
		XtSetArg(wargs[0], DeXNdecimalPoint, 4);
		XtSetArg(wargs[1], DeXNdefaultValue, 5);
		XtSetArg(wargs[2], DeXNvalue, (int) (lambda_Ih * 10000));
		XtSetArg(wargs[3], DeXNlabelString, "Lambda Ih");
		XtSetValues(DeXInput_Lambda,wargs,4);
		XtAddCallback(DeXInput_Lambda, DeXNokCallback, (XtPointer)callback_Lambda_Ih_A, NULL);
	      }
	    /* 1 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_V_demi_h,wargs,5);
	    XtAddCallback(DeXInput_V_demi_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
		
	    /* 2 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Coef_A_h,wargs,5);
	    XtAddCallback(DeXInput_Coef_A_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
		
	    /* 3 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Power_h,wargs,5);
	    XtAddCallback(DeXInput_Power_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	    /* 4 VIDE */
	    XtSetArg(wargs[0], DeXNdecimalPoint, 0);
	    XtSetArg(wargs[1], DeXNdefaultValue, 0);
	    XtSetArg(wargs[2], DeXNvalue, 0);
	    XtSetArg(wargs[3], DeXNlabelString, "Not Applicable");
	    XtSetArg(wargs[4], XmNsensitive,False);
	    XtSetValues(DeXInput_Lambda_h,wargs,5);
	    XtAddCallback(DeXInput_Lambda_h, DeXNokCallback, (XtPointer)callback_Vide, NULL);
	    
	  } /* fin du if */
					     
	
	XtAddCallback(Top_Level_Activ, XmNdestroyCallback, fermeture_Activ, NULL);

	/*---I Na----*/
	
	if (set_g_Na)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_Lambda);
		XtUnmapWidget(DeXInput_V_demi_h);
		XtUnmapWidget(DeXInput_Coef_A_h);
		XtUnmapWidget(DeXInput_Power_h);
		XtUnmapWidget(DeXInput_Lambda_h);
	      }
	    if (model_type==HH_SIMPLE_MODEL)	
	      {
		XtUnmapWidget(DeXInput_Lambda);
	      }
	    if (model_type==HH_PUMP_MODEL)	
	      {
		XtUnmapWidget(DeXInput_Lambda);
	      }
	  } /* fin du if */

	/*---I K----*/
	if (set_g_K)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_V_demi_h);
		XtUnmapWidget(DeXInput_Coef_A_h);
		XtUnmapWidget(DeXInput_Power_h);
		XtUnmapWidget(DeXInput_Lambda_h);
	      }
	    if (model_type==HH_SIMPLE_MODEL)	
	      {
		XtUnmapWidget(DeXInput_V_demi_h);
		XtUnmapWidget(DeXInput_Coef_A_h);
		XtUnmapWidget(DeXInput_Power_h);
		XtUnmapWidget(DeXInput_Lambda_h);
	      }
	    if (model_type==HH_PUMP_MODEL)	
	      {
		XtUnmapWidget(DeXInput_V_demi_h);
		XtUnmapWidget(DeXInput_Coef_A_h);
		XtUnmapWidget(DeXInput_Power_h);
		XtUnmapWidget(DeXInput_Lambda_h);
		XtUnmapWidget(DeXInput_Power);
		XtUnmapWidget(DeXInput_Lambda);
	      }
	  }
	
	/*---I Ca----*/
	
	if (set_g_Ca)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_V_demi_h);
		XtUnmapWidget(DeXInput_Coef_A_h);
		XtUnmapWidget(DeXInput_Power_h);
		XtUnmapWidget(DeXInput_Lambda_h);
	      }
	  }
	
	/*---I A----*/
	
	if (set_g_A)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_Lambda);
	      }
	  }

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
/*- Unmap here all not applicable widget -all "Vide" (empty) DeXInput- */
	/*---I New----*/
	
	if (set_g_New)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_Lambda);
	      }
	    if (model_type==HH_SIMPLE_MODEL)	
	      {
		
	      }
	    if (model_type==HH_PUMP_MODEL)	
	      {
		
	      }
	  }
#endif

	/*---I C----*/
	
	if (set_g_C)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_Power);
		XtUnmapWidget(DeXInput_V_demi_h);
		XtUnmapWidget(DeXInput_Coef_A_h);
		XtUnmapWidget(DeXInput_Power_h);
		XtUnmapWidget(DeXInput_Lambda_h);
	      }
	  }
	/*---I m----*/
	
	if (set_g_M)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_Power);
		XtUnmapWidget(DeXInput_V_demi_h);
		XtUnmapWidget(DeXInput_Coef_A_h);
		XtUnmapWidget(DeXInput_Power_h);
		XtUnmapWidget(DeXInput_Lambda_h);
	      }
	  }
	/*---I nap----*/
	
	if (set_g_Nap)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_Power);
		XtUnmapWidget(DeXInput_V_demi_h);
		XtUnmapWidget(DeXInput_Coef_A_h);
		XtUnmapWidget(DeXInput_Power_h);
		XtUnmapWidget(DeXInput_Lambda_h);
	      }
	  }
	/*---I Ca LVA ----*/
	
	if (set_g_Cab)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_Power);
	      }
	  }
	/*---I h----*/
	
	if (set_g_H)
	  {
	    if (model_type==MICHAELIS_MENTON_MODEL || 
		model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL)	
	      {		 
		XtUnmapWidget(DeXInput_Power);
		XtUnmapWidget(DeXInput_V_demi_h);
		XtUnmapWidget(DeXInput_Coef_A_h);
		XtUnmapWidget(DeXInput_Power_h);
		XtUnmapWidget(DeXInput_Lambda_h);
	      }
	  }


	if (colormap)
	  XSetWindowColormap(disp, XtWindow(Top_Level_Activ), palette);
}










