/*
*
*	A S K V A L . H
*
*	Corresponds to askval.c V2.2
*	Header to include to each program  calling the
*	/usr/local/lib/libaskval.a library
*
*	Entete pour askval.c V2.0 a inclure dans tous les programmes
*	faisant appel a la librairie libaskval.ar
*
*	programs to compile with the option -laskval
*
*	programmes a compiler avec l'option -laskval
*
*	askval.c - Prompt for a number, char or string with default value
*
*	Date:	29-Aout-89
*
*	Auteur: Dr J-F VIBERT
*		Laboratoire de Physiologie
*		CHU Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is in any way usable for commercial purpose.
*
*/

#define NB_HIST	10
#define ask_tirets(ok)	(ask_traits=ok)

extern	char	*ask_i_previous[NB_HIST],	/* Les chaines i d'avant */
		*ask_f_previous[NB_HIST],	/* Les chaines f d'avant */
		*ask_s_previous[NB_HIST],	/* Les chaines s d'avant */
		with_help[20],			/* la chaine d'help par defaut */
		no_help[15],			/* la chaine no help */
		bad_val[30];			/*
						 * la chaine de mauvaise
						 * valeur par defaut
						 */
extern	int	ask_i_min,	/* le domaine des int */
		ask_i_max;	

extern	float	ask_f_min,	/* le domaine des float */
		ask_f_max;	

extern	int	nb_i_hist,	/* le nb de chaines i memorisees */
		nb_f_hist,	/* le nb de chaines f memorisees */
		nb_s_hist,	/* le nb de chaines s memorisees */
		p_i_stack,	/* et leurs "pointeurs" */
		p_f_stack,
		p_s_stack;

extern	int	ask_traits;		/* faut-il ou non des tirets	*/
					/* les fonctions		*/
extern	int	askival(), askivalh(), askivalf(), faskival(),
		asksval(), asksvalh(), asksvalf(), fasksval();
extern	float	askfval(), askfvalh(), askfvalf(), faskfval();
extern	char	askcval(), askcvalh(), askcvalf(), faskcval();

extern	void	askvalfree();

extern	FILE	*std_ask;		/* The default output */
