/*
 * NE PAS DITER CE FICHIER - il est gnr par Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config_xnbc.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "cp_callbacks.h"
#include "cp_interface.h"
#include "support.h"
#include "MENU_constante.h"

GtkWidget*
create_main_window (void)
{
  GtkWidget *main_window;
  GtkWidget *fixed1;
  GtkWidget *menubar1;
  guint tmp_key;
  GtkWidget *experiment1;
  GtkWidget *experiment1_menu;
  GtkAccelGroup *experiment1_menu_accels;
  GtkWidget *current2;
  GtkWidget *_New;
  GtkWidget *open1;
  GtkWidget *recent_experiments1;
  GtkWidget *quit1;
  GtkWidget *graphics1;
  GtkWidget *graphics1_menu;
  GtkAccelGroup *graphics1_menu_accels;
  GtkWidget *global_activity_print1;
  GtkWidget *global_activity_view1;
  GtkWidget *intracellular_recording1;
  GtkWidget *membrane_potential_3d1;
  GtkWidget *view_postscript_files1;
  GtkWidget *gnuplot1;
  GtkWidget *raster_viewer1;
  GtkWidget *options1;
  GtkWidget *options1_menu;
  GtkAccelGroup *options1_menu_accels;
  GtkWidget *printer_to_use1;
  GtkWidget *keep_postscript_files1;
  GtkWidget *verbose_mode1;
  GtkWidget *help1;
  GtkWidget *help1_menu;
  GtkAccelGroup *help1_menu_accels;
  GtkWidget *on_control_panel1;
  GtkWidget *about_xnbc1;
  GtkWidget *Manual;
  GtkWidget *P_neuron;
  GtkWidget *V_neuron;
  GtkWidget *Drug_editor;
  GtkWidget *G_neuron;
  GtkWidget *Link_edit;
  GtkWidget *Full_edit;
  GtkWidget *Simulator;
  GtkWidget *Visu;
  GtkWidget *Xtms;
  GtkWidget *Xcaa;
  GtkWidget *spanake;
  GtkWidget *arrow1;
  GtkWidget *arrow2;
  GtkWidget *arrow3;
  GtkWidget *arrow4;
  GtkWidget *pix_neurone;
  GtkWidget *label_version;
  GtkWidget *pix_visu;
  GtkWidget *pix_drugs;
  GtkWidget *pix_network;
  GtkWidget *pix_label;
  GtkWidget *pix_results;
  GtkWidget *pix_souris;
  GtkWidget *pix_logo;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (main_window), "main_window", main_window);
  gtk_tooltips_set_tip (tooltips, main_window, _("XNBC Control panel"), NULL);
  gtk_window_set_title (GTK_WINDOW (main_window), _("XNBC Control Panel"));
  gtk_window_set_position (GTK_WINDOW (main_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (main_window), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (main_window), 744, 400);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (main_window), fixed1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar1);
  gtk_fixed_put (GTK_FIXED (fixed1), menubar1, 0, 0);
  gtk_widget_set_uposition (menubar1, 0, 0);
  gtk_widget_set_usize (menubar1, 744, 24);

  experiment1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (experiment1)->child),
                                   _("_Experiment"));
  gtk_widget_add_accelerator (experiment1, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_ref (experiment1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "experiment1", experiment1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (experiment1);
  gtk_container_add (GTK_CONTAINER (menubar1), experiment1);
  gtk_tooltips_set_tip (tooltips, experiment1, _("Choose your experiment..."), NULL);

  experiment1_menu = gtk_menu_new ();
  gtk_widget_ref (experiment1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "experiment1_menu", experiment1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (experiment1), experiment1_menu);
  experiment1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (experiment1_menu));

  current2 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (current2)->child),
                                   _("_Current"));
  gtk_widget_add_accelerator (current2, "activate_item", experiment1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (current2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "current2", current2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (current2);
  gtk_container_add (GTK_CONTAINER (experiment1_menu), current2);
  gtk_tooltips_set_tip (tooltips, current2, _("Displays the current experiment directory and main files"), NULL);

  _New = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (_New)->child),
                                   _("_New"));
  gtk_widget_add_accelerator (_New, "activate_item", experiment1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (_New);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "_New", _New,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (_New);
  gtk_container_add (GTK_CONTAINER (experiment1_menu), _New);
  gtk_tooltips_set_tip (tooltips, _New, _("Gives a new experiment name to begin a new experiment"), NULL);

  open1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (open1)->child),
                                   _("_Open"));
  gtk_widget_add_accelerator (open1, "activate_item", experiment1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (open1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "open1", open1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (open1);
  gtk_container_add (GTK_CONTAINER (experiment1_menu), open1);
  gtk_tooltips_set_tip (tooltips, open1, _("Open an existing experiment"), NULL);

  recent_experiments1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (recent_experiments1)->child),
                                   _("_Recent experiments"));
  gtk_widget_add_accelerator (recent_experiments1, "activate_item", experiment1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (recent_experiments1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "recent_experiments1", recent_experiments1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (recent_experiments1);
  gtk_container_add (GTK_CONTAINER (experiment1_menu), recent_experiments1);
  gtk_tooltips_set_tip (tooltips, recent_experiments1, _("Select one of your recent experiments"), NULL);

  quit1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (quit1)->child),
                                   _("_Quit"));
  gtk_widget_add_accelerator (quit1, "activate_item", experiment1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (quit1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "quit1", quit1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (quit1);
  gtk_container_add (GTK_CONTAINER (experiment1_menu), quit1);
  gtk_tooltips_set_tip (tooltips, quit1, _("Quit XNBC"), NULL);

  graphics1 = gtk_menu_item_new_with_label (_("Graphics"));
  gtk_widget_ref (graphics1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "graphics1", graphics1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (graphics1);
  gtk_container_add (GTK_CONTAINER (menubar1), graphics1);
  gtk_tooltips_set_tip (tooltips, graphics1, _("Tools to produce or display figures"), NULL);

  graphics1_menu = gtk_menu_new ();
  gtk_widget_ref (graphics1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "graphics1_menu", graphics1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (graphics1), graphics1_menu);
  graphics1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (graphics1_menu));

  global_activity_print1 = gtk_menu_item_new_with_label (_("Global activity (print)"));
  gtk_widget_ref (global_activity_print1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "global_activity_print1", global_activity_print1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (global_activity_print1);
  gtk_container_add (GTK_CONTAINER (graphics1_menu), global_activity_print1);
  gtk_tooltips_set_tip (tooltips, global_activity_print1, _("Produce PS file of cluster global activity"), NULL);

  global_activity_view1 = gtk_menu_item_new_with_label (_("Global activity (view/print)"));
  gtk_widget_ref (global_activity_view1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "global_activity_view1", global_activity_view1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (global_activity_view1);
  gtk_container_add (GTK_CONTAINER (graphics1_menu), global_activity_view1);
  gtk_tooltips_set_tip (tooltips, global_activity_view1, _("View (and print) the clusters global activity"), NULL);

  intracellular_recording1 = gtk_menu_item_new_with_label (_("Intracellular recording"));
  gtk_widget_ref (intracellular_recording1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "intracellular_recording1", intracellular_recording1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (intracellular_recording1);
  gtk_container_add (GTK_CONTAINER (graphics1_menu), intracellular_recording1);
  gtk_tooltips_set_tip (tooltips, intracellular_recording1, _("Ouput of intracellular recordind of selected neurons"), NULL);

  membrane_potential_3d1 = gtk_menu_item_new_with_label (_("Membrane potential (3D)"));
  gtk_widget_ref (membrane_potential_3d1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "membrane_potential_3d1", membrane_potential_3d1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (membrane_potential_3d1);
  gtk_container_add (GTK_CONTAINER (graphics1_menu), membrane_potential_3d1);
  gtk_tooltips_set_tip (tooltips, membrane_potential_3d1, _("3D representation of mebrane potentials"), NULL);

  view_postscript_files1 = gtk_menu_item_new_with_label (_("View PostScript files"));
  gtk_widget_ref (view_postscript_files1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "view_postscript_files1", view_postscript_files1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (view_postscript_files1);
  gtk_container_add (GTK_CONTAINER (graphics1_menu), view_postscript_files1);
  gtk_tooltips_set_tip (tooltips, view_postscript_files1, _("Visualization of PostScript files"), NULL);

  gnuplot1 = gtk_menu_item_new_with_label (_("Gnuplot"));
  gtk_widget_ref (gnuplot1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "gnuplot1", gnuplot1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (gnuplot1);
  gtk_container_add (GTK_CONTAINER (graphics1_menu), gnuplot1);
  gtk_tooltips_set_tip (tooltips, gnuplot1, _("Visualization of Gnuplot files (*.gpl)"), NULL);

  raster_viewer1 = gtk_menu_item_new_with_label (_("Raster Viewer"));
  gtk_widget_ref (raster_viewer1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "raster_viewer1", raster_viewer1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (raster_viewer1);
  gtk_container_add (GTK_CONTAINER (graphics1_menu), raster_viewer1);
  gtk_tooltips_set_tip (tooltips, raster_viewer1, _("Raster Viewer annalysis tool"), NULL);

  options1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (options1)->child),
                                   _("_Options"));
  gtk_widget_add_accelerator (options1, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_ref (options1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "options1", options1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (options1);
  gtk_container_add (GTK_CONTAINER (menubar1), options1);
  gtk_tooltips_set_tip (tooltips, options1, _("General option selections"), NULL);

  options1_menu = gtk_menu_new ();
  gtk_widget_ref (options1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "options1_menu", options1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (options1), options1_menu);
  options1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (options1_menu));

  printer_to_use1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (printer_to_use1)->child),
                                   _("_Printer to use"));
  gtk_widget_add_accelerator (printer_to_use1, "activate_item", options1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (printer_to_use1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "printer_to_use1", printer_to_use1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (printer_to_use1);
  gtk_container_add (GTK_CONTAINER (options1_menu), printer_to_use1);
  gtk_tooltips_set_tip (tooltips, printer_to_use1, _("Give the command line to print on your system and printer"), NULL);

  keep_postscript_files1 = gtk_check_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (keep_postscript_files1)->child),
                                   _("_Keep PostScript files"));
  gtk_widget_add_accelerator (keep_postscript_files1, "activate_item", options1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (keep_postscript_files1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "keep_postscript_files1", keep_postscript_files1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (keep_postscript_files1);
  gtk_container_add (GTK_CONTAINER (options1_menu), keep_postscript_files1);
  gtk_tooltips_set_tip (tooltips, keep_postscript_files1, _("Keep PostScript files created by the graphic applications"), NULL);
  gtk_check_menu_item_set_show_toggle (GTK_CHECK_MENU_ITEM (keep_postscript_files1), TRUE);

  verbose_mode1 = gtk_check_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (verbose_mode1)->child),
                                   _("_Verbose mode"));
  gtk_widget_add_accelerator (verbose_mode1, "activate_item", options1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (verbose_mode1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "verbose_mode1", verbose_mode1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (verbose_mode1);
  gtk_container_add (GTK_CONTAINER (options1_menu), verbose_mode1);
  gtk_tooltips_set_tip (tooltips, verbose_mode1, _("Run the different application in verbose mode (XNBC must be run from an xterm)"), NULL);
  gtk_check_menu_item_set_show_toggle (GTK_CHECK_MENU_ITEM (verbose_mode1), TRUE);

  help1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (help1)->child),
                                   _("_Help"));
  gtk_widget_add_accelerator (help1, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_ref (help1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help1", help1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (help1);
  gtk_container_add (GTK_CONTAINER (menubar1), help1);
  gtk_tooltips_set_tip (tooltips, help1, _("Help about XNBC"), NULL);

  help1_menu = gtk_menu_new ();
  gtk_widget_ref (help1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help1_menu", help1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (help1), help1_menu);
  help1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (help1_menu));

  on_control_panel1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (on_control_panel1)->child),
                                   _("_On control panel"));
  gtk_widget_add_accelerator (on_control_panel1, "activate_item", help1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (on_control_panel1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "on_control_panel1", on_control_panel1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (on_control_panel1);
  gtk_container_add (GTK_CONTAINER (help1_menu), on_control_panel1);
  gtk_tooltips_set_tip (tooltips, on_control_panel1, _("Browse the XNBC Control Panel manual"), NULL);

  about_xnbc1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (about_xnbc1)->child),
                                   _("_About XNBC"));
  gtk_widget_add_accelerator (about_xnbc1, "activate_item", help1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (about_xnbc1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "about_xnbc1", about_xnbc1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about_xnbc1);
  gtk_container_add (GTK_CONTAINER (help1_menu), about_xnbc1);
  gtk_tooltips_set_tip (tooltips, about_xnbc1, _("About XNBC panel"), NULL);

  Manual = gtk_toggle_button_new_with_label (_("Browse the full manual"));
  gtk_widget_ref (Manual);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "Manual", Manual,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Manual);
  gtk_fixed_put (GTK_FIXED (fixed1), Manual, 16, 32);
  gtk_widget_set_uposition (Manual, 16, 32);
  gtk_widget_set_usize (Manual, 168, 32);
  gtk_tooltips_set_tip (tooltips, Manual, _("Call your browser to read the XNBC manual"), NULL);

  P_neuron = gtk_button_new_with_label (_("Simple\nNeuron\nEditor"));
  gtk_widget_ref (P_neuron);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "P_neuron", P_neuron,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (P_neuron);
  gtk_fixed_put (GTK_FIXED (fixed1), P_neuron, 16, 112);
  gtk_widget_set_uposition (P_neuron, 16, 112);
  gtk_widget_set_usize (P_neuron, 120, 64);
  gtk_tooltips_set_tip (tooltips, P_neuron, _("Launch the simple neuron editor (Phenomenologic neuron)"), NULL);

  V_neuron = gtk_button_new_with_label (_("Virtual\nNeurons\nBrowser"));
  gtk_widget_ref (V_neuron);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "V_neuron", V_neuron,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (V_neuron);
  gtk_fixed_put (GTK_FIXED (fixed1), V_neuron, 16, 272);
  gtk_widget_set_uposition (V_neuron, 16, 272);
  gtk_widget_set_usize (V_neuron, 120, 64);
  gtk_tooltips_set_tip (tooltips, V_neuron, _("Displays the *.tms files available to act as virtual neurons"), NULL);

  Drug_editor = gtk_button_new_with_label (_("Drug\nEditor"));
  gtk_widget_ref (Drug_editor);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "Drug_editor", Drug_editor,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Drug_editor);
  gtk_fixed_put (GTK_FIXED (fixed1), Drug_editor, 328, 56);
  gtk_widget_set_uposition (Drug_editor, 328, 56);
  gtk_widget_set_usize (Drug_editor, 120, 48);
  gtk_tooltips_set_tip (tooltips, Drug_editor, _("Launch the drug editor"), NULL);

  G_neuron = gtk_button_new_with_label (_("Full featured\nNeuron\nEditor"));
  gtk_widget_ref (G_neuron);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "G_neuron", G_neuron,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (G_neuron);
  gtk_fixed_put (GTK_FIXED (fixed1), G_neuron, 16, 192);
  gtk_widget_set_uposition (G_neuron, 16, 192);
  gtk_widget_set_usize (G_neuron, 120, 64);
  gtk_tooltips_set_tip (tooltips, G_neuron, _("Launch the full featured neuron editor in Conductance mode"), NULL);

  Link_edit = gtk_button_new_with_label (_("Simple\nNetwork\nEditor"));
  gtk_widget_ref (Link_edit);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "Link_edit", Link_edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Link_edit);
  gtk_fixed_put (GTK_FIXED (fixed1), Link_edit, 168, 144);
  gtk_widget_set_uposition (Link_edit, 168, 144);
  gtk_widget_set_usize (Link_edit, 120, 64);
  gtk_tooltips_set_tip (tooltips, Link_edit, _("Launch the simple network editor"), NULL);

  Full_edit = gtk_button_new_with_label (_("Full featured\nNetwork\nEditor"));
  gtk_widget_ref (Full_edit);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "Full_edit", Full_edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Full_edit);
  gtk_fixed_put (GTK_FIXED (fixed1), Full_edit, 168, 232);
  gtk_widget_set_uposition (Full_edit, 168, 232);
  gtk_widget_set_usize (Full_edit, 120, 64);
  gtk_tooltips_set_tip (tooltips, Full_edit, _("Launch the full featured network editor"), NULL);

  Simulator = gtk_button_new_with_label (_("Simulator"));
  gtk_widget_ref (Simulator);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "Simulator", Simulator,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Simulator);
  gtk_fixed_put (GTK_FIXED (fixed1), Simulator, 328, 184);
  gtk_widget_set_uposition (Simulator, 328, 184);
  gtk_widget_set_usize (Simulator, 120, 64);
  gtk_tooltips_set_tip (tooltips, Simulator, _("Launch the simulator"), NULL);

  Visu = gtk_button_new_with_label (_("Visualization"));
  gtk_widget_ref (Visu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "Visu", Visu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Visu);
  gtk_fixed_put (GTK_FIXED (fixed1), Visu, 576, 56);
  gtk_widget_set_uposition (Visu, 576, 56);
  gtk_widget_set_usize (Visu, 120, 64);
  gtk_tooltips_set_tip (tooltips, Visu, _("Launch the visualization tool"), NULL);

  Xtms = gtk_button_new_with_label (_("Time series\nAnalysis"));
  gtk_widget_ref (Xtms);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "Xtms", Xtms,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Xtms);
  gtk_fixed_put (GTK_FIXED (fixed1), Xtms, 576, 128);
  gtk_widget_set_uposition (Xtms, 576, 128);
  gtk_widget_set_usize (Xtms, 120, 64);
  gtk_tooltips_set_tip (tooltips, Xtms, _("To make time series analysis on unit spike trains"), NULL);

  Xcaa = gtk_button_new_with_label (_("Cluster activity\nAnalysis"));
  gtk_widget_ref (Xcaa);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "Xcaa", Xcaa,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Xcaa);
  gtk_fixed_put (GTK_FIXED (fixed1), Xcaa, 576, 200);
  gtk_widget_set_uposition (Xcaa, 576, 200);
  gtk_widget_set_usize (Xcaa, 120, 64);
  gtk_tooltips_set_tip (tooltips, Xcaa, _("To analyze the network or cluster activity"), NULL);

  spanake = gtk_button_new_with_label (_("Raster viewer\nAnalysis"));
  gtk_widget_ref (spanake);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "spanake", spanake,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spanake);
  gtk_fixed_put (GTK_FIXED (fixed1), spanake, 576, 272);
  gtk_widget_set_uposition (spanake, 576, 272);
  gtk_widget_set_usize (spanake, 120, 64);
  gtk_tooltips_set_tip (tooltips, spanake, _("To draw dot display of unit spike trains"), NULL);

  arrow1 = gtk_arrow_new (GTK_ARROW_DOWN, GTK_SHADOW_OUT);
  gtk_widget_ref (arrow1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "arrow1", arrow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (arrow1);
  gtk_fixed_put (GTK_FIXED (fixed1), arrow1, 384, 112);
  gtk_widget_set_uposition (arrow1, 384, 112);
  gtk_widget_set_usize (arrow1, 16, 72);

  arrow2 = gtk_arrow_new (GTK_ARROW_RIGHT, GTK_SHADOW_OUT);
  gtk_widget_ref (arrow2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "arrow2", arrow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (arrow2);
  gtk_fixed_put (GTK_FIXED (fixed1), arrow2, 144, 216);
  gtk_widget_set_uposition (arrow2, 144, 216);
  gtk_widget_set_usize (arrow2, 16, 16);

  arrow3 = gtk_arrow_new (GTK_ARROW_RIGHT, GTK_SHADOW_OUT);
  gtk_widget_ref (arrow3);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "arrow3", arrow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (arrow3);
  gtk_fixed_put (GTK_FIXED (fixed1), arrow3, 288, 216);
  gtk_widget_set_uposition (arrow3, 288, 216);
  gtk_widget_set_usize (arrow3, 16, 16);

  arrow4 = gtk_arrow_new (GTK_ARROW_RIGHT, GTK_SHADOW_OUT);
  gtk_widget_ref (arrow4);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "arrow4", arrow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (arrow4);
  gtk_fixed_put (GTK_FIXED (fixed1), arrow4, 456, 216);
  gtk_widget_set_uposition (arrow4, 456, 216);
  gtk_widget_set_usize (arrow4, 24, 16);

  pix_neurone = create_pixmap (main_window, "neurone.xpm");
  gtk_widget_ref (pix_neurone);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "pix_neurone", pix_neurone,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_neurone);
  gtk_fixed_put (GTK_FIXED (fixed1), pix_neurone, 24, 64);
  gtk_widget_set_uposition (pix_neurone, 24, 64);
  gtk_widget_set_usize (pix_neurone, 96, 48);

  label_version = gtk_label_new (_(VERSION));
  gtk_widget_ref (label_version);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label_version", label_version,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_version);
  gtk_fixed_put (GTK_FIXED (fixed1), label_version, 344, 336);
  gtk_widget_set_uposition (label_version, 344, 336);
  gtk_widget_set_usize (label_version, 104, 24);
  gtk_widget_set_sensitive (label_version, FALSE);

  pix_visu = create_pixmap (main_window, "visu.xpm");
  gtk_widget_ref (pix_visu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "pix_visu", pix_visu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_visu);
  gtk_fixed_put (GTK_FIXED (fixed1), pix_visu, 648, 32);
  gtk_widget_set_uposition (pix_visu, 648, 32);
  gtk_widget_set_usize (pix_visu, 88, 184);

  pix_drugs = create_pixmap (main_window, "drugs.xpm");
  gtk_widget_ref (pix_drugs);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "pix_drugs", pix_drugs,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_drugs);
  gtk_fixed_put (GTK_FIXED (fixed1), pix_drugs, 448, 24);
  gtk_widget_set_uposition (pix_drugs, 448, 24);
  gtk_widget_set_usize (pix_drugs, 72, 104);

  pix_network = create_pixmap (main_window, "reseau2.xpm");
  gtk_widget_ref (pix_network);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "pix_network", pix_network,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_network);
  gtk_fixed_put (GTK_FIXED (fixed1), pix_network, 168, 72);
  gtk_widget_set_uposition (pix_network, 168, 72);
  gtk_widget_set_usize (pix_network, 112, 64);

  pix_label = create_pixmap (main_window, "label_xnbc.xpm");
  gtk_widget_ref (pix_label);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "pix_label", pix_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_label);
  gtk_fixed_put (GTK_FIXED (fixed1), pix_label, 240, 248);
  gtk_widget_set_uposition (pix_label, 240, 248);
  gtk_widget_set_usize (pix_label, 312, 89);

  pix_results = create_pixmap (main_window, "results.xpm");
  gtk_widget_ref (pix_results);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "pix_results", pix_results,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_results);
  gtk_fixed_put (GTK_FIXED (fixed1), pix_results, 472, 144);
  gtk_widget_set_uposition (pix_results, 472, 144);
  gtk_widget_set_usize (pix_results, 96, 112);

  pix_souris = create_pixmap (main_window, "souris.xpm");
  gtk_widget_ref (pix_souris);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "pix_souris", pix_souris,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_souris);
  gtk_fixed_put (GTK_FIXED (fixed1), pix_souris, 112, 288);
  gtk_widget_set_uposition (pix_souris, 112, 288);
  gtk_widget_set_usize (pix_souris, 128, 80);

  pix_logo = create_pixmap (main_window, "logo_xnbc9s.xpm");
  gtk_widget_ref (pix_logo);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "pix_logo", pix_logo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_logo);
  gtk_fixed_put (GTK_FIXED (fixed1), pix_logo, 0, 344);
  gtk_widget_set_uposition (pix_logo, 0, 344);
  gtk_widget_set_usize (pix_logo, 736, 104);

  gtk_signal_connect (GTK_OBJECT (current2), "activate",
                      GTK_SIGNAL_FUNC (on_current2_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (_New), "activate",
                      GTK_SIGNAL_FUNC (on_new_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (open1), "activate",
                      GTK_SIGNAL_FUNC (on_open1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (recent_experiments1), "activate",
                      GTK_SIGNAL_FUNC (on_recent_experiments1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (quit1), "activate",
                      GTK_SIGNAL_FUNC (on_quit1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (global_activity_print1), "activate",
                      GTK_SIGNAL_FUNC (on_global_activity_print1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (global_activity_view1), "activate",
                      GTK_SIGNAL_FUNC (on_global_activity_view1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (intracellular_recording1), "activate",
                      GTK_SIGNAL_FUNC (on_intracellular_recording1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (membrane_potential_3d1), "activate",
                      GTK_SIGNAL_FUNC (on_membrane_potential_3d1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (view_postscript_files1), "activate",
                      GTK_SIGNAL_FUNC (on_view_postscript_files1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (gnuplot1), "activate",
                      GTK_SIGNAL_FUNC (on_gnuplot1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (raster_viewer1), "activate",
                      GTK_SIGNAL_FUNC (on_raster_viewer1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (printer_to_use1), "activate",
                      GTK_SIGNAL_FUNC (on_printer_to_use1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (keep_postscript_files1), "activate",
                      GTK_SIGNAL_FUNC (on_keep_postscript_files1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (verbose_mode1), "activate",
                      GTK_SIGNAL_FUNC (on_verbose_mode1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (on_control_panel1), "activate",
                      GTK_SIGNAL_FUNC (on_on_control_panel1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (about_xnbc1), "activate",
                      GTK_SIGNAL_FUNC (on_about_xnbc1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Manual), "clicked",
                      GTK_SIGNAL_FUNC (on_manual_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (P_neuron), "clicked",
                      GTK_SIGNAL_FUNC (on_P_neuron_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (V_neuron), "clicked",
                      GTK_SIGNAL_FUNC (on_V_neuron_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Drug_editor), "clicked",
                      GTK_SIGNAL_FUNC (on_Drug_edit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (G_neuron), "clicked",
                      GTK_SIGNAL_FUNC (on_G_neuron_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Link_edit), "clicked",
                      GTK_SIGNAL_FUNC (on_link_edit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Full_edit), "clicked",
                      GTK_SIGNAL_FUNC (on_full_edit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Simulator), "clicked",
                      GTK_SIGNAL_FUNC (on_simulator_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Visu), "clicked",
                      GTK_SIGNAL_FUNC (on_visu_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Xtms), "clicked",
                      GTK_SIGNAL_FUNC (on_xtms_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Xcaa), "clicked",
                      GTK_SIGNAL_FUNC (on_xcaa_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (spanake), "clicked",
                      GTK_SIGNAL_FUNC (on_spanake_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (main_window), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (main_window), accel_group);

  return main_window;
}

GtkWidget*
create_about_window (void)
{
  GtkWidget *about_window;
  GtkWidget *dialog_vbox1;
  GtkWidget *fixed3;
  GtkWidget *pixmap3;
  GtkWidget *label2;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbuttonbox1;
  GtkWidget *close_dialog1;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  about_window = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (about_window), "about_window", about_window);
  gtk_container_set_border_width (GTK_CONTAINER (about_window), 2);
  gtk_tooltips_set_tip (tooltips, about_window, _("XNBC Control panel authors"), NULL);
  gtk_window_set_title (GTK_WINDOW (about_window), _("About XNBC V9"));
  GTK_WINDOW (about_window)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (about_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (about_window), TRUE);
  gtk_window_set_policy (GTK_WINDOW (about_window), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (about_window)->vbox;
  gtk_object_set_data (GTK_OBJECT (about_window), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  fixed3 = gtk_fixed_new ();
  gtk_widget_ref (fixed3);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "fixed3", fixed3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed3);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), fixed3, TRUE, TRUE, 0);

  pixmap3 = create_pixmap (about_window, "logo_small.xpm");
  gtk_widget_ref (pixmap3);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "pixmap3", pixmap3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap3);
  gtk_fixed_put (GTK_FIXED (fixed3), pixmap3, 144, 24);
  gtk_widget_set_uposition (pixmap3, 144, 24);
  gtk_widget_set_usize (pixmap3, 21, 21);

  label2 = gtk_label_new (_("Control panel\n\nAuthors\nJean-Francois VIBERT\nMarc TISSERAND\n\nESI B3E INSERM U444\nFaculte de Medecine Saint-Antoine\n27 rue de Chaligny\n75571 Paris Cedex 12 \nFRANCE\n\nCopyleft : Dr J-F Vibert, August 2001\nLicence : General Public Licence\n"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed3), label2, 16, 56);
  gtk_widget_set_uposition (label2, 16, 56);
  gtk_widget_set_usize (label2, 264, 248);

  dialog_action_area1 = GTK_DIALOG (about_window)->action_area;
  gtk_object_set_data (GTK_OBJECT (about_window), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbuttonbox1, TRUE, TRUE, 0);

  close_dialog1 = gtk_button_new_with_label (_("Close"));
  gtk_widget_ref (close_dialog1);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "close_dialog1", close_dialog1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close_dialog1);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), close_dialog1);
  GTK_WIDGET_SET_FLAGS (close_dialog1, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, close_dialog1, _("Close this information box"), NULL);

  gtk_signal_connect (GTK_OBJECT (close_dialog1), "clicked",
                      GTK_SIGNAL_FUNC (on_close_dialog1_clicked),
                      NULL);

  gtk_widget_grab_focus (about_window);
  gtk_widget_grab_default (close_dialog1);
  gtk_object_set_data (GTK_OBJECT (about_window), "tooltips", tooltips);

  return about_window;
}

GtkWidget*
create_fileselection_exp (void)
{
  GtkWidget *fileselection_exp;
  GtkWidget *btn_ok_filesel_open;
  GtkWidget *btn_filesel_open_cancel;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  fileselection_exp = gtk_file_selection_new (_("Chose an experiment file"));
  gtk_object_set_data (GTK_OBJECT (fileselection_exp), "fileselection_exp", fileselection_exp);
  gtk_container_set_border_width (GTK_CONTAINER (fileselection_exp), 10);
  GTK_WINDOW (fileselection_exp)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (fileselection_exp), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (fileselection_exp), TRUE);

  btn_ok_filesel_open = GTK_FILE_SELECTION (fileselection_exp)->ok_button;
  gtk_object_set_data (GTK_OBJECT (fileselection_exp), "btn_ok_filesel_open", btn_ok_filesel_open);
  gtk_widget_show (btn_ok_filesel_open);
  GTK_WIDGET_SET_FLAGS (btn_ok_filesel_open, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, btn_ok_filesel_open, _("Accept this file and close."), NULL);

  btn_filesel_open_cancel = GTK_FILE_SELECTION (fileselection_exp)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (fileselection_exp), "btn_filesel_open_cancel", btn_filesel_open_cancel);
  gtk_widget_show (btn_filesel_open_cancel);
  GTK_WIDGET_SET_FLAGS (btn_filesel_open_cancel, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, btn_filesel_open_cancel, _("Cancel the selection and close."), NULL);

  gtk_signal_connect (GTK_OBJECT (btn_ok_filesel_open), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_ok_filesel_open_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_filesel_open_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_filesel_open_cancel_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (fileselection_exp), "tooltips", tooltips);

  return fileselection_exp;
}

GtkWidget*
create_dialog_current (void)
{
  GtkWidget *dialog_current;
  GtkWidget *dialog_vbox2;
  GtkWidget *label_current_1;
  GtkWidget *label_current_2;
  GtkWidget *dialog_action_area2;
  GtkWidget *btn_close_current;
  GtkWidget *btn_help_current;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  dialog_current = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_current), "dialog_current", dialog_current);
  gtk_window_set_title (GTK_WINDOW (dialog_current), _("Current experiment"));
  GTK_WINDOW (dialog_current)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (dialog_current), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialog_current), TRUE);

  dialog_vbox2 = GTK_DIALOG (dialog_current)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog_current), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  label_current_1 = gtk_label_new (_("Current experiment :"));
  gtk_widget_ref (label_current_1);
  gtk_object_set_data_full (GTK_OBJECT (dialog_current), "label_current_1", label_current_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_current_1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), label_current_1, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_current_1), GTK_JUSTIFY_LEFT);

  label_current_2 = gtk_label_new (_("label4"));
  gtk_widget_ref (label_current_2);
  gtk_object_set_data_full (GTK_OBJECT (dialog_current), "label_current_2", label_current_2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_current_2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), label_current_2, TRUE, TRUE, 0);

  dialog_action_area2 = GTK_DIALOG (dialog_current)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog_current), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_widget_set_usize (dialog_action_area2, 42, -2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  btn_close_current = gtk_button_new_with_label (_("Close"));
  gtk_widget_ref (btn_close_current);
  gtk_object_set_data_full (GTK_OBJECT (dialog_current), "btn_close_current", btn_close_current,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_close_current);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), btn_close_current, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, btn_close_current, _("Close this information box."), NULL);

  btn_help_current = gtk_button_new_with_label (_("Help"));
  gtk_widget_ref (btn_help_current);
  gtk_object_set_data_full (GTK_OBJECT (dialog_current), "btn_help_current", btn_help_current,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_help_current);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), btn_help_current, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_help_current, 38, -2);
  gtk_tooltips_set_tip (tooltips, btn_help_current, _("To obtain help on the different fields of this information box"), NULL);

  gtk_signal_connect (GTK_OBJECT (btn_close_current), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_close_current_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_help_current), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_help_current_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (dialog_current), "tooltips", tooltips);

  return dialog_current;
}

GtkWidget*
create_dialog_help_current (void)
{
  GtkWidget *dialog_help_current;
  GtkWidget *dialog_vbox3;
  GtkWidget *label3;
  GtkWidget *dialog_action_area3;
  GtkWidget *btn_help_close;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  dialog_help_current = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_help_current), "dialog_help_current", dialog_help_current);
  gtk_window_set_title (GTK_WINDOW (dialog_help_current), _("Help on Current Experiment"));
  GTK_WINDOW (dialog_help_current)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (dialog_help_current), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (dialog_help_current), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialog_help_current), TRUE, TRUE, FALSE);

  dialog_vbox3 = GTK_DIALOG (dialog_help_current)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog_help_current), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_vbox3), 11);

  label3 = gtk_label_new ("");
  gtk_label_parse_uline (GTK_LABEL (label3),
                         _("The path directory is the place where all files,\nof the current experiment, are stored.\nNote, that the directory name is always suffixed by _xnbc.\nPlease, do not manipulate the files stored in these\ndirectories, (by a shell command for example...)\nif you want to be able to still work with these experiments."));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (dialog_help_current), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), label3, FALSE, FALSE, 0);

  dialog_action_area3 = GTK_DIALOG (dialog_help_current)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog_help_current), "dialog_action_area3", dialog_action_area3);
  gtk_widget_show (dialog_action_area3);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area3), 10);

  btn_help_close = gtk_button_new_with_label (_("Close"));
  gtk_widget_ref (btn_help_close);
  gtk_object_set_data_full (GTK_OBJECT (dialog_help_current), "btn_help_close", btn_help_close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_help_close);
  gtk_box_pack_start (GTK_BOX (dialog_action_area3), btn_help_close, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, btn_help_close, _("Close this help box."), NULL);

  gtk_signal_connect (GTK_OBJECT (btn_help_close), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_help_close_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (dialog_help_current), "tooltips", tooltips);

  return dialog_help_current;
}

GtkWidget*
create_dialog_previous (void)
{
  GtkWidget *dialog_previous;
  GtkWidget *dialog_vbox4;
  GtkWidget *label_recent;
  GtkWidget *scrolledwindow3;
  GtkWidget *list_recent;
  GtkWidget *label7;
  GtkWidget *hbox1;
  GtkWidget *label6;
  GtkObject *spinbutton1_adj;
  GtkWidget *spinbutton1;
  GtkWidget *dialog_action_area4;
  GtkWidget *btn_recent_OK;
  GtkWidget *Cancel_recent;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  dialog_previous = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_previous), "dialog_previous", dialog_previous);
  gtk_window_set_title (GTK_WINDOW (dialog_previous), _("Recent experiments"));
  GTK_WINDOW (dialog_previous)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (dialog_previous), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (dialog_previous), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialog_previous), TRUE, TRUE, FALSE);

  dialog_vbox4 = GTK_DIALOG (dialog_previous)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog_previous), "dialog_vbox4", dialog_vbox4);
  gtk_widget_show (dialog_vbox4);

  label_recent = gtk_label_new (_("Select one of your recent experiments"));
  gtk_widget_ref (label_recent);
  gtk_object_set_data_full (GTK_OBJECT (dialog_previous), "label_recent", label_recent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_recent);
  gtk_box_pack_start (GTK_BOX (dialog_vbox4), label_recent, FALSE, FALSE, 5);
  gtk_label_set_justify (GTK_LABEL (label_recent), GTK_JUSTIFY_LEFT);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (dialog_previous), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (dialog_vbox4), scrolledwindow3, TRUE, TRUE, 5);

  list_recent = gtk_clist_new (1);
  gtk_widget_ref (list_recent);
  gtk_object_set_data_full (GTK_OBJECT (dialog_previous), "list_recent", list_recent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_recent);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), list_recent);
  gtk_clist_set_column_width (GTK_CLIST (list_recent), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (list_recent));

  label7 = gtk_label_new (_("Recent experiments"));
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (dialog_previous), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_clist_set_column_widget (GTK_CLIST (list_recent), 0, label7);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog_previous), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox4), hbox1, FALSE, FALSE, 0);

  label6 = gtk_label_new (_(" Nb of experiments to remember  : "));
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (dialog_previous), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (hbox1), label6, FALSE, FALSE, 0);

  spinbutton1_adj = gtk_adjustment_new (1, 0, 100, 1, 10, 10);
  spinbutton1 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 0);
  gtk_widget_ref (spinbutton1);
  gtk_object_set_data_full (GTK_OBJECT (dialog_previous), "spinbutton1", spinbutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton1);
  gtk_box_pack_start (GTK_BOX (hbox1), spinbutton1, TRUE, TRUE, 0);

  dialog_action_area4 = GTK_DIALOG (dialog_previous)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog_previous), "dialog_action_area4", dialog_action_area4);
  gtk_widget_show (dialog_action_area4);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area4), 10);

  btn_recent_OK = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (btn_recent_OK);
  gtk_object_set_data_full (GTK_OBJECT (dialog_previous), "btn_recent_OK", btn_recent_OK,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_recent_OK);
  gtk_box_pack_start (GTK_BOX (dialog_action_area4), btn_recent_OK, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_recent_OK, 55, -2);
  gtk_tooltips_set_tip (tooltips, btn_recent_OK, _("Accept the selected experiment and close the dialog box."), NULL);

  Cancel_recent = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (Cancel_recent);
  gtk_object_set_data_full (GTK_OBJECT (dialog_previous), "Cancel_recent", Cancel_recent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Cancel_recent);
  gtk_box_pack_start (GTK_BOX (dialog_action_area4), Cancel_recent, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, Cancel_recent, _("Cancel the selection and close"), NULL);

  gtk_signal_connect (GTK_OBJECT (list_recent), "select_row",
                      GTK_SIGNAL_FUNC (on_list_recent_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (spinbutton1), "changed",
                      GTK_SIGNAL_FUNC (on_spinbutton1_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_recent_OK), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_recent_OK_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Cancel_recent), "clicked",
                      GTK_SIGNAL_FUNC (on_Cancel_recent_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (dialog_previous), "tooltips", tooltips);

  return dialog_previous;
}

GtkWidget*
create_dialog_printer (void)
{
  GtkWidget *dialog_printer;
  GtkWidget *dialog_vbox5;
  GtkWidget *label_printer;
  GtkWidget *entry_printer;
  GtkWidget *dialog_action_area5;
  GtkWidget *btn_printer_OK;
  GtkWidget *btn_printer_cancel;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  dialog_printer = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_printer), "dialog_printer", dialog_printer);
  gtk_window_set_title (GTK_WINDOW (dialog_printer), _("Printer selection"));
  GTK_WINDOW (dialog_printer)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (dialog_printer), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialog_printer), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialog_printer), TRUE, TRUE, FALSE);

  dialog_vbox5 = GTK_DIALOG (dialog_printer)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog_printer), "dialog_vbox5", dialog_vbox5);
  gtk_widget_show (dialog_vbox5);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_vbox5), 10);

  label_printer = gtk_label_new (_("Command line to print a PS file on this system."));
  gtk_widget_ref (label_printer);
  gtk_object_set_data_full (GTK_OBJECT (dialog_printer), "label_printer", label_printer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_printer);
  gtk_box_pack_start (GTK_BOX (dialog_vbox5), label_printer, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_printer), GTK_JUSTIFY_LEFT);

  entry_printer = gtk_entry_new_with_max_length (256);
  gtk_widget_ref (entry_printer);
  gtk_object_set_data_full (GTK_OBJECT (dialog_printer), "entry_printer", entry_printer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_printer);
  gtk_box_pack_start (GTK_BOX (dialog_vbox5), entry_printer, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, entry_printer, _("The command line to send the PostScript files to your printer. According to your local installation, this line can vary. This command line is kept for the next runs."), NULL);
  gtk_entry_set_text (GTK_ENTRY (entry_printer), _("lpr -P"));

  dialog_action_area5 = GTK_DIALOG (dialog_printer)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog_printer), "dialog_action_area5", dialog_action_area5);
  gtk_widget_show (dialog_action_area5);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area5), 10);

  btn_printer_OK = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (btn_printer_OK);
  gtk_object_set_data_full (GTK_OBJECT (dialog_printer), "btn_printer_OK", btn_printer_OK,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_printer_OK);
  gtk_box_pack_start (GTK_BOX (dialog_action_area5), btn_printer_OK, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_printer_OK, 46, -2);
  GTK_WIDGET_UNSET_FLAGS (btn_printer_OK, GTK_CAN_FOCUS);
  gtk_tooltips_set_tip (tooltips, btn_printer_OK, _("Accept the command line and close the dialog box"), NULL);

  btn_printer_cancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (btn_printer_cancel);
  gtk_object_set_data_full (GTK_OBJECT (dialog_printer), "btn_printer_cancel", btn_printer_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_printer_cancel);
  gtk_box_pack_start (GTK_BOX (dialog_action_area5), btn_printer_cancel, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, btn_printer_cancel, _("Cancel the change and close"), NULL);

  gtk_signal_connect (GTK_OBJECT (btn_printer_OK), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_printer_OK_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_printer_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_printer_cancel_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (dialog_printer), "tooltips", tooltips);

  return dialog_printer;
}

GtkWidget*
create_fileselection_new (void)
{
  GtkWidget *fileselection_new;
  GtkWidget *btn_ok_filesel_new;
  GtkWidget *btn_filesel_new_cancel;
  GtkTooltips *tooltips;
  char home_dir[256];

  strcpy(home_dir,getenv("HOME"));
  strcat(home_dir,"/");

  tooltips = gtk_tooltips_new ();

  fileselection_new = gtk_file_selection_new (_("Give a new experiment name"));
  gtk_object_set_data (GTK_OBJECT (fileselection_new), "fileselection_new", fileselection_new);
  gtk_container_set_border_width (GTK_CONTAINER (fileselection_new), 10);
  GTK_WIDGET_SET_FLAGS (fileselection_new, GTK_CAN_FOCUS);
  gtk_tooltips_set_tip (tooltips, fileselection_new, _("Give a new experiment name. _xnbc will be automatically added."), NULL);
  GTK_WINDOW (fileselection_new)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (fileselection_new), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (fileselection_new), TRUE);
  gtk_file_selection_set_filename (GTK_WINDOW (fileselection_new), home_dir);

  btn_ok_filesel_new = GTK_FILE_SELECTION (fileselection_new)->ok_button;
  gtk_object_set_data (GTK_OBJECT (fileselection_new), "btn_ok_filesel_new", btn_ok_filesel_new);
  gtk_widget_show (btn_ok_filesel_new);
  GTK_WIDGET_SET_FLAGS (btn_ok_filesel_new, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, btn_ok_filesel_new, _("Accept  this name and close the box."), NULL);

  btn_filesel_new_cancel = GTK_FILE_SELECTION (fileselection_new)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (fileselection_new), "btn_filesel_new_cancel", btn_filesel_new_cancel);
  gtk_widget_show (btn_filesel_new_cancel);
  GTK_WIDGET_SET_FLAGS (btn_filesel_new_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (btn_ok_filesel_new), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_ok_filesel_new_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_filesel_new_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_filesel_new_cancel_clicked),
                      NULL);

  gtk_widget_grab_focus (fileselection_new);
  gtk_object_set_data (GTK_OBJECT (fileselection_new), "tooltips", tooltips);

  return fileselection_new;
}

GtkWidget*
create_dialog_message (void)
{
  GtkWidget *dialog_message;
  GtkWidget *dialog_vbox6;
  GtkWidget *label_message;
  GtkWidget *dialog_action_area6;
  GtkWidget *btn_close_message;

  dialog_message = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_message), "dialog_message", dialog_message);
  gtk_window_set_title (GTK_WINDOW (dialog_message), _("Message"));
  GTK_WINDOW (dialog_message)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (dialog_message), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialog_message), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialog_message), TRUE, TRUE, FALSE);

  dialog_vbox6 = GTK_DIALOG (dialog_message)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog_message), "dialog_vbox6", dialog_vbox6);
  gtk_widget_show (dialog_vbox6);

  label_message = gtk_label_new (_("Message:"));
  gtk_widget_ref (label_message);
  gtk_object_set_data_full (GTK_OBJECT (dialog_message), "label_message", label_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_message);
  gtk_box_pack_start (GTK_BOX (dialog_vbox6), label_message, FALSE, FALSE, 0);

  dialog_action_area6 = GTK_DIALOG (dialog_message)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog_message), "dialog_action_area6", dialog_action_area6);
  gtk_widget_show (dialog_action_area6);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area6), 10);

  btn_close_message = gtk_button_new_with_label (_("Close"));
  gtk_widget_ref (btn_close_message);
  gtk_object_set_data_full (GTK_OBJECT (dialog_message), "btn_close_message", btn_close_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_close_message);
  gtk_box_pack_start (GTK_BOX (dialog_action_area6), btn_close_message, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (btn_close_message), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_close_message_clicked),
                      NULL);

  return dialog_message;
}

GtkWidget*
create_dialog_virtual (void)
{
  GtkWidget *dialog_virtual;
  GtkWidget *dialog_vbox7;
  GtkWidget *label5;
  GtkWidget *scrolledwindow1;
  GtkWidget *viewport1;
  GtkWidget *virtual_text;
  GtkWidget *dialog_action_area7;
  GtkWidget *virtual_help;
  GtkWidget *virtual_close;

  dialog_virtual = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_virtual), "dialog_virtual", dialog_virtual);
  gtk_window_set_title (GTK_WINDOW (dialog_virtual), _("Virtual neurons"));
  GTK_WINDOW (dialog_virtual)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (dialog_virtual), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialog_virtual), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialog_virtual), TRUE, TRUE, FALSE);

  dialog_vbox7 = GTK_DIALOG (dialog_virtual)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog_virtual), "dialog_vbox7", dialog_vbox7);
  gtk_widget_show (dialog_vbox7);

  label5 = gtk_label_new (_("Available virtual neurons"));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (dialog_virtual), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (dialog_vbox7), label5, FALSE, FALSE, 2);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (dialog_virtual), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox7), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (dialog_virtual), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);

  virtual_text = gtk_label_new (_("No Virtual neuron available.\nSorry!"));
  gtk_widget_ref (virtual_text);
  gtk_object_set_data_full (GTK_OBJECT (dialog_virtual), "virtual_text", virtual_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (virtual_text);
  gtk_container_add (GTK_CONTAINER (viewport1), virtual_text);
  gtk_widget_set_sensitive (virtual_text, FALSE);
  gtk_label_set_justify (GTK_LABEL (virtual_text), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (virtual_text), TRUE);

  dialog_action_area7 = GTK_DIALOG (dialog_virtual)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog_virtual), "dialog_action_area7", dialog_action_area7);
  gtk_widget_show (dialog_action_area7);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area7), 10);

  virtual_help = gtk_button_new_with_label (_("Help"));
  gtk_widget_ref (virtual_help);
  gtk_object_set_data_full (GTK_OBJECT (dialog_virtual), "virtual_help", virtual_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (virtual_help);
  gtk_box_pack_start (GTK_BOX (dialog_action_area7), virtual_help, FALSE, FALSE, 0);

  virtual_close = gtk_button_new_with_label (_("Close"));
  gtk_widget_ref (virtual_close);
  gtk_object_set_data_full (GTK_OBJECT (dialog_virtual), "virtual_close", virtual_close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (virtual_close);
  gtk_box_pack_start (GTK_BOX (dialog_action_area7), virtual_close, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (virtual_help), "clicked",
                      GTK_SIGNAL_FUNC (on_virtual_help_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (virtual_close), "clicked",
                      GTK_SIGNAL_FUNC (on_virtual_close_clicked),
                      NULL);

  return dialog_virtual;
}

