/* 
 *  Header pour la gestion des fichiers de xnbc
 *
 *  JF Vibert 1 sept 1997
 *            get_current_simulation added (JFV: 20 sept 2001)
 */

void browse_manual(char *);
char *get_current_experiment(void);
char *get_simulation_name(void);
char *get_network_name(void);
char *get_lnk_name(void);
char *get_pmb_name(void);
char *get_sim_name(void);
char *get_tms_name(void);
char *get_project_name(void);
char *get_dir_name(void);
int save_xnbcrc(char *, char *, char *, char *, char *);
int put_current_experiment(char *);
int put_simulation_name(char *, char *);
int put_network_name(char *, char *);
int put_project_name(char *, char *);
int put_dir_name(char *, char *);

#define DEF_XNBC_BROWSER	"mozilla"
#define DEF_XNBC_ROOT_HTML	"/usr/local/bin/xnbc.bin/V8/xnbc8_manual/"
#define	XNBC_FULL_MANUAL	"XNBC8_User.html"
#define XNBC_CONTROL_PANEL	"XNBC_control.html"
#define XNBC_P_NEURON		"phenomenologic_model.html"
#define XNBC_G_NEURON		"conductance_based.html"
#define XNBC_LINK_EDIT		"simple_network.html"
#define XNBC_NETWORK_EDITOR	"full_featured.html"
#define XNBC_DRUG_EDITOR	"drug_editor.html"
#define XNBC_NBC_X		"simulator.html"
#define XNBC_VISU		"visualization_tool.html"
#define XNBC_XTMS		"time_series.html"
#define XNBC_XCAA		"network_activity.html"
#define XNBC_CBM_EQ		"CBM_model.html"
#define XNBC_LIM_EQ		"LIM_model.html"
#define XNBC_PUM_EQ		"PUM_model.html"
#define XNBC_BUM_EQ		"BUM_model.html"
