/*----------------------------------------------------------------------------
 *				M A T R I X . H
 *--------------------------------------------------------------------------*/

/*
  *
  *	Author: Yann HERRY
  *		Laboratoire de Biomathematiques
  *		URBB B3E INSERM U263
  *		Faculte de Medecine Saint-Antoine
  *		27 rue Chaligny
  *		75571 Paris cedex 12
  *			France
  *
  *	Copyright Dr JF Vibert, May 1993
  *	All rights reserved
  *	Access limited to authorized persons
  *	This software was developped only for resarch purpose
  *	and is not, in any way, usable for commercial purpose.
  *
*/
  

/*---- Pour les wigets ou-exclusif des types de connexions -----*/

#define 	INHIB 	0
#define 	EXCIT	1
#define       ALEAT          4
#define       MANUEL      5

/*---- Pour le widget enregistrant les motifs pour la gestion des connexions -----*/
#define 	STOP      	0
#define 	RECORD 	1
#define 	PLACE    	2
#define 	REPEAT	3
#define 	CLEAR	4


extern draw_matrix(Widget, int *,XmAnyCallbackStruct *);			/* CallBack de Saisie des connexions */
extern void gest_scrolling(Widget,int *, XmDrawingAreaCallbackStruct *);	/* Callback de suivi du scrolling */
extern void Notify_Matrix(int, int, int, int);
extern void Notify_AVL(int );						/* Message cluster.c vers matrix.c sur le nombre de neurone dans chaque cluster */
extern void change_couleur( int );						/* Couleurs pour lien Excit/Inhib */
extern void gest_motif( int );						/* Mode pour reproduire un motif */
extern int read_cnx(char *);
extern void  Lect_Fich_MAT( char * );	/* Lecture de connections entre deux clusters */


