/*---------------------------------------------------------------------------
	T Y P A V L . H : Declaration des types de donnees manipule par AVL
---------------------------------------------------------------------------*/

/*
*
*	Author: Yann HERRY
*		Laboratoire de Biomathematiques
*		URBB B3E INSERM U263
*		Faculte de Medecine Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert, Mai 1993 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is not, in any way, usable for commercial purpose.
*
*/
#include "typmat.h"

#define DEB 0
#define FIN 1
#define INT	2
#define AVL_SIMPLE    0
#define AVL_DCHAINE 1

#define MEMORY_AVL	   	0
#define MEMORY_MATRIX    	-1
#define NOPROBLEM		1

#define NUL -1

/*--- Definition des couleurs et des types pour les connixions ---*/
#define       INHIB 	0
#define       EXCIT	1
#define 	NEANT   	2
#define        BLACK	3

#define       ALEAT          4
#define       MANUEL      5


	struct element
	{
		MAT *Matrix;   
		int Cle, Type, NbNeurL, NbNeurH;
	};


	struct NOEUD
	{
		struct NOEUD *g,*d;
		struct NOEUD *pred,*suiv;
		struct element elem;
		int deseq; /* -2..+2 */
	};


typedef struct NOEUD *ARBRE_AVL;





