/*******************************************************************
*
*			 E C R A N . H
*
*	Fichier de definition de la gestion d'ecran VT100 / VT2xx
*
*		J-F VIBERT      23-MAR-1987 12:58:13 
*	Portage ULTRIX
*		J-F VIBERT	10 mars 1988
*		
*	Auteur: Dr J-F VIBERT et Ch. PASTORET
*		Laboratoire de Physiologie
*		CHU Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for research purpose
*	and is in any way usable for commercial purpose.
*
*	Modifie par J-F Vibert les
*		 13-MAY-1987 11:59:49 
*		par Ch Pastoret
*		 NOV-87
*
*********************************************************************/
#ifdef DOCUMENTATION

title	ECRAN	Gestion d ecran
index		Gestion d ecran


Synopsis

	.nf
	#include <ecran.h>
	.f

Description

Files


See also


Diagnostics

Authors

	Dr Jean-Francois VIBERT
	Christian PASTORET
	.s
	CHU Saint_Antoine PARIS

Bugs/deficiencies


#endif


/************************ S O N N E T T E ***************************/

#define		BELL	'\007'

/******************** E / S   M O D E   G R A P H I Q U E ***********/

			/****** mode graphique ******/

#define		GRAPH	puts("\033\0500")

			/****** mode non-graphique ******/
			
#define		NOGRAPH	puts("\033\050B")

/************************ C A R A C T E R E S ************************/

			/****** caracteres en simple-largeur ******/

#define		SINGLEW	"\033#5"	

			/****** caracteres en double-largeur ******/

#define		DBLEW	"\033#6"


			/****** caracteres en double-largeur ******/
		             /****** et double-hauteur ******/
				    /* Haut et Bas */

#define		DBLEH	"\033#3"	
#define		DBLEB	"\033#4"	


/****************************** E C R A N **********************************/

		/****** clear all screen ******/

#define 	CLRAS	"\033[2J"
#define		CL 	puts("\033[2J")


		/****** clear screen from cursor position ******/

#define		CLS	("\033[J")

/******************* B L I N K / R E V E R S E / N O R M A L *****************/

			/****** clignote on ******/

#define 	BLINK	"\033[5m"

			/****** reverse video ******/

#define 	REVERSE "\033[7m"

			/****** surbrillant  ******/

#define 	BOLD	"\033[1m"

			/****** souligne ******/

#define 	UNDERLINE	"\033[4m"

			/****** retour normal ******/

#define 	NORMAL	"\033[m"

/************************ C U R S E U R ********************************/

			/****** home ******/

#define		HOME 	"\033[H"
#define		HOM     curseur(1,1)
#define		cursBD	cursB(1);cursD(1)

/*********************** D E L E T I O N S **************************/

		/****** delete la ligne courante ******/

#define		DELL	puts("\033[2K")
		
		/****** delete du curseur a la fin de la ligne ******/

#define		DELCL	puts("\033[K")
		
		/****** delete du debut de ligne au curseur ******/

#define		DELLC	puts("\033[1K")

