#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- no modification in this file -------------*/

#endif
/*-----------------------------------------------------------------
 *                      C O U L E U R S . C
 * vient de G_neuron
 * modifie pour nbc_x 
 *                      JFV: 19 dec 2000
 *---------------------------------------------------------------*/

 
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include "creation-simu.h"

#define	MAXCOULEURS	256


/*----------------------------------------------------------------
 *                     c r e e _ p a l e t t e
 *--------------------------------------------------------------*/

void	cree_palette ()

{
	int		nb_couleurs;
	register	i;
	Colormap        palette_default;
	XColor		couleur[MAXCOULEURS];

	/* nombre de cellules de la palette par defaut */

	nb_couleurs = DisplayCells (the_display, XDefaultScreen (the_display));

	/* recuperation de la palette par defaut */

	palette_default = DefaultColormap(the_display,
					  XDefaultScreen (the_display));

	/* initialisation du tableau couleur pour
	indiquer chaque pixel disponible */

	for(i = 0; i<nb_couleurs; i++)
	{
		couleur[i].pixel = i;
	} /* fin du for */

	/*recuperation des valeurs RGB de la palette par
	defaut et les place dans le tableau couleur */

	XQueryColors (the_display, palette_default, couleur, nb_couleurs);


	/* creation d'une nouvelle palette */

	palette = XCreateColormap (the_display, DefaultRootWindow(the_display),
				   DefaultVisual(the_display,
					DefaultScreen(the_display)),
				   AllocAll);

	/* definition du noir */

	couleur[99].red = 0;
	couleur[99].blue = 0;
	couleur[99].green = 0;

	/* definition du rouge */

	couleur[100].red = 65535;
	couleur[100].blue = 0;
	couleur[100].green = 0;

	/* definition du bleu */

	couleur[101].red = 0;
	couleur[101].blue = 65535;
	couleur[101].green = 0;

	/* definition du vert */

	couleur[102].red = 0;
	couleur[102].blue = 0;
	couleur[102].green = 55000;

	/* definition du violet */

	couleur[103].red = 50000;
	couleur[103].blue = 65535;
	couleur[103].green = 0;

	/* definition du mauve */

	couleur[104].red = 65000;
	couleur[104].blue = 65000;
	couleur[104].green = 35000;

	/* definition du turquoise */

	couleur[105].red = 0;
	couleur[105].blue = 65000;
	couleur[105].green = 55000;

	/* definition du jaune */

	couleur[106].red = 44461;
	couleur[106].blue = 12079;
	couleur[106].green = 65535;

	/* Stockage des couleurs dans la nouvelle palette */

	XStoreColors (the_display, palette, couleur, nb_couleurs);

}


/*----------------------------------------------------------------
 *                     c o u l e u r s
 *--------------------------------------------------------------*/

void	couleurs ()
{
	/* definition du noir */

	NOIR = 0;

	/* definition du rouge */

	ROUGE = 16711680;

	/* definition du bleu */

	BLEU = 255;

	/* definition du vert */

	VERT = 54784;

	/* definition du violet */

	VIOLET = 12779775;

	/* definition du mauve */

	MAUVE = 16681214;

	/* definition du turquoise */

	TURQ = 55037;

	/* definition du jaune */

	JAUNE = 11403055;

	/* definition du blanc */

	BLANC = 16766719;
}
