#ifndef _CREATION_SIMU_1_
#define _CREATION_SIMU_1_

#define DRUG_DEBUG 0
/*
 * Globally included information.
 */

#include "creation-simu.h"

/*
 * Create the form_nucleus_parameters hierarchy of widgets.
 */
Widget
Createform_nucleus_parameters(parent)
     Widget parent;
{
  char     file[256];
  char	   drug_dir[256];
  char	   *d_dir;
  Arg      args[256];
  Cardinal ac=0;
  Boolean  argok=False;
  Widget   nucleus_parameters;
  Widget   form_nucleus_parameters;
  Widget   separator5;
  Widget   form_nucl_para_ctrl;
  Widget   option_stim_nucl;
  Widget   pushB_ok_nucl;
  Widget   pushB_apply_nucl;
  Widget   pushB_cancel_nucl;
  Widget   pushB_help_nucl;
  Widget   form_nucl_para_w;
  Widget   form_nucl_para_other;
  Widget   textF_hebb_factor;
  Widget   label_learning_factor;
  Widget   toggleB_weight_fluct;
  Widget   label_nucl_dynamic;
  Widget   label_prob_spike;
  Widget   textF_prob_spike;
  Widget   label_old_last_spike;
  Widget   textF_old_last_spike;
  Widget   label_recent_last_spike;
  Widget   textF_recent_last_spike;
  Widget   label_up_mb_pot;
  Widget   textF_up_mb_pot;
  Widget   label_low_mb_pot;
  Widget   textF_low_mb_pot;
  Widget   separator3;
  Widget   toggleB_make_alive;
  Widget   label_nucl_init;
  Widget   form_nucl_modulation;
  Widget   textF_nucl_modul_phase;
  Widget   textF_nucl_modul_amp;
  Widget   textF_nucl_modul_period;
  Widget   textF_nucl_modul_nb;
  Widget   label_nucl_modul_amp;
  Widget   label_nucl_modul_phase;
  Widget   label_nucl_modul_period;
  Widget   label_nucl_modul_nb;
  Widget   radioBox2;
  Widget   toggleB_nucl_modul_none;
  Widget   toggleB_nucl_modul_sin;
  Widget   toggleB_nucl_modul_triangle;
  Widget   toggleB_nucl_modul_rect;
  Widget   toggleB_nucl_modul_pulse;
  Widget   label;
  Widget   form_nucl_para_noise;
  Widget   label_nucl_noise_sd;
  Widget   label_nucl_noise_m;
  Widget   radioBox4;
  Widget   toggleB_nucl_noise_none;
  Widget   toggleB_nucl_noise_active;
  Widget   textF_nucl_noise_sd;
  Widget   textF_nucl_noise_m;
  Widget   label_noise;
  Widget   form_nucl_para_input;
  Widget   radioBox1;
  Widget   toggleB_nucl_input_excit;
  Widget   toggleB_nucl_input_inhib;
  Widget   textF_input_scale_factor;
  Widget   textF_input_sd;
  Widget   textF_input_period_m;
  Widget   label_input_scale_factor;
  Widget   label_input_deviation;
  Widget   label_input_period_m;
  Widget   radioBox;
  Widget   toggleB_nucl_input_none;
  Widget   toggleB_nucl_input_reg;
  Widget   toggleB_nucl_input_gauss;
  Widget   toggleB_nucl_input_exp;
  Widget   toggleB_nucl_input_gamma;
  Widget   toggleB_nucl_input_poisson;
  Widget   label_input;

  Widget   form_nucl_drug;

  Widget   toggleB_nucl_input_drug;
  Widget   toggleB_nucl_input_No_drug;
  Widget   label_input_drug;
  Widget   label_drug_File_Name;


  char     message[256];
  Widget   Label_explain_drug;
  Widget   Label_List_drug;
  Widget   Label_List_crt;
  Widget   Label_List_drug_Selected;
  int      i, j, k, Number_of_drug, Number_of_drug_select;
  XmString xmstring, string1, string2, string3, string4, string5, string6;
  
  /*
   * Register the converters for the widgets.
   */
  RegisterBxConverters(XtWidgetToApplicationContext(parent)); 
  XtInitializeWidgetClass(xmDialogShellWidgetClass);
  XtInitializeWidgetClass(xmFormWidgetClass);
  XtInitializeWidgetClass(xmSeparatorWidgetClass);
  XtInitializeWidgetClass(xmFormWidgetClass);
  XtInitializeWidgetClass(xmPushButtonWidgetClass);
  XtInitializeWidgetClass(xmTextFieldWidgetClass);
  XtInitializeWidgetClass(xmLabelWidgetClass);
  XtInitializeWidgetClass(xmToggleButtonWidgetClass);
  XtInitializeWidgetClass(xmRowColumnWidgetClass);
  
  /*
   * Fenetre des parametres du nucleus
   */
  ac = 0;
  XtSetArg(args[ac], XmNtitle, "Nucleus Parameters"); ac++;
  XtSetArg(args[ac], XmNminWidth, 840); ac++;
  XtSetArg(args[ac], XmNminHeight, 407); ac++;
  /*
  XtSetArg(args[ac], XmNmaxWidth, 840); ac++;
  XtSetArg(args[ac], XmNmaxHeight, 367); ac++;
  */
  XtSetArg(args[ac], XmNiconPixmap, pixicon);  ac++;
  XtSetArg(args[ac], XmNx, 217); ac++;
  XtSetArg(args[ac], XmNy, 387); ac++;
  XtSetArg(args[ac], XmNwidth, 840); ac++;
  XtSetArg(args[ac], XmNheight, 407); ac++;
  nucleus_parameters = XtCreatePopupShell("nucleus_parameters",
					  xmDialogShellWidgetClass,
					  parent,
					  args, 
					  ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNautoUnmanage, False); ac++;
  XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
  XtSetArg(args[ac], XmNx, 217); ac++;
  XtSetArg(args[ac], XmNy, 387); ac++;
  XtSetArg(args[ac], XmNwidth, 840); ac++;
  XtSetArg(args[ac], XmNheight, 407); ac++;
  form_nucleus_parameters  = XtCreateWidget("form_nucleus_parameters",
					    xmFormWidgetClass,
					    nucleus_parameters,
					    args,
					    ac);  
  
  register_widget_CB(form_nucleus_parameters,(XtPointer)ID_form_nucleus_parameters,NULL);
  create_event_CB(form_nucleus_parameters,(XtPointer)ID_form_nucleus_parameters,NULL);
  
  /*
   * Les 4 boutons du bas
   */
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 2); ac++;
  XtSetArg(args[ac], XmNy, 289); ac++;
  XtSetArg(args[ac], XmNwidth, 836); ac++;
  XtSetArg(args[ac], XmNheight, 8); ac++;
  separator5 = XmCreateSeparator(form_nucleus_parameters,
				 "separator5",
				 args, 
				 ac);
  XtManageChild(separator5);
  
  ac = 0;
  XtSetArg(args[ac], XmNautoUnmanage, False); ac++;
  XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
  XtSetArg(args[ac], XmNfractionBase, 9); ac++;
  XtSetArg(args[ac], XmNx, 4); ac++;
  XtSetArg(args[ac], XmNy, 301); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 62); ac++;
  form_nucl_para_ctrl = XmCreateForm(form_nucleus_parameters,
				     "form_nucl_para_ctrl",
				     args, 
				     ac);
  XtManageChild(form_nucl_para_ctrl);

  /* Option menu */

  ac = 0;
  XtSetArg(args[ac], XmNx, 10); ac++;
  XtSetArg(args[ac], XmNy, 10); ac++;
  /*
  XtSetArg(args[ac], XmNwidth, 73); ac++;
  */
  XtSetArg(args[ac], XmNheight, 40); ac++;


  string1 = XmStringCreateSimple("Stimuli: ");
  string2 = XmStringCreateSimple("Spike trains");
  string3 = XmStringCreateSimple("Noise");
  string4 = XmStringCreateSimple("Modulation or pulses");
  string5 = XmStringCreateSimple("Drugs");
  string6 = XmStringCreateSimple("Others");
  option_stim_nucl = XmVaCreateSimpleOptionMenu(form_nucl_para_ctrl,
						 "option_stim_nucl",
						 string1, 'S', 0, (XtPointer)option_stim_nucl_CB,
						 XmVaPUSHBUTTON, string2, 'N', NULL, NULL,
						 XmVaPUSHBUTTON, string3, 'S', NULL, NULL,
						 XmVaPUSHBUTTON, string4, 'M', NULL, NULL,
						 XmVaPUSHBUTTON, string5, 'D', NULL, NULL,
						 XmVaPUSHBUTTON, string6, 'O', NULL, NULL,
						 NULL);
    
  XtSetValues(option_stim_nucl,args,ac);

  register_widget_CB(option_stim_nucl,(XtPointer)ID_option_stim_nucl,NULL);
  create_event_CB(option_stim_nucl,(XtPointer)ID_option_stim_nucl,NULL);
  XtManageChild(option_stim_nucl);
  XmStringFree(string1);
  XmStringFree(string2);
  XmStringFree(string3);
  XmStringFree(string4);
  XmStringFree(string5);
  XmStringFree(string6);
  
  
  xmstring = XmStringCreateLocalized("Close");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 280); ac++;
  XtSetArg(args[ac], XmNy, 10); ac++;
  XtSetArg(args[ac], XmNwidth, 80); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  pushB_ok_nucl = XmCreatePushButton(form_nucl_para_ctrl,
				     "pushB_ok_nucl",
				     args, 
				     ac);
  register_widget_CB(pushB_ok_nucl,(XtPointer)ID_pushB_ok_nucl,NULL);
  create_event_CB(pushB_ok_nucl,(XtPointer)ID_pushB_ok_nucl,NULL);
  XtAddCallback(pushB_ok_nucl,XmNactivateCallback,nucl_para_activate_CB,
		(XtPointer)ID_pushB_ok_nucl);
  XtManageChild(pushB_ok_nucl);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Apply");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 380); ac++;
  XtSetArg(args[ac], XmNy, 10); ac++;
  XtSetArg(args[ac], XmNwidth, 80); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  pushB_apply_nucl = XmCreatePushButton(form_nucl_para_ctrl,
					"pushB_apply_nucl",
					args, 
					ac);
  register_widget_CB(pushB_apply_nucl,(XtPointer)ID_pushB_apply_nucl,NULL);
  create_event_CB(pushB_apply_nucl,(XtPointer)ID_pushB_apply_nucl,NULL);
  XtAddCallback(pushB_apply_nucl,XmNactivateCallback,nucl_para_activate_CB,
		(XtPointer)ID_pushB_apply_nucl);
  XtManageChild(pushB_apply_nucl);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Cancel");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 480); ac++;
  XtSetArg(args[ac], XmNy, 10); ac++;
  XtSetArg(args[ac], XmNwidth, 80); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  pushB_cancel_nucl = XmCreatePushButton(form_nucl_para_ctrl,
					 "pushB_cancel_nucl",
					 args, 
					 ac);
  register_widget_CB(pushB_cancel_nucl,(XtPointer)ID_pushB_cancel_nucl,NULL);
  create_event_CB(pushB_cancel_nucl,(XtPointer)ID_pushB_cancel_nucl,NULL);
  XtAddCallback(pushB_cancel_nucl,XmNactivateCallback,nucl_para_activate_CB,
		(XtPointer)ID_pushB_cancel_nucl);
  XtManageChild(pushB_cancel_nucl);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Help");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 580); ac++;
  XtSetArg(args[ac], XmNy, 10); ac++;
  XtSetArg(args[ac], XmNwidth, 80); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  pushB_help_nucl = XmCreatePushButton(form_nucl_para_ctrl,
				       "pushB_help_nucl",
				       args, 
				       ac);
  register_widget_CB(pushB_help_nucl,(XtPointer)ID_pushB_help_nucl,NULL);
  create_event_CB(pushB_help_nucl,(XtPointer)ID_pushB_help_nucl,NULL);
  XtAddCallback(pushB_help_nucl,XmNactivateCallback,help_CB,
		(XtPointer)ID_pushB_help_nucl);
  XtManageChild(pushB_help_nucl);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNborderWidth, 0); ac++;
  XtSetArg(args[ac], XmNautoUnmanage, False); ac++;
  XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
  XtSetArg(args[ac], XmNfractionBase, 9); ac++;
  XtSetArg(args[ac], XmNx, 4); ac++;
  XtSetArg(args[ac], XmNy, 4); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 283); ac++;
  form_nucl_para_w = XmCreateForm(form_nucleus_parameters,
				  "form_nucl_para_w",
				  args, 
				  ac);
  XtManageChild(form_nucl_para_w);
  
  ac = 0;
  XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 732); ac++;
  XtSetArg(args[ac], XmNheight, 283); ac++;
  form_nucl_para_other = XmCreateForm(form_nucl_para_w,
				      "form_nucl_para_other",
				      args, 
				      ac);
  register_widget_CB(form_nucl_para_other,(XtPointer)ID_form_nucl_para_other,NULL);
  XtManageChild(form_nucl_para_other);

  

  /******************* cinquieme panneau (drogues) ********************************/



  ac = 0;
  XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 323); ac++;
  form_nucl_drug = XmCreateForm(form_nucl_para_w,
				"form_nucl_drug",
				args, 
				ac);
  register_widget_CB(form_nucl_drug,(XtPointer)ID_form_nucl_drug,NULL);




  
  xmstring = XmStringCreateLocalized("Injection of drug (active with CBM type cluster only)");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_input_drug = XmCreateLabel(form_nucl_drug,
				   "label_input_drug",
				   args, 
				   ac);
  XtManageChild(label_input_drug);
  XmStringFree(xmstring);




  xmstring = XmStringCreateLocalized("File Drug Name:");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 10); ac++;
  XtSetArg(args[ac], XmNy, 100); ac++;
  XtSetArg(args[ac], XmNwidth, 163); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_drug_File_Name = XmCreateLabel(form_nucl_drug,
				   "label_drug_File_Name",
				   args, 
				   ac);
  XtManageChild(label_drug_File_Name);
  XmStringFree(xmstring);

  d_dir = NULL;
  d_dir = getenv("XNBC_DRUG_DIR");
  if(d_dir)
  {
	strcpy(file,d_dir);
	strcat(file,"/Default.drug");
  }
  else
  {
	strcpy(file,bin_directory);
	strcat(file,"/drug/Default.drug");
  } /* fin du else */

  xmstring = XmStringCreateLocalized(file);
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 10); ac++;
  XtSetArg(args[ac], XmNy, 150); ac++;
  XtSetArg(args[ac], XmNwidth, 380); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_resultat_of_File_Name_Buttom = XmCreateLabel(form_nucl_drug,
						     "label_resultat_of_File_Name_Buttom",
						     args, 
						     ac);
  XtManageChild(label_resultat_of_File_Name_Buttom);
  XmStringFree(xmstring);

  xmstring = XmStringCreateLocalized("File Selection");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 10); ac++;
  XtSetArg(args[ac], XmNy, 50); ac++;
  XtSetArg(args[ac], XmNwidth, 150); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  Buttom_drug_File_Selection = XmCreatePushButton(form_nucl_drug,
						  "buttom_drug_file_selection",
						  args, 
						  ac);

  register_widget_CB(Buttom_drug_File_Selection,(XtPointer)ID_Buttom_drug_File_Selection,NULL);
  create_event_CB(Buttom_drug_File_Selection,(XtPointer)ID_Buttom_drug_File_Selection,NULL);
  XtAddCallback(Buttom_drug_File_Selection,XmNactivateCallback,nucl_para_activate_CB,
		(XtPointer)ID_Buttom_drug_File_Selection);

  XtManageChild(Buttom_drug_File_Selection);
  
  ac = 0;
  XtSetArg(args[ac], XmNisHomogeneous, False); ac++;
  XtSetArg(args[ac], XmNorientation, XmVERTICAL); ac++;
  XtSetArg(args[ac], XmNentryAlignment, XmALIGNMENT_CENTER); ac++;
  XtSetArg(args[ac], XmNpacking, XmPACK_COLUMN); ac++;
  XtSetArg(args[ac], XmNx, 10); ac++;
  XtSetArg(args[ac], XmNy, 200); ac++;
  XtSetArg(args[ac], XmNborderWidth, 1); ac++;
  XtSetArg(args[ac], XmNwidth, 163); ac++;
  XtSetArg(args[ac], XmNheight, 94); ac++;
  radioBoxDrug = XmCreateRadioBox(form_nucl_drug,
				  "radioBoxDrug",
				  args, 
				  ac);
  XtManageChild(radioBoxDrug);
  
  xmstring = XmStringCreateLocalized("Drug");
  ac = 0;
  XtSetArg(args[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNset, False); ac++;
  XtSetArg(args[ac], XmNwidth, 155); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_input_drug = XmCreateToggleButton(radioBoxDrug,
						 "toggleB_nucl_input_drug",
						 args, 
						 ac);

  register_widget_CB(toggleB_nucl_input_drug,(XtPointer)ID_toggleB_nucl_input_drug,NULL);
  create_event_CB(toggleB_nucl_input_drug, (XtPointer)ID_toggleB_nucl_input_drug, NULL);
  XtAddCallback(toggleB_nucl_input_drug,XmNvalueChangedCallback,nucl_para_activate_CB,
		(XtPointer)ID_toggleB_nucl_input_drug);
  XtManageChild(toggleB_nucl_input_drug);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("No Drug");
  ac = 0;
  XtSetArg(args[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNset, True); ac++;
  XtSetArg(args[ac], XmNwidth, 155); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_input_No_drug = XmCreateToggleButton(radioBoxDrug,
						     "toggleB_nucl_input_No_drug",
						     args, 
						     ac); 
  register_widget_CB(toggleB_nucl_input_No_drug,(XtPointer)ID_toggleB_nucl_input_No_drug,NULL);
  create_event_CB(toggleB_nucl_input_No_drug, (XtPointer)ID_toggleB_nucl_input_No_drug, NULL);
  XtAddCallback(toggleB_nucl_input_No_drug,XmNvalueChangedCallback,nucl_para_activate_CB,
		(XtPointer)ID_toggleB_nucl_input_No_drug);
  XtManageChild(toggleB_nucl_input_No_drug);
  XmStringFree(xmstring);

  
  xmstring = XmStringCreateLocalized("Select one or more drugs,\n\
this will inhibit\n\
the corresponding currents.\n\
Or directly inhibit a current.");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 100); ac++;
  XtSetArg(args[ac], XmNy, 200); ac++;
  XtSetArg(args[ac], XmNwidth, 300); ac++;
  /*
  XtSetArg(args[ac], XmNheight, 40); ac++;
  */
  Label_explain_drug = XmCreateLabel(form_nucl_drug,
				  "label_explain_drug",
				  args, 
				  ac);
  XtManageChild(Label_explain_drug);
  XmStringFree(xmstring);

  
  xmstring = XmStringCreateLocalized("Available drugs:");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 406); ac++;
  XtSetArg(args[ac], XmNy, 40); ac++;
  XtSetArg(args[ac], XmNwidth, 163); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  Label_List_drug = XmCreateLabel(form_nucl_drug,
				  "label_list_drug",
				  args, 
				  ac);
  XtManageChild(Label_List_drug);
  XmStringFree(xmstring);

  ac = 0;
  XtSetArg(args[ac], XmNx, 406); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNborderWidth, 1); ac++;
  XtSetArg(args[ac], XmNwidth, 160); ac++;
  XtSetArg(args[ac], XmNheight, 200); ac++;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 80); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;

  XtSetArg(args[ac], XmNvisualPolicy, XmCONSTANT);
  XtSetArg(args[ac], XmNscrollingPolicy, XmAUTOMATIC);
  XtSetArg(args[ac], XmNscrollBarDisplayPolicy, XmAS_NEEDED);

  List_drug = XmCreateScrolledWindow(form_nucl_drug,
				   "List1",
				   args,
				   ac);

  register_widget_CB(List_drug,(XtPointer)ID_list_drug,NULL);
  create_event_CB(List_drug, (XtPointer)ID_list_drug, NULL);
  
  XtManageChild(List_drug);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 160); ac++;
  XtSetArg(args[ac], XmNheight, 200); ac++;
  form_drugs = XmCreateForm(List_drug,
				"form_drugs",
				args, 
				ac);
  
  XtManageChild(form_drugs);


  /* lire le fichier par defaut pour obtenir le nombre de drogue et allouer la memoire pour les listes */

  if(!READ_DRUG_FILE(file))
  {
#if DRUG_DEBUG
      printf("on fait la boucle\n");
#endif
      /* pas de fichier par defaut trouve. Charger automatiquement les drogues TEA et TTX */
      str_list_drug = ( XmStringTable )XtMalloc(sizeof(XmString) * 2 );
      
      str_list_drug[0] =  XmStringCreateSimple("TEA");
      str_list_drug[1] =  XmStringCreateSimple("TTX");
      nbr_drug = 2;
      
      if ((table_of_drug_mask = ( int **)calloc(2, sizeof(int * ) ))==NULL)
      {
	  sprintf(message,"table_of_drug_mask Impossible Allocation\n");
	  display_error(widget_array[ID_sim_mainW],message,"Access Error");
      }
      
      for( i = 0 ; i < nbr_drug ; i++)
      {
	  if((table_of_drug_mask[i] = (int *)calloc(NBR_CRT, sizeof(int ) ))==NULL)
	  {
	      if (i>0)
	      {
		  for (j=0 ; j<i ; j++)
		    free(table_of_drug_mask[j]);
		  free(table_of_drug_mask);
	      }
	      sprintf(message,"Impossible Allocation... drug_mask[%d]\n",i);
	      display_error(widget_array[ID_sim_mainW],message,"Access Error");
	  }
      }
      
      if ((table_of_number_selection = ( int *)calloc(nbr_drug, sizeof(int ) ))==NULL)
      {
	  sprintf(message,"Impossible Allocation table_of_number_selection\n");
	  display_error(widget_array[ID_sim_mainW],message,"Access Error");
	  return 0;
      }
      
      MAKE_MASK_TABLE( 0, "I_K" );
      MAKE_MASK_TABLE( 1, "I_Na" );
    }

    /* the widgets */

    drug_toggle_w = (Widget *) XtCalloc(1, nbr_drug * sizeof(Widget));

    for(i = 0 ; i < nbr_drug ; i++)
    {
      /* La colonne de toggle boutons pour les drogues */

      ac = 0;
      XtSetArg(args[ac], XmNlabelString, str_list_drug[i]); ac++;
      XtSetArg(args[ac], XmNsensitive, True);ac++;    
      XtSetArg(args[ac], XmNx, 0);ac++;    
      XtSetArg(args[ac], XmNy, ((i * 35)));ac++;    
      drug_toggle_w[i] = XmCreateToggleButton(form_drugs,
					   "drug_pb",
					   args, 
					   ac);

      XtAddCallback(drug_toggle_w[i],XmNdisarmCallback,drug_activate_CB,
		    (XtPointer)(i));

      XtManageChild(drug_toggle_w[i]);
    }

    /* Liste des boutons pour les courants */

    xmstring = XmStringCreateLocalized("Inactivated currents:");

    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 600); ac++;
    XtSetArg(args[ac], XmNy, 40); ac++;
    XtSetArg(args[ac], XmNwidth, 200); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    Label_List_crt = XmCreateLabel(form_nucl_drug,
				    "label_list_crt",
				    args, 
				    ac);

    create_event_CB(Label_List_crt, (XtPointer)ID_selection_list_drug, NULL);
    XtManageChild(Label_List_crt);
    XmStringFree(xmstring);

    /* the widgets */

    crt_toggle_w = (Widget *) XtCalloc(1, NBR_CRT * sizeof(Widget));

    str_list_crt = ( XmStringTable )XtMalloc(NBR_CRT * sizeof(XmString));
      
    str_list_crt[drug_Na] =  XmStringCreateSimple("I Na");
    str_list_crt[drug_K] =  XmStringCreateSimple("I K");
    str_list_crt[drug_Ca] =  XmStringCreateSimple("I Ca");
    str_list_crt[drug_Cl] =  XmStringCreateSimple("I Cl");
    str_list_crt[drug_A] =  XmStringCreateSimple("I A");
    str_list_crt[drug_M] =  XmStringCreateSimple("I M");
    str_list_crt[drug_C] =  XmStringCreateSimple("I C");
    str_list_crt[drug_H] =  XmStringCreateSimple("I H");
    str_list_crt[drug_ahp] =  XmStringCreateSimple("I ahp");
    str_list_crt[drug_Nap] =  XmStringCreateSimple("I Nap");
    str_list_crt[drug_Cab] =  XmStringCreateSimple("I Cab");
    str_list_crt[drug_P] =  XmStringCreateSimple("I P");
    str_list_crt[drug_fuite] =  XmStringCreateSimple("I leak");

    k = 0;
    for(j = 0, i = 0 ; i <= NBR_CRT ; i += 2, j++)
    {
      /* Les 2 colonnes de toggle boutons pour les courants */
      ac = 0;
      XtSetArg(args[ac], XmNlabelString, str_list_crt[i]); ac++;
      XtSetArg(args[ac], XmNsensitive, True);ac++;    
      XtSetArg(args[ac], XmNx, 600);ac++;    
      XtSetArg(args[ac], XmNy, ((j * 35) + 80));ac++;    
      crt_toggle_w[i] = XmCreateToggleButton(form_nucl_drug,
					   "crt_pb",
					   args, 
					   ac);
      
      XtAddCallback(crt_toggle_w[i],XmNdisarmCallback,crt_disactivate_CB,
		    (XtPointer)(i));
      
      XtManageChild(crt_toggle_w[i]);
      k++;

      if (k < NBR_CRT)
      {
	ac = 0;
	XtSetArg(args[ac], XmNlabelString, str_list_crt[i+1]); ac++;
	XtSetArg(args[ac], XmNsensitive, True);ac++;    
	XtSetArg(args[ac], XmNx, 700);ac++;    
	XtSetArg(args[ac], XmNy, ((j * 35) + 80));ac++;    
	crt_toggle_w[i+1] = XmCreateToggleButton(form_nucl_drug,
					       "crt_pb",
					       args, 
					       ac);
      
	XtAddCallback(crt_toggle_w[i+1],XmNdisarmCallback,crt_disactivate_CB,
		      (XtPointer)(i+1));
      
	XtManageChild(crt_toggle_w[i+1]);
	k++;
      }
    }



  /*****************************************************************************/
  
  /*
   * initialisation vivant ou mort et Hebb factor
   */

  /************************** quatrieme panneau ********************************/

  ac = 0;
  XtSetArg(args[ac], XmNx, 439); ac++;
  XtSetArg(args[ac], XmNy, 229); ac++;
  XtSetArg(args[ac], XmNwidth, 132); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_hebb_factor = XmCreateTextField(form_nucl_para_other,
					"textF_hebb_factor",
					args, 
					ac);

  register_widget_CB( textF_hebb_factor,(XtPointer)ID_textF_hebb_factor,NULL);
  XtManageChild(textF_hebb_factor);
  
  xmstring = XmStringCreateLocalized("Hebbian learning factor:");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 110); ac++;
  XtSetArg(args[ac], XmNy, 229); ac++;
  XtSetArg(args[ac], XmNwidth, 219); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_learning_factor = XmCreateLabel(form_nucl_para_other,
					"label_learning_factor",
					args, 
					ac);
  register_widget_CB( label_learning_factor,(XtPointer)ID_label_learning_factor,NULL);
  XtManageChild(label_learning_factor);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("connection weights fluctuation according to Hebb");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 117); ac++;
  XtSetArg(args[ac], XmNy, 158); ac++;
  XtSetArg(args[ac], XmNwidth, 476); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  toggleB_weight_fluct = XmCreateToggleButton(form_nucl_para_other,
					      "toggleB_weight_fluct",
					      args, 
					      ac);
  register_widget_CB(toggleB_weight_fluct,(XtPointer)ID_toggleB_weight_fluct,NULL);
  XtAddCallback(toggleB_weight_fluct,XmNvalueChangedCallback,start_hebb_CB,NULL);
  XtManageChild(toggleB_weight_fluct);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Dynamic behavior");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 119); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_nucl_dynamic = XmCreateLabel(form_nucl_para_other,
				     "label_nucl_dynamic",
				     args, 
				     ac);
  XtManageChild(label_nucl_dynamic);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 99); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 10); ac++;
  separator3 = XmCreateSeparator(form_nucl_para_other,
				 "separator3",
				 args, 
				 ac);
  XtManageChild(separator3);

  xmstring = XmStringCreateLocalized("Initialization");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_nucl_init = XmCreateLabel(form_nucl_para_other,
				  "label_nucl_init",
				  args, 
				  ac);
  XtManageChild(label_nucl_init);
  XmStringFree(xmstring);

  
  xmstring = XmStringCreateLocalized("Random initial activity (engaged) or no initial activity (released)");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 117); ac++;
  XtSetArg(args[ac], XmNy, 40); ac++;
  XtSetArg(args[ac], XmNwidth, 483); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  toggleB_make_alive = XmCreateToggleButton(form_nucl_para_other,
					    "toggleB_make_alive",
					    args, 
					    ac);
  register_widget_CB(toggleB_make_alive,(XtPointer)ID_toggleB_make_alive,NULL);
  XtAddCallback(toggleB_make_alive,XmNvalueChangedCallback,start_alive_CB,NULL);
  XtManageChild(toggleB_make_alive);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Spiking units (%): ");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 20); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_prob_spike = XmCreateLabel(form_nucl_para_other,
					"label_prob_spike",
					args, 
					ac);
  register_widget_CB(label_prob_spike,(XtPointer)ID_label_prob_spike,NULL);
  XtManageChild(label_prob_spike);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 220); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNwidth, 80); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_prob_spike = XmCreateTextField(form_nucl_para_other,
					"textF_prob_spike",
					args, 
					ac);

  register_widget_CB( textF_prob_spike,(XtPointer)ID_textF_prob_spike,NULL);
  XtManageChild(textF_prob_spike);
  
  xmstring = XmStringCreateLocalized("Last spike from (oldest)");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 20); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_old_last_spike = XmCreateLabel(form_nucl_para_other,
					"label_old_last_spike",
					args, 
					ac);
  register_widget_CB(label_old_last_spike,(XtPointer)ID_label_old_last_spike,NULL);
  XtManageChild(label_old_last_spike);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 220); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNwidth, 80); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_old_last_spike = XmCreateTextField(form_nucl_para_other,
					"textF_old_last_spike",
					args, 
					ac);

  register_widget_CB( textF_old_last_spike,(XtPointer)ID_textF_old_last_spike,NULL);
  XtManageChild(textF_old_last_spike);
  
  xmstring = XmStringCreateLocalized(" to (ms): ");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 20); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_recent_last_spike = XmCreateLabel(form_nucl_para_other,
					"label_recent_last_spike",
					args, 
					ac);
  register_widget_CB(label_recent_last_spike,(XtPointer)ID_label_recent_last_spike,NULL);
  XtManageChild(label_recent_last_spike);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 220); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNwidth, 80); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_recent_last_spike = XmCreateTextField(form_nucl_para_other,
					"textF_recent_last_spike",
					args, 
					ac);

  register_widget_CB( textF_recent_last_spike,(XtPointer)ID_textF_recent_last_spike,NULL);
  XtManageChild(textF_recent_last_spike);

  /****/

  
  xmstring = XmStringCreateLocalized("Mb potential from");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 20); ac++;
  XtSetArg(args[ac], XmNy, 130); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_low_mb_pot = XmCreateLabel(form_nucl_para_other,
					"label_low_mb_pot",
					args, 
					ac);
  register_widget_CB(label_low_mb_pot,(XtPointer)ID_label_low_mb_pot,NULL);
  XtManageChild(label_low_mb_pot);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 220); ac++;
  XtSetArg(args[ac], XmNy, 130); ac++;
  XtSetArg(args[ac], XmNwidth, 80); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_low_mb_pot = XmCreateTextField(form_nucl_para_other,
					"textF_low_mb_pot",
					args, 
					ac);

  register_widget_CB( textF_low_mb_pot,(XtPointer)ID_textF_low_mb_pot,NULL);
  XtManageChild(textF_low_mb_pot);
  
  xmstring = XmStringCreateLocalized(" to (mV): ");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 20); ac++;
  XtSetArg(args[ac], XmNy, 130); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_up_mb_pot = XmCreateLabel(form_nucl_para_other,
					"label_up_mb_pot",
					args, 
					ac);
  register_widget_CB(label_up_mb_pot,(XtPointer)ID_label_up_mb_pot,NULL);
  XtManageChild(label_up_mb_pot);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 220); ac++;
  XtSetArg(args[ac], XmNy, 130); ac++;
  XtSetArg(args[ac], XmNwidth, 80); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_up_mb_pot = XmCreateTextField(form_nucl_para_other,
					"textF_up_mb_pot",
					args, 
					ac);

  register_widget_CB( textF_up_mb_pot,(XtPointer)ID_textF_up_mb_pot,NULL);
  XtManageChild(textF_up_mb_pot);


  /*****************************************************************************/

  /*
   * Fenetre de modulation surajoutee
   */

  /************************* troisieme panneau *********************************/
  ac = 0;
  XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 283); ac++;
  form_nucl_modulation = XmCreateForm(form_nucl_para_w,
				      "form_nucl_modulation",
				      args, 
				      ac);
  register_widget_CB(form_nucl_modulation,(XtPointer)ID_form_nucl_modulation,NULL);
  
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 520); ac++;
  XtSetArg(args[ac], XmNy, 200); ac++;
  XtSetArg(args[ac], XmNwidth, 150); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_nucl_modul_phase = XmCreateTextField(form_nucl_modulation,
					     "textF_nucl_modul_phase",
					     args, 
					     ac);
  register_widget_CB(textF_nucl_modul_phase,(XtPointer)ID_textF_nucl_modul_phase,NULL);
  XtManageChild(textF_nucl_modul_phase);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 520); ac++;
  XtSetArg(args[ac], XmNy, 140); ac++;
  XtSetArg(args[ac], XmNwidth, 150); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_nucl_modul_amp = XmCreateTextField(form_nucl_modulation,
					   "textF_nucl_modul_amp",
					   args, 
					   ac); 
  register_widget_CB(textF_nucl_modul_amp,(XtPointer)ID_textF_nucl_modul_amp,NULL);
  XtManageChild(textF_nucl_modul_amp);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 520); ac++;
  XtSetArg(args[ac], XmNy, 260); ac++;
  XtSetArg(args[ac], XmNwidth, 150); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_nucl_modul_nb = XmCreateTextField(form_nucl_modulation,
					   "textF_nucl_modul_nb",
					   args, 
					   ac); 
  register_widget_CB(textF_nucl_modul_nb,(XtPointer)ID_textF_nucl_modul_nb,NULL);
  XtManageChild(textF_nucl_modul_nb);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 520); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNwidth, 150); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_nucl_modul_period = XmCreateTextField(form_nucl_modulation,
					      "textF_nucl_modul_period",
					      args, 
					      ac);
  register_widget_CB(textF_nucl_modul_period,(XtPointer)ID_textF_nucl_modul_period,NULL);
  XtManageChild(textF_nucl_modul_period);
  
  xmstring = XmStringCreateLocalized("Amplitude of modulation (mV)\nor Amplitude of pulses (mV):");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 250); ac++;
  XtSetArg(args[ac], XmNy, 140); ac++;
  XtSetArg(args[ac], XmNwidth, 250); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_nucl_modul_amp = XmCreateLabel(form_nucl_modulation,
				       "label_nucl_modul_amp",
				       args, 
				       ac);
  XtManageChild(label_nucl_modul_amp);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Phase (ms):\nor Pulse duration (ms):");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 250); ac++;
  XtSetArg(args[ac], XmNy, 200); ac++;
  XtSetArg(args[ac], XmNwidth, 250); ac++;
  XtSetArg(args[ac], XmNheight, 35); ac++;
  label_nucl_modul_phase = XmCreateLabel(form_nucl_modulation,
					 "label_nucl_modul_phase",
					 args, 
					 ac);
  XtManageChild(label_nucl_modul_phase);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Period (ms):\nor Time between pulse trains (ms):");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 250); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNwidth, 250); ac++;
  /*  XtSetArg(args[ac], XmNheight, 35); ac++;*/
  label_nucl_modul_period = XmCreateLabel(form_nucl_modulation,
					  "label_nucl_modul_period",
					  args, 
					  ac);
  XtManageChild(label_nucl_modul_period);
  XmStringFree(xmstring);
  
  
  xmstring = XmStringCreateLocalized("Number of pulses/pulse train:");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 250); ac++;
  XtSetArg(args[ac], XmNy, 260); ac++;
  XtSetArg(args[ac], XmNwidth, 250); ac++;
  /*  XtSetArg(args[ac], XmNheight, 35); ac++;*/
  label_nucl_modul_nb = XmCreateLabel(form_nucl_modulation,
					  "label_nucl_modul_nb",
					  args, 
					  ac);
  XtManageChild(label_nucl_modul_nb);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNisHomogeneous, False); ac++;
  XtSetArg(args[ac], XmNx, 30); ac++;
  XtSetArg(args[ac], XmNy, 80); ac++;
  XtSetArg(args[ac], XmNwidth, 217); ac++;
  XtSetArg(args[ac], XmNheight, 147); ac++;
  radioBox2 = XmCreateRadioBox(form_nucl_modulation,
			       "radioBox2",
			       args, 
			       ac);
  XtManageChild(radioBox2);
  
  xmstring = XmStringCreateLocalized("No modulation");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNset, True); ac++;
  XtSetArg(args[ac], XmNwidth, 211); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_modul_none = XmCreateToggleButton(radioBox2,
						 "toggleB_nucl_modul_none",
						 args, 
						 ac);
  register_widget_CB(toggleB_nucl_modul_none,(XtPointer)ID_toggleB_nucl_modul_none,NULL);
  XtManageChild(toggleB_nucl_modul_none);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Sinusoidal modulation");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNwidth, 211); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_modul_sin = XmCreateToggleButton(radioBox2,
						"toggleB_nucl_modul_sin",
						args, 
						ac);
  register_widget_CB(toggleB_nucl_modul_sin,(XtPointer)ID_toggleB_nucl_modul_sin,NULL);
  XtManageChild(toggleB_nucl_modul_sin);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Triangular modulation");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNwidth, 211); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_modul_triangle = XmCreateToggleButton(radioBox2,
						     "toggleB_nucl_modul_triangle",
						     args, 
						     ac);
  register_widget_CB(toggleB_nucl_modul_triangle,(XtPointer)ID_toggleB_nucl_modul_triangle,NULL);
  XtManageChild(toggleB_nucl_modul_triangle);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Rectangular modulation");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNwidth, 211); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_modul_rect = XmCreateToggleButton(radioBox2,
						 "toggleB_nucl_modul_rect",
						 args, 
						 ac);
  register_widget_CB(toggleB_nucl_modul_rect,(XtPointer)ID_toggleB_nucl_modul_rect,NULL);
  XtManageChild(toggleB_nucl_modul_rect);
  XmStringFree(xmstring);

  xmstring = XmStringCreateLocalized("Single pulse or pulse train");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNwidth, 211); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_modul_pulse = XmCreateToggleButton(radioBox2,
						 "toggleB_nucl_modul_pulse",
						 args, 
						 ac);
  register_widget_CB(toggleB_nucl_modul_pulse,(XtPointer)ID_toggleB_nucl_modul_pulse,NULL);
  XtManageChild(toggleB_nucl_modul_pulse);
  XmStringFree(xmstring);

  
  xmstring = XmStringCreateLocalized("Periodic modulation [ A f(t + phase) ]\nor Stimulation by a series of pulse trains");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 732); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label = XmCreateLabel(form_nucl_modulation,
			"label",
			args, 
			ac);
  XtManageChild(label);
  XmStringFree(xmstring);
  
  /**********************************************************************************/

  /*
   * Fenetre du bruit
   */

  /******************************** deuxieme panneau ********************************/
  ac = 0;
  XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 283); ac++;
  form_nucl_para_noise = XmCreateForm(form_nucl_para_w,
				      "form_nucl_para_noise",
				      args, 
				      ac);
  register_widget_CB(form_nucl_para_noise,(XtPointer)ID_form_nucl_para_noise,NULL);
  
  
  xmstring = XmStringCreateLocalized("Standard deviation:");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 227); ac++;
  XtSetArg(args[ac], XmNy, 170); ac++;
  XtSetArg(args[ac], XmNwidth, 168); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_nucl_noise_sd = XmCreateLabel(form_nucl_para_noise,
				      "label_nucl_noise_sd",
				      args, 
				      ac);
  XtManageChild(label_nucl_noise_sd);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Mean value:");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 256); ac++;
  XtSetArg(args[ac], XmNy, 79); ac++;
  XtSetArg(args[ac], XmNwidth, 161); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_nucl_noise_m = XmCreateLabel(form_nucl_para_noise,
				     "label_nucl_noise_m",
				     args, 
				     ac);
  XtManageChild(label_nucl_noise_m);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNisHomogeneous, False); ac++;
  XtSetArg(args[ac], XmNorientation, XmVERTICAL); ac++;
  XtSetArg(args[ac], XmNentryAlignment, XmALIGNMENT_BEGINNING); ac++;
  XtSetArg(args[ac], XmNpacking, XmPACK_COLUMN); ac++;
  XtSetArg(args[ac], XmNx, 29); ac++;
  XtSetArg(args[ac], XmNy, 108); ac++;
  XtSetArg(args[ac], XmNwidth, 250); ac++;
  XtSetArg(args[ac], XmNheight, 76); ac++;
  radioBox4 = XmCreateRadioBox(form_nucl_para_noise,
			       "radioBox4",
			       args, 
			       ac);
  XtManageChild(radioBox4);
  
  xmstring = XmStringCreateLocalized("No noise");
  ac = 0;
  XtSetArg(args[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNset, True); ac++;
  XtSetArg(args[ac], XmNwidth, 250); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_noise_none = XmCreateToggleButton(radioBox4,
						 "toggleB_nucl_noise_none",
						 args, 
						 ac);
  register_widget_CB(toggleB_nucl_noise_none,(XtPointer)ID_toggleB_nucl_noise_none,NULL);
  XtManageChild(toggleB_nucl_noise_none);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Noise present (no filter)");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
  XtSetArg(args[ac], XmNwidth, 250); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_noise_active = XmCreateToggleButton(radioBox4,
						   "toggleB_nucl_noise_active",
						   args, 
						   ac);
  register_widget_CB(toggleB_nucl_noise_active,(XtPointer)ID_toggleB_nucl_noise_active,NULL);
  XtManageChild(toggleB_nucl_noise_active);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 439); ac++;
  XtSetArg(args[ac], XmNy, 170); ac++;
  XtSetArg(args[ac], XmNwidth, 198); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_nucl_noise_sd = XmCreateTextField(form_nucl_para_noise,
					  "textF_nucl_noise_sd",
					  args, 
					  ac);
  register_widget_CB(textF_nucl_noise_sd,(XtPointer)ID_textF_nucl_noise_sd,NULL);
  XtManageChild(textF_nucl_noise_sd);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 439); ac++;
  XtSetArg(args[ac], XmNy, 79); ac++;
  XtSetArg(args[ac], XmNwidth, 198); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_nucl_noise_m = XmCreateTextField(form_nucl_para_noise,
					 "textF_nucl_noise_m",
					 args, 
					 ac);
  register_widget_CB(textF_nucl_noise_m,(XtPointer)ID_textF_nucl_noise_m,NULL);
  XtManageChild(textF_nucl_noise_m);
  
  xmstring = XmStringCreateLocalized("Background noise");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 732); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_noise = XmCreateLabel(form_nucl_para_noise,
			      "label_noise",
			      args, 
			      ac);
  XtManageChild(label_noise);
  XmStringFree(xmstring);

  /************************************************************************************/

  /*
   * Stimulation of the nucleus (Spike trains)
   */

  /******************************* premier panneau ***********************************/
  ac = 0;
  XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 283); ac++;
  form_nucl_para_input = XmCreateForm(form_nucl_para_w,
				      "form_nucl_para_input",
				      args, 
				      ac);
  register_widget_CB(form_nucl_para_input,(XtPointer)ID_form_nucl_para_input,NULL);
  

  ac = 0;
  XtSetArg(args[ac], XmNisHomogeneous, False); ac++;
  XtSetArg(args[ac], XmNorientation, XmVERTICAL); ac++;
  XtSetArg(args[ac], XmNentryAlignment, XmALIGNMENT_CENTER); ac++;
  XtSetArg(args[ac], XmNpacking, XmPACK_COLUMN); ac++;
  XtSetArg(args[ac], XmNx, 556); ac++;
  XtSetArg(args[ac], XmNy, 110); ac++;
  XtSetArg(args[ac], XmNwidth, 161); ac++;
  XtSetArg(args[ac], XmNheight, 94); ac++;
  radioBox1 = XmCreateRadioBox(form_nucl_para_input,
			       "radioBox1",
			       args, 
			       ac);
  XtManageChild(radioBox1);
  
  xmstring = XmStringCreateLocalized("Excitation");
  ac = 0;
  XtSetArg(args[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNset, False); ac++;
  XtSetArg(args[ac], XmNwidth, 155); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_input_excit = XmCreateToggleButton(radioBox1,
						  "toggleB_nucl_input_excit",
						  args, 
						  ac);
  register_widget_CB(toggleB_nucl_input_excit,(XtPointer)ID_toggleB_nucl_input_excit,NULL);
  XtManageChild(toggleB_nucl_input_excit);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Inhibition");
  ac = 0;
  XtSetArg(args[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNwidth, 155); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_input_inhib = XmCreateToggleButton(radioBox1,
						  "toggleB_nucl_input_inhib",
						  args, 
						  ac); 
  register_widget_CB(toggleB_nucl_input_inhib,(XtPointer)ID_toggleB_nucl_input_inhib,NULL);
  XtManageChild(toggleB_nucl_input_inhib);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 381); ac++;
  XtSetArg(args[ac], XmNy, 198); ac++;
  XtSetArg(args[ac], XmNwidth, 124); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_input_scale_factor = XmCreateTextField(form_nucl_para_input,
					       "textF_input_scale_factor",
					       args, 
					       ac);    
  register_widget_CB(textF_input_scale_factor,(XtPointer)ID_textF_input_scale_factor,NULL);
  XtManageChild(textF_input_scale_factor);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 381); ac++;
  XtSetArg(args[ac], XmNy, 136); ac++;
  XtSetArg(args[ac], XmNwidth, 124); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_input_sd = XmCreateTextField(form_nucl_para_input,
				     "textF_input_sd",
				     args, 
				     ac);
  register_widget_CB(textF_input_sd,(XtPointer)ID_textF_input_sd,NULL);
  XtManageChild(textF_input_sd);
  
  ac = 0;
  XtSetArg(args[ac], XmNx, 381); ac++;
  XtSetArg(args[ac], XmNy, 74); ac++;
  XtSetArg(args[ac], XmNwidth, 124); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  textF_input_period_m = XmCreateTextField(form_nucl_para_input,
					   "textF_input_period_m",
					   args, 
					   ac);
  register_widget_CB(textF_input_period_m,(XtPointer)ID_textF_input_period_m,NULL);
  XtManageChild(textF_input_period_m);
  
  xmstring = XmStringCreateLocalized("Input weight:");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 227); ac++;
  XtSetArg(args[ac], XmNy, 198); ac++;
  XtSetArg(args[ac], XmNwidth, 139); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_input_scale_factor = XmCreateLabel(form_nucl_para_input,
					   "label_input_scale_factor",
					   args, 
					   ac);
  XtManageChild(label_input_scale_factor);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Standard deviation:");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 190); ac++;
  XtSetArg(args[ac], XmNy, 136); ac++;
  XtSetArg(args[ac], XmNwidth, 169); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_input_deviation = XmCreateLabel(form_nucl_para_input,
					"label_input_deviation",
					args, 
					ac);
  XtManageChild(label_input_deviation);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Mean period (ms):");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 220); ac++;
  XtSetArg(args[ac], XmNy, 74); ac++;
  XtSetArg(args[ac], XmNwidth, 161); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_input_period_m = XmCreateLabel(form_nucl_para_input,
				       "label_input_period_m",
				       args, 
				       ac);
  XtManageChild(label_input_period_m);
  XmStringFree(xmstring);
  
  ac = 0;
  XtSetArg(args[ac], XmNisHomogeneous, False); ac++;
  XtSetArg(args[ac], XmNx, 7); ac++;
  XtSetArg(args[ac], XmNy, 74); ac++;
  XtSetArg(args[ac], XmNwidth, 154); ac++;
  XtSetArg(args[ac], XmNheight, 184); ac++;
  radioBox = XmCreateRadioBox(form_nucl_para_input,
			      "radioBox",
			      args, 
			      ac);
  XtManageChild(radioBox);
  
  xmstring = XmStringCreateLocalized("No stimulation");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNset, True); ac++;
  XtSetArg(args[ac], XmNwidth, 168); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_input_none = XmCreateToggleButton(radioBox,
						 "toggleB_nucl_input_none",
						 args, 
						 ac);
  register_widget_CB(toggleB_nucl_input_none,(XtPointer)ID_toggleB_nucl_input_none,NULL);
  XtManageChild(toggleB_nucl_input_none);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Regular periodic");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNwidth, 168); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_input_reg = XmCreateToggleButton(radioBox,
						"toggleB_nucl_input_reg",
						args, 
						ac);    
  register_widget_CB(toggleB_nucl_input_reg,(XtPointer)ID_toggleB_nucl_input_reg,NULL);
  XtManageChild(toggleB_nucl_input_reg);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Gaussian process");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNwidth, 168); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_input_gauss = XmCreateToggleButton(radioBox,
						  "toggleB_nucl_input_gauss",
						  args, 
						  ac);
  
  register_widget_CB(toggleB_nucl_input_gauss,(XtPointer)ID_toggleB_nucl_input_gauss,NULL);
  XtManageChild(toggleB_nucl_input_gauss);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Gamma process");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNwidth, 168); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_input_gamma = XmCreateToggleButton(radioBox,
						  "toggleB_nucl_input_gamma",
						  args, 
						  ac);    
  register_widget_CB(toggleB_nucl_input_gamma,(XtPointer)ID_toggleB_nucl_input_gamma,NULL);
  XtManageChild(toggleB_nucl_input_gamma);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Poisson process");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNwidth, 168); ac++;
  XtSetArg(args[ac], XmNheight, 33); ac++;
  toggleB_nucl_input_poisson = XmCreateToggleButton(radioBox,
						    "toggleB_nucl_input_poisson",
						    args, 
						    ac);    
  register_widget_CB(toggleB_nucl_input_poisson,(XtPointer)ID_toggleB_nucl_input_poisson,NULL);
  XtManageChild(toggleB_nucl_input_poisson);
  XmStringFree(xmstring);
  
  xmstring = XmStringCreateLocalized("Stimulation by a train of spikes of given distribution");
  ac = 0;
  XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
  XtSetArg(args[ac], XmNx, 0); ac++;
  XtSetArg(args[ac], XmNy, 0); ac++;
  XtSetArg(args[ac], XmNwidth, 832); ac++;
  XtSetArg(args[ac], XmNheight, 40); ac++;
  label_input = XmCreateLabel(form_nucl_para_input,
			      "label_input",
			      args, 
			      ac);
  XtManageChild(label_input);
  XmStringFree(xmstring);



  /* les boutons de bas le fenetre */

  /* attachement des widgets */


  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopWidget, form_nucl_para_w); ac++;
  XtSetArg(args[ac], XmNtopOffset, 2); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 70); ac++;
  XtSetArg(args[ac], XmNleftOffset, 2); ac++;
  XtSetArg(args[ac], XmNrightOffset, 2); ac++;
  XtSetValues(separator5, args, ac);
  

  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopWidget, separator5); ac++;
  XtSetArg(args[ac], XmNtopOffset, 4); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 4); ac++;
  XtSetArg(args[ac], XmNleftOffset, 4); ac++;
  XtSetArg(args[ac], XmNrightOffset, 4); ac++;
  XtSetValues(form_nucl_para_ctrl, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_WIDGET); ac++;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightWidget, pushB_ok_nucl); ac++;
  XtSetArg(args[ac], XmNtopOffset, 10); ac++;
  XtSetArg(args[ac], XmNrightOffset, 40); ac++;
  XtSetValues(option_stim_nucl, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_WIDGET); ac++;
  XtSetArg(args[ac], XmNrightWidget, pushB_apply_nucl); ac++;
  XtSetArg(args[ac], XmNtopOffset, 10); ac++;
  XtSetArg(args[ac], XmNrightOffset, 40); ac++;
  XtSetValues(pushB_ok_nucl, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_WIDGET); ac++;
  XtSetArg(args[ac], XmNrightWidget, pushB_cancel_nucl); ac++;
  XtSetArg(args[ac], XmNtopOffset, 10); ac++;
  XtSetArg(args[ac], XmNrightOffset, 40); ac++;
  XtSetValues(pushB_apply_nucl, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_WIDGET); ac++;
  XtSetArg(args[ac], XmNrightWidget, pushB_help_nucl); ac++;
  XtSetArg(args[ac], XmNtopOffset, 10); ac++;
  XtSetArg(args[ac], XmNrightOffset, 40); ac++;
  XtSetValues(pushB_cancel_nucl, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 10); ac++;
  XtSetArg(args[ac], XmNrightOffset, 10); ac++;
  XtSetValues(pushB_help_nucl, args, ac);
  
  /**********************************/



  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 4); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 80); ac++;
  XtSetArg(args[ac], XmNleftOffset, 4); ac++;
  XtSetArg(args[ac], XmNrightOffset, 4); ac++;
  XtSetValues(form_nucl_para_w, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(form_nucl_para_other, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 81); ac++;
  XtSetArg(args[ac], XmNleftPosition, 60); ac++;
  XtSetArg(args[ac], XmNrightPosition, 78); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_hebb_factor, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 81); ac++;
  XtSetArg(args[ac], XmNleftPosition, 15); ac++;
  XtSetArg(args[ac], XmNrightPosition, 45); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_learning_factor, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 60); ac++;
  XtSetArg(args[ac], XmNleftPosition, 16); ac++;
  XtSetArg(args[ac], XmNrightPosition, 81); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(toggleB_weight_fluct, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopPosition, 48); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_nucl_dynamic, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopPosition, 45); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(separator3, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 8); ac++;
  XtSetArg(args[ac], XmNleftPosition, 16); ac++;
  XtSetArg(args[ac], XmNrightPosition, 82); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(toggleB_make_alive, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 25); ac++;
  XtSetArg(args[ac], XmNleftPosition, 2); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_prob_spike, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 25); ac++;
  XtSetArg(args[ac], XmNleftPosition, 20); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_prob_spike, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 20); ac++;
  XtSetArg(args[ac], XmNleftPosition, 35); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_old_last_spike, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 20); ac++;
  XtSetArg(args[ac], XmNleftPosition, 60); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_old_last_spike, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 20); ac++;
  XtSetArg(args[ac], XmNleftPosition, 70); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_recent_last_spike, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 20); ac++;
  XtSetArg(args[ac], XmNleftPosition, 85); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_recent_last_spike, args, ac);
  
  /***/
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 30); ac++;
  XtSetArg(args[ac], XmNleftPosition, 35); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_low_mb_pot, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 30); ac++;
  XtSetArg(args[ac], XmNleftPosition, 60); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_low_mb_pot, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 30); ac++;
  XtSetArg(args[ac], XmNleftPosition, 70); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_up_mb_pot, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNtopPosition, 30); ac++;
  XtSetArg(args[ac], XmNleftPosition, 85); ac++;
  XtSetArg(args[ac], XmNrightPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_up_mb_pot, args, ac);
  
  /***/
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopPosition, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_nucl_init, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(form_nucl_modulation, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 140); ac++;
  XtSetArg(args[ac], XmNleftOffset, 250); ac++;
  XtSetValues(label_nucl_modul_amp, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 200); ac++;
  XtSetArg(args[ac], XmNleftOffset, 250); ac++;
  XtSetValues(label_nucl_modul_phase, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 80); ac++;
  XtSetArg(args[ac], XmNleftOffset, 250); ac++;
  XtSetValues(label_nucl_modul_period, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 80); ac++;
  XtSetArg(args[ac], XmNleftOffset, 30); ac++;
  XtSetValues(radioBox2, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(form_nucl_para_noise, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 60); ac++;
  XtSetArg(args[ac], XmNleftPosition, 31); ac++;
  XtSetArg(args[ac], XmNrightPosition, 54); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_nucl_noise_sd, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 28); ac++;
  XtSetArg(args[ac], XmNleftPosition, 35); ac++;
  XtSetArg(args[ac], XmNrightPosition, 57); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_nucl_noise_m, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 60); ac++;
  XtSetArg(args[ac], XmNleftPosition, 60); ac++;
  XtSetArg(args[ac], XmNrightPosition, 87); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_nucl_noise_sd, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 28); ac++;
  XtSetArg(args[ac], XmNleftPosition, 60); ac++;
  XtSetArg(args[ac], XmNrightPosition, 87); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_nucl_noise_m, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_noise, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 0); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(form_nucl_para_input, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 39); ac++;
  XtSetArg(args[ac], XmNbottomPosition, 72); ac++;
  XtSetArg(args[ac], XmNleftPosition, 76); ac++;
  XtSetArg(args[ac], XmNrightPosition, 98); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(radioBox1, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 70); ac++;
  XtSetArg(args[ac], XmNleftPosition, 52); ac++;
  XtSetArg(args[ac], XmNrightPosition, 69); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_input_scale_factor, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 48); ac++;
  XtSetArg(args[ac], XmNleftPosition, 52); ac++;
  XtSetArg(args[ac], XmNrightPosition, 69); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_input_sd, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 26); ac++;
  XtSetArg(args[ac], XmNleftPosition, 52); ac++;
  XtSetArg(args[ac], XmNrightPosition, 69); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(textF_input_period_m, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 70); ac++;
  XtSetArg(args[ac], XmNleftPosition, 31); ac++;
  XtSetArg(args[ac], XmNrightPosition, 50); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_input_scale_factor, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 48); ac++;
  XtSetArg(args[ac], XmNleftPosition, 26); ac++;
  XtSetArg(args[ac], XmNrightPosition, 49); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_input_deviation, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 26); ac++;
  XtSetArg(args[ac], XmNleftPosition, 30); ac++;
  XtSetArg(args[ac], XmNrightPosition, 52); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_input_period_m, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
  XtSetArg(args[ac], XmNtopPosition, 26); ac++;
  XtSetArg(args[ac], XmNbottomPosition, 91); ac++;
  XtSetArg(args[ac], XmNleftPosition, 1); ac++;
  XtSetArg(args[ac], XmNrightPosition, 22); ac++;
  XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(radioBox, args, ac);
  
  ac = 0;
  XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
  XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
  XtSetArg(args[ac], XmNtopOffset, 0); ac++;
  XtSetArg(args[ac], XmNleftOffset, 0); ac++;
  XtSetArg(args[ac], XmNrightOffset, 0); ac++;
  XtSetValues(label_input, args, ac);

  return( form_nucleus_parameters );
}

/*
 * Create the form_stimulation hierarchy of widgets.
 */

Widget   StimShell;

Widget
Createform_stimulation(parent)
     Widget parent;
{

    Arg      args[256];
    char     buffer[60];
    Cardinal ac=0;
    Cardinal cdc=0;
    Boolean  argok=False;
    Widget   form_stim_control;
    Widget   stim_close_pushB;
    Widget   stim_set_all_pushB;
    Widget   stim_clear_all_pushB;
    Widget   stim_separator2;
    Widget   stim_scrolledWindow;
    Widget   stim_label1;
    Widget   stim_label2;
    Widget   stim_label3;
    Widget   stim_label4;
    Widget   stim_label5;
    Widget   stim_separator1;
    Widget   stim_label;
    Widget   stim_form1;

    /*
     * Register the converters for the widgets.
     */
    RegisterBxConverters(XtWidgetToApplicationContext(parent));
    XtInitializeWidgetClass(xmFormWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmSeparatorWidgetClass);
    XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);

    /*
    ac = 0;
    XtSetArg(args[ac], XmNtitle, "Stimulation Control Panel"); ac++;
    XtSetArg(args[ac], XmNx, 655); ac++;
    XtSetArg(args[ac], XmNy, 435); ac++;
    XtSetArg(args[ac], XmNwidth, 633); ac++;
    XtSetArg(args[ac], XmNheight, 308); ac++;


    StimShell = XtAppCreateShell( BX_APP_NAME, BX_APP_CLASS,
				  applicationShellWidgetClass, the_display, args, ac);
    */
	   
	 	/* windows creation */   

    ac = 0;
    XtSetArg(args[ac], XmNtitle, "Stimulation Control Panel"); ac++;
    XtSetArg(args[ac], XmNx, 655); ac++;
    XtSetArg(args[ac], XmNy, 435); ac++;
    XtSetArg(args[ac], XmNwidth, 633); ac++;
    XtSetArg(args[ac], XmNheight, 308); ac++;

    form_stim_control = XtCreatePopupShell("stim_topLevelShell",
        topLevelShellWidgetClass,
        parent,
        args,
        ac);

    /*
    form_stim_control = XtAppCreateShell( BX_APP_NAME, BX_APP_CLASS,
				  applicationShellWidgetClass, the_display, args, ac);
    */
	 
    ac = 0;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 511); ac++;
    XtSetArg(args[ac], XmNwidth, 633); ac++;
    XtSetArg(args[ac], XmNheight, 308); ac++;
    stim_form1 = XmCreateForm(form_stim_control,
			      "stim_form1",
			      args,
			      ac);

    ac = 0;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(stim_form1, "Close",
        XmRXmString, 0, &argok)); if (argok) ac++;
    XtSetArg(args[ac], XmNx, 500); ac++;
    XtSetArg(args[ac], XmNy, 259); ac++;
    XtSetArg(args[ac], XmNwidth, 100); ac++;
    XtSetArg(args[ac], XmNheight, 34); ac++;
    stim_close_pushB = XmCreatePushButton(stim_form1,
        "stim_close_pushB",
        args,
        ac);

    register_widget_CB( stim_close_pushB,(XtPointer)ID_pushB_close_stim,NULL);
    XtAddCallback(stim_close_pushB, XmNactivateCallback,stim_close_CB,
		(XtPointer)ID_pushB_close_stim);

    XtManageChild(stim_close_pushB);

    ac = 0;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(stim_form1, "Start all",
        XmRXmString, 0, &argok)); if (argok) ac++;
    XtSetArg(args[ac], XmNx, 40); ac++;
    XtSetArg(args[ac], XmNy, 259); ac++;
    XtSetArg(args[ac], XmNwidth, 100); ac++;
    XtSetArg(args[ac], XmNheight, 34); ac++;
    stim_set_all_pushB = XmCreatePushButton(stim_form1,
        "stim_set_all_pushB",
        args,
        ac);

    register_widget_CB( stim_set_all_pushB,(XtPointer)ID_pushB_set_all_stim,NULL);
    XtAddCallback(stim_set_all_pushB, XmNactivateCallback,stim_set_all_CB,
		(XtPointer)ID_pushB_set_all_stim);

    XtManageChild(stim_set_all_pushB);

    ac = 0;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(stim_form1, "Stop all",
        XmRXmString, 0, &argok)); if (argok) ac++;
    XtSetArg(args[ac], XmNx, 180); ac++;
    XtSetArg(args[ac], XmNy, 259); ac++;
    XtSetArg(args[ac], XmNwidth, 100); ac++;
    XtSetArg(args[ac], XmNheight, 34); ac++;
    stim_clear_all_pushB = XmCreatePushButton(stim_form1,
        "stim_clear_all_pushB",
        args,
        ac);

    register_widget_CB( stim_clear_all_pushB,(XtPointer)ID_pushB_clear_all_stim,NULL);
    XtAddCallback(stim_clear_all_pushB, XmNactivateCallback,stim_clear_all_CB,
		(XtPointer)ID_pushB_clear_all_stim);

    XtManageChild(stim_clear_all_pushB);


    ac = 0;
    XtSetArg(args[ac], XmNx, 10); ac++;
    XtSetArg(args[ac], XmNy, 228); ac++;
    XtSetArg(args[ac], XmNwidth, 517); ac++;
    XtSetArg(args[ac], XmNheight, 20); ac++;
    stim_separator2 = XmCreateSeparator(stim_form1,
        "stim_separator2",
        args,
        ac);
    XtManageChild(stim_separator2);

    ac = 0;
    XtSetArg(args[ac], XmNscrollingPolicy, XmAUTOMATIC); ac++;
    XtSetArg(args[ac], XmNx, 10); ac++;
    XtSetArg(args[ac], XmNy, 70); ac++;
    XtSetArg(args[ac], XmNwidth, 613); ac++;
    XtSetArg(args[ac], XmNheight, 154); ac++;
    stim_scrolledWindow = XmCreateScrolledWindow(stim_form1,
        "stim_scrolledWindow",
        args,
        ac);
    XtManageChild(stim_scrolledWindow);

    ac = 0;
    XtSetArg(args[ac], XmNnumColumns, (simu->nb_nucleus + 1)); ac++;
    XtSetArg(args[ac], XmNorientation, XmHORIZONTAL); ac++;
    XtSetArg(args[ac], XmNpacking, XmPACK_COLUMN); ac++;
    XtSetArg(args[ac], XmNwidth, 583); ac++;
    XtSetArg(args[ac], XmNheight, 31); ac++;
    stim_rowColumn = XmCreateRowColumn(stim_scrolledWindow,
        "stim_rowColumn",
        args,
        ac);
    XtManageChild(stim_rowColumn);

    register_widget_CB(stim_rowColumn,(XtPointer)ID_rowcol_stim,NULL);

    ac = 0;
    XtSetArg(args[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(form_stim_control, "Nucleus name",
        XmRXmString, 0, &argok)); if (argok) ac++;
    XtSetArg(args[ac], XmNwidth, 117); ac++;
    XtSetArg(args[ac], XmNheight, 25); ac++;
    stim_label1 = XmCreateLabel(stim_rowColumn,
        "stim_label1",
        args,
        ac);
    XtManageChild(stim_label1);

    ac = 0;
    XtSetArg(args[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(form_stim_control, "Noise",
        XmRXmString, 0, &argok)); if (argok) ac++;
    XtSetArg(args[ac], XmNwidth, 117); ac++;
    XtSetArg(args[ac], XmNheight, 25); ac++;
    stim_label2 = XmCreateLabel(stim_rowColumn,
        "stim_label2",
        args,
        ac);
    XtManageChild(stim_label2);

    ac = 0;
    XtSetArg(args[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(form_stim_control, "Pulse trains",
        XmRXmString, 0, &argok)); if (argok) ac++;
    XtSetArg(args[ac], XmNwidth, 117); ac++;
    XtSetArg(args[ac], XmNheight, 25); ac++;
    stim_label3 = XmCreateLabel(stim_rowColumn,
        "stim_label3",
        args,
        ac);
    XtManageChild(stim_label3);

    ac = 0;
    XtSetArg(args[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(form_stim_control, "Modulation",
        XmRXmString, 0, &argok)); if (argok) ac++;
    XtSetArg(args[ac], XmNwidth, 117); ac++;
    XtSetArg(args[ac], XmNheight, 25); ac++;
    stim_label4 = XmCreateLabel(stim_rowColumn,
        "stim_label4",
        args,
        ac);
    XtManageChild(stim_label4);

    ac = 0;
    XtSetArg(args[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(form_stim_control, "Drugs",
        XmRXmString, 0, &argok)); if (argok) ac++;
    XtSetArg(args[ac], XmNwidth, 117); ac++;
    XtSetArg(args[ac], XmNheight, 25); ac++;
    stim_label5 = XmCreateLabel(stim_rowColumn,
        "stim_label5",
        args,
        ac);
    XtManageChild(stim_label5);

    ac = 0;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 50); ac++;
    XtSetArg(args[ac], XmNwidth, 533); ac++;
    XtSetArg(args[ac], XmNheight, 20); ac++;
    stim_separator1 = XmCreateSeparator(stim_form1,
        "stim_separator1",
        args,
        ac);
    XtManageChild(stim_separator1);

    ac = 0;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(form_stim_control, "Stimulation Control Panel\n(Blue: not stimulating, Orange: stimulating)",
        XmRXmString, 0, &argok)); if (argok) ac++;
    XtSetArg(args[ac], XmNx, 10); ac++;
    XtSetArg(args[ac], XmNy, 10); ac++;
    XtSetArg(args[ac], XmNwidth, 513); ac++;
    XtSetArg(args[ac], XmNheight, 38); ac++;
    stim_label = XmCreateLabel(stim_form1,
        "stim_label",
        args,
        ac);
    XtManageChild(stim_label);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 15); ac++;
    XtSetArg(args[ac], XmNrightOffset, 20); ac++;
    XtSetValues(stim_close_pushB, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 15); ac++;
    XtSetValues(stim_clear_all_pushB, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 15); ac++;
    XtSetValues(stim_set_all_pushB, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 60); ac++;
    XtSetArg(args[ac], XmNleftOffset, 6); ac++;
    XtSetArg(args[ac], XmNrightOffset, 6); ac++;
    XtSetValues(stim_separator2, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 70); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 84); ac++;
    XtSetArg(args[ac], XmNleftOffset, 10); ac++;
    XtSetArg(args[ac], XmNrightOffset, 10); ac++;
    XtSetValues(stim_scrolledWindow, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 50); ac++;
    XtSetArg(args[ac], XmNleftOffset, 6); ac++;
    XtSetArg(args[ac], XmNrightOffset, 6); ac++;
    XtSetValues(stim_separator1, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 10); ac++;
    XtSetArg(args[ac], XmNrightOffset, 10); ac++;
    XtSetValues(stim_label, args, ac);

    XtManageChild(stim_form1);

    /* Begin user code block <end_Createform1> */
    
    /*
    XtRealizeWidget(form_stim_control);

    XtPopdown(form_stim_control);
    */


    /* End user code block <end_Createform1> */
    return(form_stim_control);
}
#endif






