#define _CREATION_SIMU_2_

/*
 * Globally included information.
 */

#include "creation-simu.h"
#include <Xm/Protocols.h>
#include <Xm/AtomMgr.h>
#include <Xm/DrawingA.h>

/*
 * Create the sim_mainW hierarchy of widgets.
 */
Widget
Createsim_mainW(parent)
Widget parent;
{
    Arg      args[256];
    Cardinal ac=0;
    Boolean  argok=False;
    Widget   sim_mainW;
    Widget   menuBar;
    Widget   cascadeB_file;
    Widget   pulldownMenu;
    Widget   pushB_new;
    Widget   pushB_continue;
    Widget   pushB_load_simulation;
    Widget   pushB_save_simulation;
    Widget   pushB_save_state;
    Widget   pushB_close;
    Widget   separator;
    Widget   pushB_exit;
    Widget   cascadeB_edit;
    Widget   pulldownMenu0;
    Widget   pushB_P_neuron;
    Widget   pushB_G_neuron;
    Widget   separator0;
    Widget   pushB_link_edit;
    Widget   pushB_network_editor;
    Widget   cascadeB_parameters;
    Widget   pulldownMenu1;
    Widget   cascadeB_nucleus;
    Widget   pulldownM_nucleus;
    Widget   pushB_nucleus_none;
    Widget   cascadeB_clusters;
    Widget   pulldownM_clusters;
    Widget   pushB_cluster_none;
    Widget   pushB_use_ntr;
    Widget   pulldownM_Update;
    Widget   pushB_Update;

    Widget   cascadeB_simulation;
    Widget   pulldownMenu3;
    Widget   pushB_first_stop;
    Widget   pushB_last_stop;
    Widget   separator1;
    Widget   pushB_time_step;
    Widget   pushB_spike_duration;
    Widget   separator2;
    Widget   pushB_interrupt;
    Widget   pushB_run_simulation;
    Widget   pushB_STOP;
    Widget   pushB_RUN;
    Widget   cascadeB_help;
    Widget   pulldownMenu2;
    Widget   pushB_help_on_window;
    Widget   pushB_help_on_topic;
    Widget   pushB_help_browse;
    Widget   cascadeB_browsing;
    Widget   pulldownMenu8;
    Widget   toggleB_display;
    Widget   pushB_it_count;
    Widget   pushB_watch_sampling;
    Widget   pushB_save_pmb;
    Widget   cascadeB_display;
    Widget   pulldownMenu6;
    Widget   pushB_display_connecting_weights;
    Widget   pushB_display_transmission_delays;
    Widget   pushB_display_nmda_sensibity;
    Widget   separator6;
    Widget   pushB_repartition;
    Widget   cascadeB_analyses;
    Widget   pulldownMenu7;
    Widget   pushB_visu;
    Widget   separator7;
    Widget   pushB_xtms;
    Widget   pushB_xcaa;
    Widget   scrolledWindow;
    Widget   text_simulator;
    Widget	form_main;
    Widget	label_info;
    Widget	shell_iterations;
    Widget	form_iterations;
    Widget	label_iterations;
    Widget   pushB_B_neuron;
    Widget   pushB_L_neuron;
    Widget   pushB_Create_Drug_File;
    Widget   pushB_sim_default;
    Widget   pushB_silent;
    Widget   pushB_STIM;
    Widget   pushB_START_ALL;
    Widget   pushB_STOP_ALL;
    Widget   main_stop_pushB;
    Widget   main_stop_text;

    Widget   cascadeB_outputs;
    Widget   pulldownMenu9;
    Widget   pushB_abe_f;
    Widget   pushB_tms_f;
    Widget   pushB_sim_f;
    Widget   pushB_pmb_f;
    Widget   pushB_gnp_f;

#if ADD_NEW_MODEL
/***************** TO ADD A MODEL COPY AND ADAPT **************/
    Widget   pushB_X_neuron;
/***********************       STOP     ***********************/
#endif

    char 	buffer[256];
    XmString	xmstring;
    XmString	xmstring2;

    Atom        WM_DELETE_WINDOW;

    /*
     * Register the converters for the widgets.
     */
    RegisterBxConverters(XtWidgetToApplicationContext(parent)); 
    XtInitializeWidgetClass(xmMainWindowWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmCascadeButtonWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmSeparatorWidgetClass);
    XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
    XtInitializeWidgetClass(xmTextWidgetClass);

    ac = 0;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 0); ac++;
    XtSetArg(args[ac], XmNwidth, 710); ac++;
    XtSetArg(args[ac], XmNheight, 351); ac++;
    sim_mainW = XmCreateMainWindow(parent,
				   "sim_mainW",
				   args, 
				   ac);
    register_widget_CB(sim_mainW,(XtPointer)ID_sim_mainW,NULL);

    WM_DELETE_WINDOW = XmInternAtom(XtDisplay(sim_mainW), "WM_DELETE_WINDOW", False);
    XmAddWMProtocolCallback(parent, WM_DELETE_WINDOW, sim_activate_CB,(XtPointer)ID_pushB_kill);
    XtAddCallback(parent,XmNdestroyCallback,sim_activate_CB,(XtPointer)ID_pushB_kill);
    
    ac = 0;
    XtSetArg(args[ac], XmNwidth, 710); ac++;
    XtSetArg(args[ac], XmNheight, 39); ac++;
    menuBar = XmCreateMenuBar(sim_mainW,
			      "menuBar",
			      args, 
			      ac);
    XtManageChild(menuBar);
    
    /*
     * Menu File
     */

	xmstring = XmStringCreateLocalized("File");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'F'); ac++;
    XtSetArg(args[ac], XmNx, 5); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 44); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    cascadeB_file = XmCreateCascadeButton(menuBar,
					  "cascadeB_file",
					  args, 
					  ac);
    XtManageChild(cascadeB_file);
    XmStringFree(xmstring);

    ac = 0;
    XtSetArg(args[ac], XmNx, 319); ac++;
    XtSetArg(args[ac], XmNy, 262); ac++;
    XtSetArg(args[ac], XmNwidth, 263); ac++;
    XtSetArg(args[ac], XmNheight, 151); ac++;
    pulldownMenu = XmCreatePulldownMenu(XtParent(cascadeB_file),
					"pulldownMenu",
					args, 
					ac);

    xmstring = XmStringCreateLocalized("New simulation...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'N'); ac++;
    pushB_new = XmCreatePushButton(pulldownMenu,
				   "pushB_new",
				   args, 
				   ac);
    register_widget_CB(pushB_new,(XtPointer)ID_pushB_new,NULL);
    create_event_CB(pushB_new,(XtPointer)ID_pushB_new,NULL);
    XtAddCallback(pushB_new,XmNactivateCallback,sim_activate_CB,(XtPointer)ID_pushB_new);
    XtManageChild(pushB_new);
    XmStringFree(xmstring);

    xmstring = XmStringCreateLocalized("continue eXisting simulation...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'X'); ac++;
    pushB_continue = XmCreatePushButton(pulldownMenu,
					"pushB_continue",
					args, 
					ac);
    register_widget_CB(pushB_continue,(XtPointer)ID_pushB_continue,NULL);
    create_event_CB(pushB_continue,(XtPointer)ID_pushB_continue,NULL);
    XtAddCallback(pushB_continue,XmNactivateCallback,sim_activate_CB,(XtPointer)ID_pushB_continue);
    
    XtManageChild(pushB_continue);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Load simulation parameters...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'L'); ac++;
    pushB_load_simulation = XmCreatePushButton(pulldownMenu,
					       "pushB_load_simulation",
					       args, 
					       ac);
    register_widget_CB(pushB_load_simulation,(XtPointer)ID_pushB_load_simulation,NULL);
    create_event_CB(pushB_load_simulation,(XtPointer)ID_pushB_load_simulation,NULL);
    XtAddCallback(pushB_load_simulation,XmNactivateCallback,sim_activate_CB,(XtPointer)ID_pushB_load_simulation);
    
    XtManageChild(pushB_load_simulation);
    XmStringFree(xmstring);
    
    
    xmstring = XmStringCreateLocalized("Save simulation parameters...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'S'); ac++;
    pushB_save_simulation = XmCreatePushButton(pulldownMenu,
					       "pushB_save_simulation",
					       args, 
					       ac);
    register_widget_CB(pushB_save_simulation,(XtPointer)ID_pushB_save_simulation,NULL);
    create_event_CB(pushB_save_simulation,(XtPointer)ID_pushB_save_simulation,NULL);
    XtAddCallback(pushB_save_simulation,XmNactivateCallback,sim_activate_CB,(XtPointer)ID_pushB_save_simulation);
    
    XtManageChild(pushB_save_simulation);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("sAve simulation files...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'A'); ac++;
    pushB_save_state = XmCreatePushButton(pulldownMenu,
					  "pushB_save_state",
					  args, 
					  ac);
    register_widget_CB(pushB_save_state,(XtPointer)ID_pushB_save_state,NULL);
    create_event_CB(pushB_save_state,(XtPointer)ID_pushB_save_state,NULL);
    XtAddCallback(pushB_save_state,XmNactivateCallback,sim_activate_CB,(XtPointer)ID_pushB_save_state);
    
    XtManageChild(pushB_save_state);
    XmStringFree(xmstring);

    xmstring = XmStringCreateLocalized("Save files and exit simulator");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'C'); ac++;
    pushB_close = XmCreatePushButton(pulldownMenu,
				     "pushB_close",
				     args, 
				     ac);
    register_widget_CB(pushB_close,(XtPointer)ID_pushB_close,NULL);
    create_event_CB(pushB_close,(XtPointer)ID_pushB_close,NULL);
    XtAddCallback(pushB_close,XmNactivateCallback,sim_activate_CB,(XtPointer)ID_pushB_close);
    
    XtManageChild(pushB_close);
    XmStringFree(xmstring);
    
    ac = 0;
    separator = XmCreateSeparator(pulldownMenu,
				  "separator",
				  args, 
				  ac);
    XtManageChild(separator);
    

    xmstring = XmStringCreateLocalized("Exit simulator");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'E'); ac++;
    pushB_exit = XmCreatePushButton(pulldownMenu,
				    "pushB_exit",
				    args, 
				    ac);
    register_widget_CB(pushB_exit,(XtPointer)ID_pushB_exit,NULL);
    create_event_CB(pushB_exit,(XtPointer)ID_pushB_exit,NULL);
    XtAddCallback(pushB_exit,XmNactivateCallback,sim_activate_CB,(XtPointer)ID_pushB_exit);
    
    XtManageChild(pushB_exit);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu); ac++;
    XtSetValues(cascadeB_file, args, ac);
    
  /*
     * Menu Edit
     */
    
    
    xmstring = XmStringCreateLocalized("Modify");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'M'); ac++;
    XtSetArg(args[ac], XmNx, 255); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 75); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    cascadeB_edit = XmCreateCascadeButton(menuBar,
					  "cascadeB_edit",
					  args, 
					  ac);
    XtManageChild(cascadeB_edit);
    XmStringFree(xmstring);
    
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 569); ac++;
    XtSetArg(args[ac], XmNy, 262); ac++;
    XtSetArg(args[ac], XmNwidth, 278); ac++;
    XtSetArg(args[ac], XmNheight, 122); ac++;
    pulldownMenu0 = XmCreatePulldownMenu(XtParent(cascadeB_edit),
					 "pulldownMenu0",
					 args, 
					 ac);

    xmstring = XmStringCreateLocalized("PUM neuron");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'P'); ac++;
    pushB_P_neuron = XmCreatePushButton(pulldownMenu0,
					"pushB_P_neuron",
					args, 
					ac);
    register_widget_CB(pushB_P_neuron,(XtPointer)ID_pushB_P_neuron,NULL);
    create_event_CB(pushB_P_neuron,(XtPointer)ID_pushB_P_neuron,NULL);
    XtAddCallback(pushB_P_neuron,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_P_neuron);
    XtManageChild(pushB_P_neuron);
    XmStringFree(xmstring);
    

    xmstring = XmStringCreateLocalized("LIM neuron");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'L'); ac++;
    pushB_L_neuron = XmCreatePushButton(pulldownMenu0,
					"pushB_L_neuron",
					args, 
					ac);
    register_widget_CB(pushB_L_neuron,(XtPointer)ID_pushB_L_neuron,NULL);
    create_event_CB(pushB_L_neuron,(XtPointer)ID_pushB_L_neuron,NULL);
    XtAddCallback(pushB_L_neuron,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_L_neuron);
    XtManageChild(pushB_L_neuron);
    XmStringFree(xmstring);
    
#if ADD_NEW_MODEL
/*************** TO ADD A MODEL COPY THIS AND ADAPT *************/

    xmstring = XmStringCreateLocalized("XXX neuron");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'X'); ac++;
    pushB_X_neuron = XmCreatePushButton(pulldownMenu0,
					"pushB_X_neuron",
					args, 
					ac);
    register_widget_CB(pushB_X_neuron,(XtPointer)ID_pushB_X_neuron,NULL);
    create_event_CB(pushB_X_neuron,(XtPointer)ID_pushB_X_neuron,NULL);
    XtAddCallback(pushB_X_neuron,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_X_neuron);
    XtManageChild(pushB_X_neuron);
    XmStringFree(xmstring);
    
/************************ STOP **********************************/
#endif

    xmstring = XmStringCreateLocalized("BUM neuron");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'B'); ac++;
    pushB_B_neuron = XmCreatePushButton(pulldownMenu0,
					"pushB_B_neuron",
					args, 
					ac);
    register_widget_CB(pushB_B_neuron,(XtPointer)ID_pushB_B_neuron,NULL);
    create_event_CB(pushB_B_neuron,(XtPointer)ID_pushB_B_neuron,NULL);
    XtAddCallback(pushB_B_neuron,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_B_neuron);
    XtManageChild(pushB_B_neuron);
    XmStringFree(xmstring);
    

    xmstring = XmStringCreateLocalized("CBM neuron");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'C'); ac++;
    pushB_G_neuron = XmCreatePushButton(pulldownMenu0,
					"pushB_G_neuron",
					args, 
					ac);
    register_widget_CB(pushB_G_neuron,(XtPointer)ID_pushB_G_neuron,NULL);
    create_event_CB(pushB_G_neuron,(XtPointer)ID_pushB_G_neuron,NULL);
    XtAddCallback(pushB_G_neuron,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_G_neuron);
    XtManageChild(pushB_G_neuron);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Create Drug File...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'D'); ac++;
    pushB_Create_Drug_File = XmCreatePushButton(pulldownMenu0,
						"pushB_create_drug_file",
						args,  
						ac);
    register_widget_CB(pushB_Create_Drug_File,(XtPointer)ID_pushB_Create_Drug_File,NULL);
    create_event_CB(pushB_Create_Drug_File,(XtPointer)ID_pushB_Create_Drug_File,NULL);
    XtAddCallback(pushB_Create_Drug_File,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_Create_Drug_File);
    
    XtManageChild(pushB_Create_Drug_File);
    XmStringFree(xmstring);
    




     ac = 0;
    separator0 = XmCreateSeparator(pulldownMenu0,
				   "separator0",
				   args, 
				   ac);
    XtManageChild(separator0);
    xmstring = XmStringCreateLocalized("Simple network");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'S'); ac++;
    pushB_link_edit = XmCreatePushButton(pulldownMenu0,
					 "pushB_link_edit",
					 args, 
					 ac);
    register_widget_CB(pushB_link_edit,(XtPointer)ID_pushB_link_edit,NULL);
    create_event_CB(pushB_link_edit,(XtPointer)ID_pushB_link_edit,NULL);
    XtAddCallback(pushB_link_edit,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_link_edit);
    XtManageChild(pushB_link_edit);
    XmStringFree(xmstring);
    

    xmstring = XmStringCreateLocalized("Detailed network");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'D'); ac++;
    pushB_network_editor = XmCreatePushButton(pulldownMenu0,
					      "pushB_network_editor",
					      args, 
					      ac);
    register_widget_CB(pushB_network_editor,(XtPointer)ID_pushB_network_editor,NULL);
    create_event_CB(pushB_network_editor,(XtPointer)ID_pushB_network_editor,NULL);
    XtAddCallback(pushB_network_editor,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_network_editor);
    XtManageChild(pushB_network_editor);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu0); ac++;
    XtSetValues(cascadeB_edit, args, ac);

    /*
     * Menu Parametres
     */

    xmstring = XmStringCreateLocalized("Parameters");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'P'); ac++;
    XtSetArg(args[ac], XmNx, 49); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 104); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    cascadeB_parameters = XmCreateCascadeButton(menuBar,
						"cascadeB_parameters",
						args, 
						ac);
    XtManageChild(cascadeB_parameters);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 363); ac++;
    XtSetArg(args[ac], XmNy, 262); ac++;
    XtSetArg(args[ac], XmNwidth, 117); ac++;
    XtSetArg(args[ac], XmNheight, 62); ac++;
    pulldownMenu1 = XmCreatePulldownMenu(XtParent(cascadeB_parameters),
					 "pulldownMenu1",
					 args, 
					 ac);
    

    xmstring = XmStringCreateLocalized("Nucleus...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'N'); ac++;
    cascadeB_nucleus = XmCreateCascadeButton(pulldownMenu1,
					     "cascadeB_nucleus",
					     args, 
					     ac);
    register_widget_CB(cascadeB_nucleus,(XtPointer)ID_cascadeB_nucleus,NULL);
    create_event_CB(cascadeB_nucleus,(XtPointer)ID_cascadeB_nucleus,NULL);
    XtManageChild(cascadeB_nucleus);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 474); ac++;
    XtSetArg(args[ac], XmNy, 269); ac++;
    XtSetArg(args[ac], XmNwidth, 98); ac++;
    XtSetArg(args[ac], XmNheight, 33); ac++;
    pulldownM_nucleus = XmCreatePulldownMenu(XtParent(cascadeB_nucleus),
        "pulldownM_nucleus",
        args, 
        ac);
    register_widget_CB(pulldownM_nucleus,(XtPointer)ID_pulldownM_nucleus,NULL);

  

    xmstring = XmStringCreateLocalized("None");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNsensitive, False);ac++;    
    pushB_nucleus_none = XmCreatePushButton(pulldownM_nucleus,
					    "pushB_nucleus_none",
					    args, 
					    ac);
    register_widget_CB(pushB_nucleus_none,(XtPointer)ID_pushB_nucleus_none,NULL);
    XtManageChild(pushB_nucleus_none);
    XmStringFree(xmstring);
    
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownM_nucleus); ac++;
    XtSetValues(cascadeB_nucleus, args, ac);
    
    xmstring = XmStringCreateLocalized("Clusters...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'C'); ac++;
    cascadeB_clusters = XmCreateCascadeButton(pulldownMenu1,
					      "cascadeB_clusters",
					      args, 
					      ac);
    register_widget_CB(cascadeB_clusters,(XtPointer)ID_cascadeB_clusters,NULL);
    create_event_CB(cascadeB_clusters,(XtPointer)ID_cascadeB_clusters,NULL);
    XtManageChild(cascadeB_clusters);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 474); ac++;
    XtSetArg(args[ac], XmNy, 298); ac++;
    XtSetArg(args[ac], XmNwidth, 129); ac++;
    XtSetArg(args[ac], XmNheight, 33); ac++;
    pulldownM_clusters = XmCreatePulldownMenu(XtParent(cascadeB_clusters),
					      "pulldownM_clusters",
					      args, 
					      ac);
    register_widget_CB(pulldownM_clusters,(XtPointer)ID_pulldownM_clusters,NULL);



    xmstring = XmStringCreateLocalized("None");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNsensitive, False);ac++; 
    pushB_cluster_none = XmCreatePushButton(pulldownM_clusters,
					    "pushB_cluster_none",
					    args, 
					    ac);
    register_widget_CB(pushB_cluster_none,(XtPointer)ID_pushB_cluster_none,NULL);

    XtManageChild(pushB_cluster_none);
    XmStringFree(xmstring);
    
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownM_clusters); ac++;
    XtSetValues(cascadeB_clusters, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu1); ac++;
    XtSetValues(cascadeB_parameters, args, ac);
 /********************************************/

	xmstring = XmStringCreateLocalized("Use neurotransmitors");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'u'); ac++;
    pushB_use_ntr = XmCreateToggleButton(pulldownMenu1,
				    "pushB_use_ntr",
				    args, 
				    ac);
    register_widget_CB(pushB_use_ntr,(XtPointer)ID_pushB_use_ntr,NULL);
    create_event_CB(pushB_use_ntr,(XtPointer)ID_pushB_use_ntr,NULL);
    XtAddCallback(pushB_use_ntr,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_use_ntr);
    XtManageChild(pushB_use_ntr);
    XmStringFree(xmstring);

    /********************************************/

    xmstring = XmStringCreateLocalized("Update Network");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'U'); ac++;
    pushB_Update = XmCreateCascadeButton(pulldownMenu1,
					      "pushB_Update",
					      args, 
					      ac);
    register_widget_CB(pushB_Update,(XtPointer)ID_pushB_Update,NULL);
    create_event_CB(pushB_Update,(XtPointer)ID_pushB_Update,NULL);
    XtAddCallback(pushB_Update,XmNactivateCallback,sim_activate_CB,(XtPointer)ID_pushB_Update);
    XtManageChild(pushB_Update);
    XmStringFree(xmstring);
 

    /********************************************/

    xmstring = XmStringCreateLocalized("Default simulation param.");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'D'); ac++;
    pushB_sim_default = XmCreateCascadeButton(pulldownMenu1,
					      "pushB_sim_default",
					      args, 
					      ac);
    register_widget_CB(pushB_sim_default,(XtPointer)ID_pushB_sim_default,NULL);
    create_event_CB(pushB_sim_default,(XtPointer)ID_pushB_sim_default,NULL);
    XtAddCallback(pushB_sim_default,XmNactivateCallback,sim_activate_CB,(XtPointer)ID_pushB_sim_default);
    XtManageChild(pushB_sim_default);
    XmStringFree(xmstring);

    /********************************************/
    
    /*
     * Menu Simulation
     */
        
    xmstring = XmStringCreateLocalized("Simulation");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'S'); ac++;
    XtSetArg(args[ac], XmNx, 153); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 102); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    cascadeB_simulation = XmCreateCascadeButton(menuBar,
						"cascadeB_simulation",
						args, 
						ac);
    XtManageChild(cascadeB_simulation);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 467); ac++;
    XtSetArg(args[ac], XmNy, 262); ac++;
    XtSetArg(args[ac], XmNwidth, 239); ac++;
    XtSetArg(args[ac], XmNheight, 182); ac++;
    pulldownMenu3 = XmCreatePulldownMenu(XtParent(cascadeB_simulation),
					 "pulldownMenu3",
					 args, 
					 ac);
    
    xmstring = XmStringCreateLocalized("Time between stops...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'N'); ac++;
    pushB_first_stop = XmCreatePushButton(pulldownMenu3,
					  "pushB_first_stop",
					  args, 
					  ac);
    register_widget_CB(pushB_first_stop,(XtPointer)ID_pushB_first_stop,NULL);
    create_event_CB(pushB_first_stop,(XtPointer)ID_pushB_first_stop,NULL);
    XtAddCallback(pushB_first_stop,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_first_stop);
    XtManageChild(pushB_first_stop);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Last stop...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'L'); ac++;
    pushB_last_stop = XmCreatePushButton(pulldownMenu3,
					 "pushB_last_stop",
					 args, 
					 ac);
    register_widget_CB(pushB_last_stop,(XtPointer)ID_pushB_last_stop,NULL);
    create_event_CB(pushB_last_stop,(XtPointer)ID_pushB_last_stop,NULL);
    XtAddCallback(pushB_last_stop,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_last_stop);

    XtManageChild(pushB_last_stop);
    XmStringFree(xmstring);
    
    ac = 0;
    separator1 = XmCreateSeparator(pulldownMenu3,
				   "separator1",
				   args, 
				   ac);
    XtManageChild(separator1);
    
    xmstring = XmStringCreateLocalized("Time step...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'T'); ac++;
    pushB_time_step = XmCreatePushButton(pulldownMenu3,
					 "pushB_time_step",
					 args, 
					 ac);
    register_widget_CB(pushB_time_step,(XtPointer)ID_pushB_time_step,NULL);
    create_event_CB(pushB_time_step,(XtPointer)ID_pushB_time_step,NULL);
    XtAddCallback(pushB_time_step,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_time_step);
    
    XtManageChild(pushB_time_step);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Spike duration...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'S'); ac++;
    pushB_spike_duration = XmCreatePushButton(pulldownMenu3,
					      "pushB_spike_duration",
					      args, 
					      ac);
    register_widget_CB(pushB_spike_duration,(XtPointer)ID_pushB_spike_duration,NULL);
    create_event_CB(pushB_spike_duration,(XtPointer)ID_pushB_spike_duration,NULL);
    XtAddCallback(pushB_spike_duration,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_spike_duration);
    XtManageChild(pushB_spike_duration);
    XmStringFree(xmstring);
    
    ac = 0;
    separator2 = XmCreateSeparator(pulldownMenu3,
				   "separator2",
				   args, 
				   ac); 

    XtManageChild(separator2);
    
    xmstring = XmStringCreateLocalized("Interrupt simulation");
    xmstring2 = XmStringCreateLocalized("Ctrl-i");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'I'); ac++;
    XtSetArg(args[ac], XmNaccelerator, "Ctrl<Key>i"); ac++;
    XtSetArg(args[ac], XmNacceleratorText, xmstring2); ac++;
    pushB_interrupt = XmCreatePushButton(pulldownMenu3,
        "pushB_interrupt",
					 args, 
					 ac);
    register_widget_CB(pushB_interrupt,(XtPointer)ID_pushB_interrupt,NULL);
    create_event_CB(pushB_interrupt,(XtPointer)ID_pushB_interrupt,NULL);
    XtAddCallback(pushB_interrupt,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_interrupt);
    XtManageChild(pushB_interrupt);
    XmStringFree(xmstring);
    XmStringFree(xmstring2);
    
    xmstring = XmStringCreateLocalized("Run simulation");
    xmstring2 = XmStringCreateLocalized("Ctrl-r");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'R'); ac++;
    XtSetArg(args[ac], XmNaccelerator, "Ctrl<Key>r"); ac++;
    XtSetArg(args[ac], XmNacceleratorText, xmstring2); ac++;
    pushB_run_simulation = XmCreatePushButton(pulldownMenu3,
					      "pushB_run_simulation",
					      args, 
					      ac);
    register_widget_CB(pushB_run_simulation,(XtPointer)ID_pushB_run_simulation,NULL);
    create_event_CB(pushB_run_simulation,(XtPointer)ID_pushB_run_simulation,NULL);
    XtAddCallback(pushB_run_simulation,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_run_simulation); 
    XtManageChild(pushB_run_simulation);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu3); ac++;
    XtSetValues(cascadeB_simulation, args, ac);
    
    /*
     * Menu Watch (show data during simulation)
     */
    
    xmstring = XmStringCreateLocalized("Watch");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'W'); ac++;
    XtSetArg(args[ac], XmNx, 255); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 75); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    cascadeB_browsing = XmCreateCascadeButton(menuBar,
					      "cascadeB_browsing",
					      args, 
					      ac);
    XtManageChild(cascadeB_browsing);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 569); ac++;
    XtSetArg(args[ac], XmNy, 262); ac++;
    XtSetArg(args[ac], XmNwidth, 278); ac++;
    XtSetArg(args[ac], XmNheight, 122); ac++;
    pulldownMenu8 = XmCreatePulldownMenu(XtParent(cascadeB_browsing),
					 "pulldownMenu8",
					 args, 
					 ac);
    
    xmstring = XmStringCreateLocalized("Network activity");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'D'); ac++;
    toggleB_display = XmCreateToggleButton(pulldownMenu8,
					   "toggleB_display",
					   args, 
					   ac);
    register_widget_CB(toggleB_display,(XtPointer)ID_toggleB_display,NULL);
    create_event_CB(toggleB_display,(XtPointer)ID_toggleB_display,NULL);
    XtAddCallback(toggleB_display,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_toggleB_display);
    XtManageChild(toggleB_display);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Counter (it or ms)...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'I'); ac++;
    pushB_it_count = XmCreatePushButton(pulldownMenu8,
					"pushB_it_count",
					args, 
					ac);
    register_widget_CB(pushB_it_count,(XtPointer)ID_pushB_it_count,NULL);
    create_event_CB(pushB_it_count,(XtPointer)ID_pushB_it_count,NULL);
    XtAddCallback(pushB_it_count,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_it_count);
    XtManageChild(pushB_it_count);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Watch sampling each...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'M'); ac++;
    pushB_watch_sampling = XmCreatePushButton(pulldownMenu8,
					"pushB_watch_sampling",
					args, 
					ac);
    register_widget_CB(pushB_watch_sampling,(XtPointer)ID_pushB_watch_sampling,NULL);
    create_event_CB(pushB_watch_sampling,(XtPointer)ID_pushB_watch_sampling,NULL);
    XtAddCallback(pushB_watch_sampling,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_watch_sampling);
    XtManageChild(pushB_watch_sampling);
    XmStringFree(xmstring);

#if 0    
    xmstring = XmStringCreateLocalized("Silent...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'S'); ac++;
    pushB_silent = XmCreateToggleButton(pulldownMenu8,
					"pushB_silent",
					args, 
					ac);
    register_widget_CB(pushB_silent,(XtPointer)ID_pushB_silent,NULL);
    create_event_CB(pushB_silent,(XtPointer)ID_pushB_silent,NULL);
    XtAddCallback(pushB_silent,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_silent);
    XtManageChild(pushB_silent);
    XmStringFree(xmstring);
#endif

    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu8); ac++;
    XtSetValues(cascadeB_browsing, args, ac);

    /*
     * Menu Display
     */
    
    xmstring = XmStringCreateLocalized("Display");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'D'); ac++;
    XtSetArg(args[ac], XmNx, 255); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 75); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    cascadeB_display = XmCreateCascadeButton(menuBar,
					     "cascadeB_display",
					     args, 
					     ac);
    XtManageChild(cascadeB_display);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 569); ac++;
    XtSetArg(args[ac], XmNy, 262); ac++;
    XtSetArg(args[ac], XmNwidth, 278); ac++;
    XtSetArg(args[ac], XmNheight, 122); ac++;
    pulldownMenu6 = XmCreatePulldownMenu(XtParent(cascadeB_display),
					 "pulldownMenu6",
					 args, 
					 ac);
    
    xmstring = XmStringCreateLocalized("Connecting weights");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'C'); ac++;
    pushB_display_connecting_weights = XmCreatePushButton(pulldownMenu6,
							  "pushB_display_connecting_weights",
							  args, 
							  ac);
    register_widget_CB(pushB_display_connecting_weights,(XtPointer)ID_pushB_display_connecting_weights,NULL);
    create_event_CB(pushB_display_connecting_weights,(XtPointer)ID_pushB_display_connecting_weights,NULL);
    XtAddCallback(pushB_display_connecting_weights,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_display_connecting_weights);
    XtManageChild(pushB_display_connecting_weights);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Transmission delays");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'T'); ac++;
    pushB_display_transmission_delays = XmCreatePushButton(pulldownMenu6,
							   "pushB_display_transmission_delays",
							   args, 
							   ac);
    register_widget_CB(pushB_display_transmission_delays,(XtPointer)ID_pushB_display_transmission_delays,NULL);
    create_event_CB(pushB_display_transmission_delays,(XtPointer)ID_pushB_display_transmission_delays,NULL);
    XtAddCallback(pushB_display_transmission_delays,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_display_transmission_delays);
    XtManageChild(pushB_display_transmission_delays);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Nmda and glutamate interactions");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'N'); ac++;
    pushB_display_nmda_sensibity = XmCreatePushButton(pulldownMenu6,
						      "pushB_display_nmda_sensibity",
						      args, 
						      ac);
    register_widget_CB(pushB_display_nmda_sensibity,(XtPointer)ID_pushB_display_nmda_sensibity,NULL);
    create_event_CB(pushB_display_nmda_sensibity,(XtPointer)ID_pushB_display_nmda_sensibity,NULL);
    XtAddCallback(pushB_display_nmda_sensibity,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_display_nmda_sensibity);
    XtManageChild(pushB_display_nmda_sensibity);
    XmStringFree(xmstring);
    
    ac = 0;
    separator6 = XmCreateSeparator(pulldownMenu6,
				   "separator6",
				   args, 
				   ac);
    XtManageChild(separator6);
    
    xmstring = XmStringCreateLocalized("Repartition of the neurons");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'R'); ac++;
    pushB_repartition = XmCreatePushButton(pulldownMenu6,
					   "pushB_repartition",
					   args, 
					   ac);
    register_widget_CB(pushB_repartition,(XtPointer)ID_pushB_repartition,NULL);
    create_event_CB(pushB_repartition,(XtPointer)ID_pushB_repartition,NULL);
    XtAddCallback(pushB_repartition,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_repartition);
    XtManageChild(pushB_repartition);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu6); ac++;
    XtSetValues(cascadeB_display, args, ac);

    /*
     * Menu Outputs
     */
    
    xmstring = XmStringCreateLocalized("Outputs");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'O'); ac++;
    XtSetArg(args[ac], XmNx, 255); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 75); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    XtSetArg(args[ac], XmNsensitive, True); ac++;
    cascadeB_outputs = XmCreateCascadeButton(menuBar,
					      "cascadeB_ouputs",
					      args, 
					      ac);
    register_widget_CB( cascadeB_outputs,(XtPointer)ID_cascadeB_outputs,NULL);
    XtManageChild(cascadeB_outputs);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 569); ac++;
    XtSetArg(args[ac], XmNy, 262); ac++;
    XtSetArg(args[ac], XmNwidth, 278); ac++;
    XtSetArg(args[ac], XmNheight, 122); ac++;
    pulldownMenu9 = XmCreatePulldownMenu(XtParent(cascadeB_outputs),
					 "pulldownMenu9",
					 args, 
					 ac);
    
    xmstring = XmStringCreateLocalized("tms file");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 't'); ac++;
    pushB_tms_f = XmCreateToggleButton(pulldownMenu9,
				    "pushB_tms_f",
				    args, 
				    ac);
    register_widget_CB(pushB_tms_f,(XtPointer)ID_pushB_tms_f,NULL);
    create_event_CB(pushB_tms_f,(XtPointer)ID_pushB_tms_f,NULL);
    XtAddCallback(pushB_tms_f,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_tms_f);
    XtManageChild(pushB_tms_f);
    XmStringFree(xmstring);
        
    
    xmstring = XmStringCreateLocalized("abe file");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'a'); ac++;
    pushB_abe_f = XmCreateToggleButton(pulldownMenu9,
				    "pushB_abe_f",
				    args, 
				    ac);
    register_widget_CB(pushB_abe_f,(XtPointer)ID_pushB_abe_f,NULL);
    create_event_CB(pushB_abe_f,(XtPointer)ID_pushB_abe_f,NULL);
    XtAddCallback(pushB_abe_f,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_abe_f);
    XtManageChild(pushB_abe_f);
    XmStringFree(xmstring);

    
    xmstring = XmStringCreateLocalized("pmb file");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'p'); ac++;
    pushB_pmb_f = XmCreateToggleButton(pulldownMenu9,
				    "pushB_pmb_f",
				    args, 
				    ac);
    register_widget_CB(pushB_pmb_f,(XtPointer)ID_pushB_pmb_f,NULL);
    create_event_CB(pushB_pmb_f,(XtPointer)ID_pushB_pmb_f,NULL);
    XtAddCallback(pushB_pmb_f,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_pmb_f);
    XtManageChild(pushB_pmb_f);
    XmStringFree(xmstring);

    
    xmstring = XmStringCreateLocalized("sim file");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 's'); ac++;
    pushB_sim_f = XmCreateToggleButton(pulldownMenu9,
				    "pushB_sim_f",
				    args, 
				    ac);
    register_widget_CB(pushB_sim_f,(XtPointer)ID_pushB_sim_f,NULL);
    create_event_CB(pushB_sim_f,(XtPointer)ID_pushB_sim_f,NULL);
    XtAddCallback(pushB_sim_f,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_sim_f);
    XtManageChild(pushB_sim_f);
    XmStringFree(xmstring);

    
    xmstring = XmStringCreateLocalized("gnuplot file");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'g'); ac++;
    pushB_gnp_f = XmCreateToggleButton(pulldownMenu9,
				    "pushB_gnp_f",
				    args, 
				    ac);
    register_widget_CB(pushB_gnp_f,(XtPointer)ID_pushB_gnp_f,NULL);
    create_event_CB(pushB_gnp_f,(XtPointer)ID_pushB_gnp_f,NULL);
    XtAddCallback(pushB_gnp_f,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_gnp_f);
    XtManageChild(pushB_gnp_f);
    XmStringFree(xmstring);


    xmstring = XmStringCreateLocalized("Sample mb pot each...");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'S'); ac++;
    pushB_save_pmb = XmCreatePushButton(pulldownMenu9,
					"pushB_save_pmb",
					args, 
					ac);
    register_widget_CB(pushB_save_pmb,(XtPointer)ID_pushB_save_pmb,NULL);
    create_event_CB(pushB_save_pmb,(XtPointer)ID_pushB_save_pmb,NULL);
    XtAddCallback(pushB_save_pmb,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_save_pmb);
    XtManageChild(pushB_save_pmb);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu9); ac++;
    XtSetValues(cascadeB_outputs, args, ac);

    /*
     * Menu Visualization
     */
    
    xmstring = XmStringCreateLocalized("Analysis");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'A'); ac++;
    XtSetArg(args[ac], XmNx, 255); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 75); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    XtSetArg(args[ac], XmNsensitive, False); ac++;
    cascadeB_analyses = XmCreateCascadeButton(menuBar,
					      "cascadeB_analyses",
					      args, 
					      ac);
    register_widget_CB( cascadeB_analyses,(XtPointer)ID_cascadeB_analyses,NULL);
    XtManageChild(cascadeB_analyses);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 569); ac++;
    XtSetArg(args[ac], XmNy, 262); ac++;
    XtSetArg(args[ac], XmNwidth, 278); ac++;
    XtSetArg(args[ac], XmNheight, 122); ac++;
    pulldownMenu7 = XmCreatePulldownMenu(XtParent(cascadeB_analyses),
					 "pulldownMenu7",
					 args, 
					 ac);
    
    xmstring = XmStringCreateLocalized("Visualization");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'V'); ac++;
    pushB_visu = XmCreatePushButton(pulldownMenu7,
				    "pushB_visu",
				    args, 
				    ac);
    register_widget_CB(pushB_visu,(XtPointer)ID_pushB_visu,NULL);
    create_event_CB(pushB_visu,(XtPointer)ID_pushB_visu,NULL);
    XtAddCallback(pushB_visu,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_visu);
    XtManageChild(pushB_visu);
    XmStringFree(xmstring);
    
    ac = 0;
    separator7 = XmCreateSeparator(pulldownMenu7,
				   "separator7",
				   args, 
				   ac);
    XtManageChild(separator7);
    
    xmstring = XmStringCreateLocalized("Time series");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'T'); ac++;
    pushB_xtms = XmCreatePushButton(pulldownMenu7,
				    "pushB_xtms",
				    args, 
				    ac);
    register_widget_CB(pushB_xtms,(XtPointer)ID_pushB_xtms,NULL);
    create_event_CB(pushB_xtms,(XtPointer)ID_pushB_xtms,NULL);
    XtAddCallback(pushB_xtms,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_xtms);
    XtManageChild(pushB_xtms);
    XmStringFree(xmstring);
    
    
    xmstring = XmStringCreateLocalized("Clusters activity ");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'C'); ac++;
    pushB_xcaa = XmCreatePushButton(pulldownMenu7,
				    "pushB_xcaa",
				    args, 
				    ac);
    register_widget_CB(pushB_xcaa,(XtPointer)ID_pushB_xcaa,NULL);
    create_event_CB(pushB_xcaa,(XtPointer)ID_pushB_xcaa,NULL);
    XtAddCallback(pushB_xcaa,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_xcaa);
    XtManageChild(pushB_xcaa);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu7); ac++;
    XtSetValues(cascadeB_analyses, args, ac);


    /*
     * Menu Help
     */
        
    xmstring = XmStringCreateLocalized("Help");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'H'); ac++;
    XtSetArg(args[ac], XmNx, 651); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 54); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    cascadeB_help = XmCreateCascadeButton(menuBar,
					  "cascadeB_help",
					  args, 
					  ac);
    XtManageChild(cascadeB_help);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 965); ac++;
    XtSetArg(args[ac], XmNy, 262); ac++;
    XtSetArg(args[ac], XmNwidth, 145); ac++;
    XtSetArg(args[ac], XmNheight, 62); ac++;
    pulldownMenu2 = XmCreatePulldownMenu(XtParent(cascadeB_help),
					 "pulldownMenu2",
					 args, 
					 ac);
    
    xmstring = XmStringCreateLocalized("Help on window");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'H'); ac++;
    pushB_help_on_window = XmCreatePushButton(pulldownMenu2,
					      "pushB_help_on_window",
					      args, 
					      ac);
    register_widget_CB(pushB_help_on_window,(XtPointer)ID_pushB_help_on_window,NULL);
    create_event_CB(pushB_help_on_window,(XtPointer)ID_pushB_help_on_window,NULL);
    XtAddCallback(pushB_help_on_window,XmNactivateCallback,help_CB,
		  (XtPointer)ID_pushB_help_on_window);
    XtManageChild(pushB_help_on_window);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Browse Manual");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'B'); ac++;
    pushB_help_browse = XmCreatePushButton(pulldownMenu2,
					     "pushB_help_browse",
					     args, 
					     ac);
    register_widget_CB(pushB_help_browse,(XtPointer)ID_pushB_help_browse,NULL);
    create_event_CB(pushB_help_browse,(XtPointer)ID_pushB_help_browse,NULL);
    XtAddCallback(pushB_help_browse,XmNactivateCallback,help_CB,
		  (XtPointer)ID_pushB_help_browse);
    XtManageChild(pushB_help_browse);
    XmStringFree(xmstring);

    xmstring = XmStringCreateLocalized("help on Topic");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'T'); ac++;
    pushB_help_on_topic = XmCreatePushButton(pulldownMenu2,
					     "pushB_help_on_topic",
					     args, 
					     ac);
    register_widget_CB(pushB_help_on_topic,(XtPointer)ID_pushB_help_on_topic,NULL);
    create_event_CB(pushB_help_on_topic,(XtPointer)ID_pushB_help_on_topic,NULL);
    XtAddCallback(pushB_help_on_topic,XmNactivateCallback,help_CB,
		  (XtPointer)ID_pushB_help_on_topic);
    XtManageChild(pushB_help_on_topic);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu2); ac++;
    XtSetValues(cascadeB_help, args, ac);

    /*
     * Form containing the bottom stuff
     */
    
    
    ac = 0;
    XtSetArg(args[ac], XmNwidth, 710);ac++;
    XtSetArg(args[ac], XmNheight, 312);ac++;
    form_main = XmCreateForm(sim_mainW,
			     "form_main",
			     args,
			     ac);
    XtManageChild(form_main);
    

    /*
     * Bouton STOP/RUN
     */

    xmstring = XmStringCreateLocalized("RUN");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNaccelerator, "Ctrl<Key>r"); ac++;
    XtSetArg(args[ac], XmNsensitive, False);ac++;    
    XtSetArg(args[ac], XmNresizable, False);ac++;    
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac], XmNwidth, 80); ac++;
    XtSetArg(args[ac], XmNrecomputeSize, False); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNwidth, 100); ac++;
    pushB_STOP = XmCreatePushButton(form_main,
				    "pushB_STOP",
				    args, 
				    ac);
    register_widget_CB(pushB_STOP,(XtPointer)ID_pushB_STOP,NULL);
    create_event_CB(pushB_STOP,(XtPointer)ID_pushB_run_simulation,NULL);
    XtAddCallback(pushB_STOP,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_run_simulation);
    XtManageChild(pushB_STOP);
    XmStringFree(xmstring);
    
    /*
     * Bouton STIMULATION
     */

    xmstring = XmStringCreateLocalized("Stimulation");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNaccelerator, "Ctrl<Key>t"); ac++;
    XtSetArg(args[ac], XmNsensitive, False);ac++;    
    XtSetArg(args[ac], XmNresizable, False);ac++;    
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac], XmNrecomputeSize, False); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNwidth, 120); ac++;
    pushB_STIM = XmCreatePushButton(form_main,
				    "pushB_STIM",
				    args, 
				    ac);
    register_widget_CB(pushB_STIM,(XtPointer)ID_pushB_STIM,NULL);
    create_event_CB(pushB_STIM,(XtPointer)ID_pushB_STIM,NULL);
    XtAddCallback(pushB_STIM,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_STIM);
    XtManageChild(pushB_STIM);
    XmStringFree(xmstring);
    
    /*
     * Bouton START ALL
     */

    xmstring = XmStringCreateLocalized("Start all");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNaccelerator, "Ctrl<Key>a"); ac++;
    XtSetArg(args[ac], XmNsensitive, False);ac++;    
    XtSetArg(args[ac], XmNresizable, False);ac++;    
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac], XmNrecomputeSize, False); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 130); ac++;
    XtSetArg(args[ac], XmNwidth, 100); ac++;
    pushB_START_ALL = XmCreatePushButton(form_main,
				    "pushB_START_ALL",
				    args, 
				    ac);
    register_widget_CB(pushB_START_ALL,(XtPointer)ID_pushB_START_ALL,NULL);
    create_event_CB(pushB_START_ALL,(XtPointer)ID_pushB_START_ALL,NULL);
    XtAddCallback(pushB_START_ALL,XmNactivateCallback,stim_set_all_CB,
		  (XtPointer)ID_pushB_START_ALL);
    XtManageChild(pushB_START_ALL);
    XmStringFree(xmstring);
    
    
    /*
     * Bouton STOP ALL
     */

    xmstring = XmStringCreateLocalized("Stop all");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNaccelerator, "Ctrl<Key>p"); ac++;
    XtSetArg(args[ac], XmNsensitive, False);ac++;    
    XtSetArg(args[ac], XmNresizable, False);ac++;    
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac], XmNrecomputeSize, False); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 230); ac++;
    XtSetArg(args[ac], XmNwidth, 100); ac++;
    pushB_STOP_ALL = XmCreatePushButton(form_main,
				    "pushB_STOP_ALL",
				    args, 
				    ac);
    register_widget_CB(pushB_STOP_ALL,(XtPointer)ID_pushB_STOP_ALL,NULL);
    create_event_CB(pushB_STOP_ALL,(XtPointer)ID_pushB_STOP_ALL,NULL);
    XtAddCallback(pushB_STOP_ALL,XmNactivateCallback,stim_clear_all_CB,
		  (XtPointer)ID_pushB_STOP_ALL);
    XtManageChild(pushB_STOP_ALL);
    XmStringFree(xmstring);
    
    /*
     * pushbutton et textfield pour afficher et modifier le next stop
     */

    ac = 0;
    XtSetArg(args[ac], XmNlabelString,
        CONVERT(form_main, "Next stop at:",
        XmRXmString, 0, &argok)); if (argok) ac++;

    XtSetArg(args[ac], XmNwidth, 130); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    main_stop_pushB = XmCreatePushButton(form_main,
        "main_stop_pushB",
        args,
        ac);

    register_widget_CB(main_stop_pushB,(XtPointer)ID_pushB_stop_main,NULL);
    create_event_CB(main_stop_pushB,(XtPointer)ID_pushB_stop_main,NULL);
    XtAddCallback(main_stop_pushB,  XmNactivateCallback,sim_next_stop_CB,
		(XtPointer)ID_pushB_stop_main);

    XtManageChild(main_stop_pushB);

    ac = 0;
    XtSetArg(args[ac], XmNwidth, 150); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac], XmNvalue,"1000");ac++;
    main_stop_text = XmCreateTextField(form_main,
        "main_stop_text",
        args,
        ac);

    register_widget_CB(main_stop_text,(XtPointer)ID_text_stop_main,NULL);
    create_event_CB(main_stop_text,(XtPointer)ID_text_stop_main,NULL);
    
    XtManageChild(main_stop_text);


    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftOffset, 350); ac++;
    XtSetValues(main_stop_pushB, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftOffset, 475); ac++;
    XtSetValues(main_stop_text, args, ac);

    XmTextFieldRemove(main_stop_text);
    sprintf(buffer,"%.3f ms",simu->stop_at_ms);
    XmTextReplace(main_stop_text,0,
		  XmTextGetLastPosition(main_stop_text), buffer);
    
    /*
     * Label de help en ligne
     */

    xmstring = XmStringCreateLocalized("                  No Loaded Network (*.ntw)                 ");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac], XmNrecomputeSize, False); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 40); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 80); ac++;
    label_info = XmCreateLabel(form_main,
			       "label_info",
			       args, 
			       ac);
    register_widget_CB(label_info,(XtPointer)ID_label_info,NULL);
    XtManageChild(label_info);
    XmStringFree(xmstring);
    
    ac = 0;
    sprintf(buffer,"Welcome to the version %s of the simulator for XNBC V%s Workstation.",NBC_X_VERSION,VERSION);
    XtSetArg(args[ac], XmNvalue, buffer); ac++;
    XtSetArg(args[ac], XmNeditMode, XmMULTI_LINE_EDIT); ac++;
    XtSetArg(args[ac], XmNeditable, False); ac++;
    XtSetArg(args[ac], XmNwordWrap, True); ac++;
    XtSetArg(args[ac], XmNcolumns, 80); ac++;
    XtSetArg(args[ac], XmNrows, 1); ac++;
    XtSetArg(args[ac], XmNcursorPositionVisible, False); ac++;
    XtSetArg(args[ac], XmNautoShowCursorPosition, True); ac++;
/*    XtSetArg(args[ac], XmNscrollingPolicy, XmAUTOMATIC); ac++;
    XtSetArg(args[ac], XmNvisualPolicy, XmCONSTANT); ac++;
    XtSetArg(args[ac], XmNscrollBarDisplayPolicy, XmSTATIC); ac++;*/
    XtSetArg(args[ac], XmNwidth, 710); ac++;
    XtSetArg(args[ac], XmNheight, 272); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 0); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 80); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    text_simulator = XmCreateScrolledText(form_main,
					  "text_simulator",
					  args, 
					  ac);
    register_widget_CB(text_simulator,(XtPointer)ID_text_simulator,NULL);
    XtManageChild(text_simulator);
    
    ac = 0;
    XtSetArg(args[ac], XmNmenuHelpWidget, cascadeB_help); ac++;
    XtSetValues(menuBar, args, ac);


    /*
     * Label des iterations
     */

#if 0    
        
    ac = 0;
    XtSetArg(args[ac], XmNtitle, "Iterations"); ac++;
    XtSetArg(args[ac], XmNx, 800); ac++;
    XtSetArg(args[ac], XmNy, 300); ac++;
    XtSetArg(args[ac], XmNwidth, 150); ac++;
    XtSetArg(args[ac], XmNheight, 80); ac++;
    shell_iterations = XtCreatePopupShell("shell_iterations",
					  xmDialogShellWidgetClass,
					  sim_mainW,
					  args, 
					  ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNautoUnmanage, False); ac++;
    XtSetArg(args[ac], XmNwidth, 150);ac++;
    XtSetArg(args[ac], XmNheight, 60);ac++;
    form_iterations = XmCreateForm(shell_iterations,
				   "form_iterations",
				   args,
				   ac);
    XtManageChild(form_iterations);

    xmstring = XmStringCreateLocalized(" ");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac], XmNrecomputeSize, False); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    label_iterations = XmCreateLabel(form_iterations,
				     "label_interations",
				     args, 
				     ac);
#endif

    
    xmstring = XmStringCreateLocalized("0 it");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac], XmNwidth, 80); ac++;

    XtSetArg(args[ac], XmNrecomputeSize, False); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 40); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_NONE); ac++;
    label_iterations = XmCreateLabel(form_main,
				     "label_interations",
				     args, 
				     ac);
    
    register_widget_CB(form_iterations,(XtPointer)ID_form_iterations,NULL);
    register_widget_CB(label_iterations,(XtPointer)ID_label_iterations,NULL);
    XtManageChild(label_iterations);
    XmStringFree(xmstring);

    return( sim_mainW );
}

/*
 * Create the form_cluster_parameters hierarchy of widgets.
 */
Widget
Createform_cluster_parameters(parent)
Widget parent;
{
    Arg      args[256];
    Cardinal ac=0;
    Boolean  argok=False;
    Widget   cluster_parameters;
    Widget   form_cluster_parameters;
    Widget   separator4;
    Widget   form_clu_para_ctrl;
    Widget   pushB_ok_clu;
    Widget   pushB_apply_clu;
    Widget   pushB_cancel_clu;
    Widget   pushB_help_clu;
    Widget   form_clu_para_w;
    Widget   form_cluster_general;
    Widget   textF_clu_noise_sd;
    Widget   textF_clu_noise_m;
    Widget   label_clu_noise_sd;
    Widget   label_clu_noise_m;
    Widget   radioBox5;
    Widget   toggleB_clu_noise_none;
    Widget   toggleB_clu_noise_active;
    Widget   toggleB_clu_noise_filter;
    Widget   label_noise1;
    Widget   separator8;
    Widget   label_clu_nb_neurons;
    Widget   label_neurons_in_cluster;
    Widget   pushB_file_select;
    Widget   pushB_display_info;
    Widget   pushB_reload_clusters;
    Widget   textF_cluster_file_name;
    Widget   label_cluster_file;
    XmString	xmstring;
    
    /*
     * Register the converters for the widgets.
     */
    RegisterBxConverters(XtWidgetToApplicationContext(parent)); 
    XtInitializeWidgetClass(xmDialogShellWidgetClass);
    XtInitializeWidgetClass(xmFormWidgetClass);
    XtInitializeWidgetClass(xmSeparatorWidgetClass);
    XtInitializeWidgetClass(xmFormWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    
    ac = 0;
    XtSetArg(args[ac], XmNtitle, "Cluster Parameters"); ac++;
    XtSetArg(args[ac], XmNminWidth, 740); ac++;
    XtSetArg(args[ac], XmNminHeight, 470); ac++;
    XtSetArg(args[ac], XmNiconPixmap, pixicon);  ac++;
    XtSetArg(args[ac], XmNx, 32); ac++;
    XtSetArg(args[ac], XmNy, 258); ac++;
    XtSetArg(args[ac], XmNwidth, 740); ac++;
    XtSetArg(args[ac], XmNheight, 470); ac++;
    cluster_parameters = XtCreatePopupShell("cluster_parameters",
					    xmDialogShellWidgetClass,
					    parent,
					    args, 
					    ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNautoUnmanage, False); ac++;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    XtSetArg(args[ac], XmNx, 32); ac++;
    XtSetArg(args[ac], XmNy, 258); ac++;
    XtSetArg(args[ac], XmNwidth, 740); ac++;
    XtSetArg(args[ac], XmNheight, 470); ac++;
    form_cluster_parameters = XtCreateWidget("form_cluster_parameters",
					     xmFormWidgetClass,
					     cluster_parameters,
					     args,
					     ac);      
        
    register_widget_CB(form_cluster_parameters,(XtPointer)ID_form_cluster_parameters,NULL);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 2); ac++;
    XtSetArg(args[ac], XmNy, 292); ac++;
    XtSetArg(args[ac], XmNwidth, 736); ac++;
    XtSetArg(args[ac], XmNheight, 8); ac++;
    separator4 = XmCreateSeparator(form_cluster_parameters,
				   "separator4",
				   args, 
				   ac);
    XtManageChild(separator4);
    
    ac = 0;
    XtSetArg(args[ac], XmNautoUnmanage, False); ac++;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    XtSetArg(args[ac], XmNfractionBase, 9); ac++;
    XtSetArg(args[ac], XmNx, 4); ac++;
    XtSetArg(args[ac], XmNy, 304); ac++;
    XtSetArg(args[ac], XmNwidth, 732); ac++;
    XtSetArg(args[ac], XmNheight, 62); ac++;
    form_clu_para_ctrl = XmCreateForm(form_cluster_parameters,
				      "form_clu_para_ctrl",
				      args, 
				      ac);
    XtManageChild(form_clu_para_ctrl);
    
    xmstring = XmStringCreateLocalized("OK");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 90); ac++;
    XtSetArg(args[ac], XmNy, 10); ac++;
    XtSetArg(args[ac], XmNwidth, 73); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    pushB_ok_clu = XmCreatePushButton(form_clu_para_ctrl,
				      "pushB_ok_clu",
				      args, 
				      ac);
    register_widget_CB(pushB_ok_clu,(XtPointer)ID_pushB_ok_clu,NULL);
    create_event_CB(pushB_ok_clu,(XtPointer)ID_pushB_ok_clu,NULL);
    XtAddCallback(pushB_ok_clu,XmNactivateCallback,clu_para_activate_CB,
		  (XtPointer)ID_pushB_ok_clu);
    XtManageChild(pushB_ok_clu);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Apply");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 244); ac++;
    XtSetArg(args[ac], XmNy, 10); ac++;
    XtSetArg(args[ac], XmNwidth, 81); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    pushB_apply_clu = XmCreatePushButton(form_clu_para_ctrl,
        "pushB_apply_clu",
        args, 
        ac);
    register_widget_CB(pushB_apply_clu,(XtPointer)ID_pushB_apply_clu,NULL);
    create_event_CB(pushB_apply_clu,(XtPointer)ID_pushB_apply_clu,NULL);
    XtAddCallback(pushB_apply_clu,XmNactivateCallback,clu_para_activate_CB,
		(XtPointer)ID_pushB_apply_clu);
    XtManageChild(pushB_apply_clu);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Cancel");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 407); ac++;
    XtSetArg(args[ac], XmNy, 10); ac++;
    XtSetArg(args[ac], XmNwidth, 81); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    pushB_cancel_clu = XmCreatePushButton(form_clu_para_ctrl,
        "pushB_cancel_clu",
        args, 
        ac);
    register_widget_CB(pushB_cancel_clu,(XtPointer)ID_pushB_cancel_clu,NULL);
    create_event_CB(pushB_cancel_clu,(XtPointer)ID_pushB_cancel_clu,NULL);
    XtAddCallback(pushB_cancel_clu,XmNactivateCallback,clu_para_activate_CB,
		(XtPointer)ID_pushB_cancel_clu);
    XtManageChild(pushB_cancel_clu);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Help");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 569); ac++;
    XtSetArg(args[ac], XmNy, 10); ac++;
    XtSetArg(args[ac], XmNwidth, 82); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    pushB_help_clu = XmCreatePushButton(form_clu_para_ctrl,
        "pushB_help_clu",
        args, 
        ac);
    register_widget_CB(pushB_help_clu,(XtPointer)ID_pushB_help_clu,NULL);
    create_event_CB(pushB_help_clu,(XtPointer)ID_pushB_help_clu,NULL);
    XtAddCallback(pushB_help_clu,XmNactivateCallback,help_CB,
		(XtPointer)ID_pushB_help_clu);
    XtManageChild(pushB_help_clu);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNborderWidth, 0); ac++;
    XtSetArg(args[ac], XmNautoUnmanage, False); ac++;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    XtSetArg(args[ac], XmNfractionBase, 9); ac++;
    XtSetArg(args[ac], XmNx, 4); ac++;
    XtSetArg(args[ac], XmNy, 4); ac++;
    XtSetArg(args[ac], XmNwidth, 732); ac++;
    XtSetArg(args[ac], XmNheight, 286); ac++;
    form_clu_para_w = XmCreateForm(form_cluster_parameters,
        "form_clu_para_w",
        args, 
        ac);
    XtManageChild(form_clu_para_w);
    
    ac = 0;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 0); ac++;
    XtSetArg(args[ac], XmNwidth, 732); ac++;
    XtSetArg(args[ac], XmNheight, 286); ac++;
    form_cluster_general = XmCreateForm(form_clu_para_w,
        "form_cluster_general",
        args, 
        ac);
    register_widget_CB(form_cluster_general,(XtPointer)ID_form_cluster_general,NULL);
    XtManageChild(form_cluster_general);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 425); ac++;
    XtSetArg(args[ac], XmNy, 229); ac++;
    XtSetArg(args[ac], XmNwidth, 197); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    textF_clu_noise_sd = XmCreateTextField(form_cluster_general,
        "textF_clu_noise_sd",
        args, 
        ac);
    register_widget_CB(textF_clu_noise_sd,(XtPointer)ID_textF_clu_noise_sd,NULL);
    
    XtManageChild(textF_clu_noise_sd);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 425); ac++;
    XtSetArg(args[ac], XmNy, 177); ac++;
    XtSetArg(args[ac], XmNwidth, 197); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    textF_clu_noise_m = XmCreateTextField(form_cluster_general,
        "textF_clu_noise_m",
        args, 
        ac);
    register_widget_CB(textF_clu_noise_m,(XtPointer)ID_textF_clu_noise_m,NULL);
    
    XtManageChild(textF_clu_noise_m);
    
    xmstring = XmStringCreateLocalized("Standard deviation:");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 198); ac++;
    XtSetArg(args[ac], XmNy, 229); ac++;
    XtSetArg(args[ac], XmNwidth, 168); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    label_clu_noise_sd = XmCreateLabel(form_cluster_general,
				       "label_clu_noise_sd",
				       args, 
				       ac);
    XtManageChild(label_clu_noise_sd);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Mean value:");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 227); ac++;
    XtSetArg(args[ac], XmNy, 177); ac++;
    XtSetArg(args[ac], XmNwidth, 161); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    label_clu_noise_m = XmCreateLabel(form_cluster_general,
				      "label_clu_noise_m",
				      args, 
				      ac);
    XtManageChild(label_clu_noise_m);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNisHomogeneous, False); ac++;
    XtSetArg(args[ac], XmNorientation, XmVERTICAL); ac++;
    XtSetArg(args[ac], XmNentryAlignment, XmALIGNMENT_BEGINNING); ac++;
    XtSetArg(args[ac], XmNpacking, XmPACK_COLUMN); ac++;
    XtSetArg(args[ac], XmNx, 15); ac++;
    XtSetArg(args[ac], XmNy, 110); ac++;
    XtSetArg(args[ac], XmNwidth, 600); ac++;
    XtSetArg(args[ac], XmNheight, 78); ac++;
    XtSetArg(args[ac],XmNrightAttachment, XmATTACH_POSITION);ac++;
    XtSetArg(args[ac],XmNleftAttachment, XmATTACH_POSITION);ac++;
    XtSetArg(args[ac], XmNrightPosition, 2);ac++;
    XtSetArg(args[ac], XmNleftPosition, 50);ac++;
    radioBox5 = XmCreateRadioBox(form_cluster_general,
				 "radioBox5",
				 args, 
				 ac);
    XtManageChild(radioBox5);
    
    xmstring = XmStringCreateLocalized("No noise");
    ac = 0;
    XtSetArg(args[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNset, True); ac++;
    XtSetArg(args[ac], XmNwidth, 600); ac++;
    XtSetArg(args[ac], XmNheight, 33); ac++;
    toggleB_clu_noise_none = XmCreateToggleButton(radioBox5,
						  "toggleB_clu_noise_none",
						  args, 
						  ac);
    register_widget_CB(toggleB_clu_noise_none,(XtPointer)ID_toggleB_clu_noise_none,NULL);
    XtManageChild(toggleB_clu_noise_none);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Gaussian white noise");
    ac = 0;
    XtSetArg(args[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNwidth, 400); ac++;
    XtSetArg(args[ac], XmNheight, 33); ac++;
    toggleB_clu_noise_active = XmCreateToggleButton(radioBox5,
						    "toggleB_clu_noise_active",
						    args, 
						    ac);
    register_widget_CB(toggleB_clu_noise_active,(XtPointer)ID_toggleB_clu_noise_active,NULL);

    XtManageChild(toggleB_clu_noise_active);
    XmStringFree(xmstring);
    
    
    xmstring = XmStringCreateLocalized("Kohn colored noise");
    ac = 0;
    XtSetArg(args[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNwidth, 400); ac++;
    XtSetArg(args[ac], XmNheight, 33); ac++;
    toggleB_clu_noise_filter = XmCreateToggleButton(radioBox5,
						    "toggleB_clu_noise_filter",
						    args, 
						    ac);
    register_widget_CB(toggleB_clu_noise_filter,(XtPointer)ID_toggleB_clu_noise_filter,NULL);

    XtManageChild(toggleB_clu_noise_filter);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Background noise");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 129); ac++;
    XtSetArg(args[ac], XmNwidth, 732); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    label_noise1 = XmCreateLabel(form_cluster_general,
				 "label_noise1",
				 args, 
				 ac);
    XtManageChild(label_noise1);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 120); ac++;
    XtSetArg(args[ac], XmNwidth, 732); ac++;
    XtSetArg(args[ac], XmNheight, 10); ac++;
    separator8 = XmCreateSeparator(form_cluster_general,
				   "separator8",
				   args, 
				   ac);
    XtManageChild(separator8);
    
    xmstring = XmStringCreateLocalized("Number of neuron(s)");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 220); ac++;
    XtSetArg(args[ac], XmNy, 80); ac++;
    XtSetArg(args[ac], XmNwidth, 168); ac++;
    XtSetArg(args[ac], XmNheight, 35); ac++;
    label_clu_nb_neurons = XmCreateLabel(form_cluster_general,
					 "label_clu_nb_neurons",
					 args, 
					 ac);
    register_widget_CB(label_clu_nb_neurons,(XtPointer)ID_label_clu_nb_neurons,NULL);

    XtManageChild(label_clu_nb_neurons);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Neuron population:");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 80); ac++;
    XtSetArg(args[ac], XmNwidth, 205); ac++;
    XtSetArg(args[ac], XmNheight, 35); ac++;
    label_neurons_in_cluster = XmCreateLabel(form_cluster_general,
					     "label_neurons_in_cluster",
					     args, 
					     ac);
    XtManageChild(label_neurons_in_cluster);
    XmStringFree(xmstring);
    

    xmstring = XmStringCreateLocalized("File selection");
    ac = 0;    
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 610); ac++;
    XtSetArg(args[ac], XmNy, 17); ac++;
    XtSetArg(args[ac], XmNwidth, 150); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac],XmNleftAttachment, XmATTACH_POSITION);ac++;
    XtSetArg(args[ac],XmNrightAttachment, XmATTACH_POSITION);ac++;
    XtSetArg(args[ac], XmNleftPosition, 81);ac++;
    XtSetArg(args[ac], XmNrightPosition, 98);ac++;
    pushB_file_select = XmCreatePushButton(form_cluster_general,
					   "pushB_file_select",
					   args, 
					   ac);
    register_widget_CB(pushB_file_select,(XtPointer)ID_pushB_file_select,NULL);
    create_event_CB(pushB_file_select,(XtPointer)ID_pushB_file_select,NULL);
    XtAddCallback(pushB_file_select,XmNactivateCallback,clu_para_activate_CB,
		  (XtPointer)ID_pushB_file_select);
    XtManageChild(pushB_file_select);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Reload");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 610); ac++;
    XtSetArg(args[ac], XmNy, 57); ac++;
    XtSetArg(args[ac], XmNwidth, 170); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNtopWidget,pushB_file_select ); ac++;
    XtSetArg(args[ac], XmNtopOffset, 5 ); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac],XmNrightAttachment, XmATTACH_POSITION);ac++;
    XtSetArg(args[ac],XmNleftAttachment, XmATTACH_POSITION);ac++;
    XtSetArg(args[ac], XmNrightPosition, 98);ac++;
    XtSetArg(args[ac], XmNleftPosition, 75);ac++;
    pushB_reload_clusters = XmCreatePushButton(form_cluster_general,
					       "pushB_reload_clusters",
					       args, 
					       ac);
    register_widget_CB(pushB_reload_clusters,(XtPointer)ID_pushB_reload,NULL);
    create_event_CB(pushB_reload_clusters,(XtPointer)ID_pushB_reload,NULL);
    XtAddCallback(pushB_reload_clusters,XmNactivateCallback,clu_para_activate_CB,
		  (XtPointer)ID_pushB_reload);
    XtManageChild(pushB_reload_clusters);
    XmStringFree(xmstring);
    
    xmstring = XmStringCreateLocalized("Show values");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 610); ac++;
    XtSetArg(args[ac], XmNy, 57); ac++;
    XtSetArg(args[ac], XmNwidth, 170); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNtopWidget,pushB_reload_clusters ); ac++;
    XtSetArg(args[ac], XmNtopOffset, 5 ); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    XtSetArg(args[ac],XmNrightAttachment, XmATTACH_POSITION);ac++;
    XtSetArg(args[ac],XmNleftAttachment, XmATTACH_POSITION);ac++;
    XtSetArg(args[ac], XmNrightPosition, 98);ac++;
    XtSetArg(args[ac], XmNleftPosition, 75);ac++;
    pushB_display_info = XmCreatePushButton(form_cluster_general,
					    "pushB_display_info",
					    args, 
					    ac);
    register_widget_CB(pushB_display_info,(XtPointer)ID_pushB_display_info,NULL);
    create_event_CB(pushB_display_info,(XtPointer)ID_pushB_display_info,NULL);
    XtAddCallback(pushB_display_info,XmNactivateCallback,clu_para_activate_CB,
		  (XtPointer)ID_pushB_display_info);
    XtManageChild(pushB_display_info);
    XmStringFree(xmstring);
    

    ac = 0;
    XtSetArg(args[ac], XmNx, 190); ac++;
    XtSetArg(args[ac], XmNy, 17); ac++;
    XtSetArg(args[ac], XmNwidth, 396); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    textF_cluster_file_name = XmCreateTextField(form_cluster_general,
						"textF_cluster_file_name",
						args, 
						ac); 
    register_widget_CB(textF_cluster_file_name,(XtPointer)ID_textF_cluster_file_name,NULL);

    XtManageChild(textF_cluster_file_name);
    
    xmstring = XmStringCreateLocalized("Cluster file name:");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 22); ac++;
    XtSetArg(args[ac], XmNy, 17); ac++;
    XtSetArg(args[ac], XmNwidth, 154); ac++;
    XtSetArg(args[ac], XmNheight, 35); ac++;
    label_cluster_file = XmCreateLabel(form_cluster_general,
				       "label_cluster_file",
				       args, 
				       ac);
    XtManageChild(label_cluster_file);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopWidget, form_clu_para_w); ac++;
    XtSetArg(args[ac], XmNtopOffset, 2); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 70); ac++;
    XtSetArg(args[ac], XmNleftOffset, 2); ac++;
    XtSetArg(args[ac], XmNrightOffset, 2); ac++;
    XtSetValues(separator4, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopWidget, separator4); ac++;
    XtSetArg(args[ac], XmNtopOffset, 4); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 4); ac++;
    XtSetArg(args[ac], XmNleftOffset, 4); ac++;
    XtSetArg(args[ac], XmNrightOffset, 4); ac++;
    XtSetValues(form_clu_para_ctrl, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightPosition, 2); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 90); ac++;
    XtSetValues(pushB_ok_clu, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNleftPosition, 3); ac++;
    XtSetArg(args[ac], XmNrightPosition, 4); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetValues(pushB_apply_clu, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNleftPosition, 5); ac++;
    XtSetArg(args[ac], XmNrightPosition, 6); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetValues(pushB_cancel_clu, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNleftPosition, 7); ac++;
    XtSetArg(args[ac], XmNrightPosition, 8); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(pushB_help_clu, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 4); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 80); ac++;
    XtSetArg(args[ac], XmNleftOffset, 4); ac++;
    XtSetArg(args[ac], XmNrightOffset, 4); ac++;
    XtSetValues(form_clu_para_w, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 0); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(form_cluster_general, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 80); ac++;
    XtSetArg(args[ac], XmNleftPosition, 58); ac++;
    XtSetArg(args[ac], XmNrightPosition, 85); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(textF_clu_noise_sd, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 62); ac++;
    XtSetArg(args[ac], XmNleftPosition, 58); ac++;
    XtSetArg(args[ac], XmNrightPosition, 85); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(textF_clu_noise_m, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 80); ac++;
    XtSetArg(args[ac], XmNleftPosition, 32); ac++;
    XtSetArg(args[ac], XmNrightPosition, 60); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(label_clu_noise_sd, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 62); ac++;
    XtSetArg(args[ac], XmNleftPosition, 31); ac++;
    XtSetArg(args[ac], XmNrightPosition, 53); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetValues(label_clu_noise_m, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 62); ac++;
    XtSetArg(args[ac], XmNbottomPosition, 95); ac++;
    XtSetArg(args[ac], XmNleftPosition, 2); ac++;
    XtSetArg(args[ac], XmNrightPosition, 30); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(radioBox5, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNtopPosition, 45); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetValues(label_noise1, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopPosition, 42); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(separator8, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 28); ac++;
    XtSetArg(args[ac], XmNleftPosition, 30); ac++;
    XtSetArg(args[ac], XmNrightPosition, 53); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(label_clu_nb_neurons, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 28); ac++;
    XtSetArg(args[ac], XmNleftPosition, 0); ac++;
    XtSetArg(args[ac], XmNrightPosition, 28); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(label_neurons_in_cluster, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 6); ac++;
    XtSetArg(args[ac], XmNleftPosition, 75); ac++;
    XtSetArg(args[ac], XmNrightPosition, 98); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(pushB_file_select, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 6); ac++;
    XtSetArg(args[ac], XmNleftPosition, 26); ac++;
    XtSetArg(args[ac], XmNrightPosition, 70); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(textF_cluster_file_name , args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(args[ac], XmNtopPosition, 6); ac++;
    XtSetArg(args[ac], XmNleftPosition, 3); ac++;
    XtSetArg(args[ac], XmNrightPosition, 24); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(label_cluster_file, args, ac);
    
    return( form_cluster_parameters );
}

/*
 * Create the help_form hierarchy of widgets.
 */
Widget
Createform_help(parent)
Widget parent;
{
    Arg      args[256];
    Cardinal ac=0;
    Boolean  argok=False;
    Widget   help_shell;
    Widget   help_form;
    Widget   menuBar;
    Widget   topic_cascadeButton;
    Widget   topic_label;
    Widget   dismiss_pushButton;
    Widget   scrolledWindow;
    Widget   help_text;
    Widget 	 topic_pulldownMenu;
    XmString	xmstring;
    
    
    /*
     * Register the converters for the widgets.
     */
    RegisterBxConverters(XtWidgetToApplicationContext(parent)); 
    XtInitializeWidgetClass(xmDialogShellWidgetClass);
    XtInitializeWidgetClass(xmFormWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmCascadeButtonWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);
    XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
    XtInitializeWidgetClass(xmTextWidgetClass);
    
    ac = 0;
    XtSetArg(args[ac], XmNtitle, "Help On Context"); ac++;
    XtSetArg(args[ac], XmNminWidth, 371); ac++;
    XtSetArg(args[ac], XmNminHeight, 165); ac++;
    XtSetArg(args[ac], XmNx, 508); ac++;
    XtSetArg(args[ac], XmNy, 217); ac++;
    XtSetArg(args[ac], XmNwidth, 536); ac++;
    XtSetArg(args[ac], XmNheight, 548); ac++;
    help_shell = XtCreatePopupShell("help_shell",
        xmDialogShellWidgetClass,
        parent,
        args, 
        ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    XtSetArg(args[ac], XmNx, 508); ac++;
    XtSetArg(args[ac], XmNy, 217); ac++;
    XtSetArg(args[ac], XmNwidth, 536); ac++;
    XtSetArg(args[ac], XmNheight, 548); ac++;
    help_form = XmCreateForm(help_shell,
        "help_form",
        args, 
        ac);
    
    
     /* create the icon */
	XtVaSetValues(XtParent(help_form),XtNiconPixmap,pixicon,NULL);
	
    register_widget_CB(help_form, (XtPointer)ID_help_form, (XtPointer)0);
   
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 2); ac++;
    XtSetArg(args[ac], XmNy, 2); ac++;
    XtSetArg(args[ac], XmNwidth, 532); ac++;
    XtSetArg(args[ac], XmNheight, 39); ac++;
    menuBar = XmCreateMenuBar(help_form,
        "menuBar",
        args, 
        ac);
    XtManageChild(menuBar);
    
    xmstring = XmStringCreateLocalized("Topic");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
/*
        CONVERT(parent, "Topic", 
        XmRXmString, 0, &argok)); if (argok) ac++;
*/	
    XtSetArg(args[ac], XmNmnemonic, 'T'); ac++;
    XtSetArg(args[ac], XmNx, 5); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 60); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    topic_cascadeButton = XmCreateCascadeButton(menuBar,
        "topic_cascadeButton",
        args, 
        ac);
    XtManageChild(topic_cascadeButton);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 515); ac++;
    XtSetArg(args[ac], XmNy, 253); ac++;
    XtSetArg(args[ac], XmNwidth, 109); ac++;
    XtSetArg(args[ac], XmNheight, 33); ac++;
    topic_pulldownMenu = XmCreatePulldownMenu(XtParent(topic_cascadeButton),
        "pulldownMenu",
        args, 
        ac);

    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, topic_pulldownMenu); ac++;
    XtSetValues(topic_cascadeButton, args, ac);
    
	register_widget_CB(topic_pulldownMenu, (XtPointer)ID_topic_pulldownMenu, (XtPointer)0);
   

    xmstring = XmStringCreateLocalized("help on NBC Simulator");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
/*
        CONVERT(parent, "help on NBC Simulator", 
        XmRXmString, 0, &argok)); if (argok) ac++;
*/	
    XtSetArg(args[ac], XmNx, 2); ac++;
    XtSetArg(args[ac], XmNy, 43); ac++;
    XtSetArg(args[ac], XmNwidth, 532); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    topic_label = XmCreateLabel(help_form,
        "topic_label",
        args, 
        ac);
    XtManageChild(topic_label);
    XmStringFree(xmstring);
    register_widget_CB(topic_label, (XtPointer)ID_topic_label, (XtPointer)0);
   
    
    
    xmstring = XmStringCreateLocalized("Dismiss");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
/*
        CONVERT(parent, "Dismiss", 
        XmRXmString, 0, &argok)); if (argok) ac++;
*/	
    XtSetArg(args[ac], XmNx, 150); ac++;
    XtSetArg(args[ac], XmNy, 508); ac++;
    XtSetArg(args[ac], XmNwidth, 236); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    dismiss_pushButton = XmCreatePushButton(help_form,
        "dismiss_pushButton",
        args, 
        ac);
    XtManageChild(dismiss_pushButton);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNscrollingPolicy, XmAUTOMATIC); ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 75); ac++;
    XtSetArg(args[ac], XmNwidth, 532); ac++;
    XtSetArg(args[ac], XmNheight, 421); ac++;
    scrolledWindow = XmCreateScrolledWindow(help_form,
        "scrolledWindow",
        args, 
        ac);
    XtManageChild(scrolledWindow);
    
    ac = 0;
    XtSetArg(args[ac], XmNeditMode, XmMULTI_LINE_EDIT); ac++;
    XtSetArg(args[ac], XmNeditable, False); ac++;
    XtSetArg(args[ac], XmNcursorPositionVisible, False); ac++;
    XtSetArg(args[ac], XmNcolumns, 160); ac++;
    XtSetArg(args[ac], XmNrows, 1); ac++;
    help_text = XmCreateText(scrolledWindow,
        "help_text",
        args, 
        ac);
    XtManageChild(help_text);
    register_widget_CB(help_text, (XtPointer)ID_help_text, (XtPointer)0);
   
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomWidget, topic_label); ac++;
    XtSetArg(args[ac], XmNtopOffset, 2); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 2); ac++;
    XtSetArg(args[ac], XmNleftOffset, 2); ac++;
    XtSetArg(args[ac], XmNrightOffset, 2); ac++;
    XtSetValues(menuBar, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomWidget, scrolledWindow); ac++;
    XtSetArg(args[ac], XmNtopOffset, 0); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 4); ac++;
    XtSetArg(args[ac], XmNleftOffset, 2); ac++;
    XtSetArg(args[ac], XmNrightOffset, 2); ac++;
    XtSetValues(topic_label, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftWidget, scrolledWindow); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 150); ac++;
    XtSetArg(args[ac], XmNrightOffset, 150); ac++;
    XtSetValues(dismiss_pushButton, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 75); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 52); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 4); ac++;
    XtSetValues(scrolledWindow, args, ac);
    
    return( help_form );
}



/*
 * Create the graph_form hierarchy of widgets.
 */
Widget
Createform_graph(parent)
Widget parent;
{
    Arg      args[256];
    Cardinal ac=0;
    Boolean  argok=False;
    Widget   graph_shell;
    Widget   graph_form;
    Widget   dismiss_pushButton_graph;
    Widget   scrolledWindowGraph;
    Widget   toggle_dot;
    Widget   toggle_global;
    XmString	xmstring;
    
    
    /*
     * Register the converters for the widgets.
     */
    RegisterBxConverters(XtWidgetToApplicationContext(parent)); 
    XtInitializeWidgetClass(xmDialogShellWidgetClass);
    XtInitializeWidgetClass(xmFormWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmCascadeButtonWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);
    XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
    XtInitializeWidgetClass(xmTextWidgetClass);

    graph_area_width = 650;
    
    ac = 0;
    XtSetArg(args[ac], XmNtitle, "Nucleus activity as a function of time"); ac++;
    XtSetArg(args[ac], XmNx, 300); ac++;
    XtSetArg(args[ac], XmNy, 330); ac++;
    XtSetArg(args[ac], XmNwidth,  graph_area_width); ac++;
    XtSetArg(args[ac], XmNheight, 300); ac++;
    graph_shell = XtCreatePopupShell("graph_shell",
        xmDialogShellWidgetClass,
        parent,
        args, 
        ac);
    register_widget_CB(graph_shell, (XtPointer)ID_graph_shell, (XtPointer)0);

    
    ac = 0;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    XtSetArg(args[ac], XmNwidth,  graph_area_width); ac++;
    XtSetArg(args[ac], XmNheight, 300); ac++;
    graph_form = XmCreateForm(graph_shell,
        "graph_form",
        args, 
        ac);
    
     /* create the icon */
    XtVaSetValues(XtParent(graph_form),XtNiconPixmap,pixicon,NULL);
	
    register_widget_CB(graph_form, (XtPointer)ID_graph_form, (XtPointer)0);
   
    xmstring = XmStringCreateLocalized("Dot display");
    ac = 0;
    XtSetArg(args[ac], XmNx, 2); ac++;
    XtSetArg(args[ac], XmNy, 2); ac++;
    XtSetArg(args[ac], XmNwidth, 150); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    toggle_dot = XmCreateToggleButton(graph_form,
        "toggle_dot",
        args, 
        ac);
    XtManageChild(toggle_dot);
    XmStringFree(xmstring);
    register_widget_CB(toggle_dot, (XtPointer)ID_toggle_dot, (XtPointer)0);
    create_event_CB(toggle_dot,(XtPointer)ID_toggle_dot,NULL);
    XtAddCallback(toggle_dot,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_toggle_dot);
    
    xmstring = XmStringCreateLocalized("Global activity");
    ac = 0;
    XtSetArg(args[ac], XmNx, 200); ac++;
    XtSetArg(args[ac], XmNy, 2); ac++;
    XtSetArg(args[ac], XmNwidth, 200); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    toggle_global = XmCreateToggleButton(graph_form,
        "toggle_global",
        args, 
        ac);
    XtManageChild(toggle_global);
    XmStringFree(xmstring);
    register_widget_CB(toggle_global, (XtPointer)ID_toggle_global, (XtPointer)0);
    create_event_CB(toggle_dot,(XtPointer)ID_toggle_dot,NULL);
    XtAddCallback(toggle_global,XmNvalueChangedCallback,sim_activate_CB,
		  (XtPointer)ID_toggle_global);
    
    
    xmstring = XmStringCreateLocalized("Close");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 150); ac++;
    XtSetArg(args[ac], XmNy, 260); ac++;
    XtSetArg(args[ac], XmNwidth, 236); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    dismiss_pushButton_graph = XmCreatePushButton(graph_form,
        "dismiss_pushButton_graph",
        args, 
        ac);
    XtManageChild(dismiss_pushButton_graph);
    register_widget_CB(dismiss_pushButton_graph, (XtPointer)ID_pushB_dismiss_graph, (XtPointer)0);
    XtAddCallback(dismiss_pushButton_graph,XmNactivateCallback,sim_activate_CB,
		  (XtPointer)ID_pushB_dismiss_graph);
    XmStringFree(xmstring);
    
    ac = 0;
    XtSetArg(args[ac], XmNscrollingPolicy, XmAUTOMATIC); ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 32); ac++;
    XtSetArg(args[ac], XmNwidth, graph_area_width); ac++;
    XtSetArg(args[ac], XmNheight, 250); ac++;
    scrolledWindowGraph = XmCreateScrolledWindow(graph_form,
        "scrolledWindowGraph",
        args, 
        ac);
    XtManageChild(scrolledWindowGraph);
    register_widget_CB(scrolledWindowGraph, (XtPointer)ID_scrolledWindowGraph, (XtPointer)0);

    ac = 0;
    XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 32); ac++;
    XtSetArg(args[ac], XmNbackground, WhitePixelOfScreen(DefaultScreenOfDisplay(the_display))); ac++;
    XtSetArg(args[ac], XmNwidth, graph_area_width); ac++;
    XtSetArg(args[ac], XmNheight, (101+simu->nb_neurons)); ac++;
    graph_area = XmCreateDrawingArea(scrolledWindowGraph,
        "graph_area",
        args, 
        ac);
    XtManageChild(graph_area);
    register_widget_CB(graph_area, (XtPointer)ID_graph_area, (XtPointer)0);
    XtAddCallback(graph_area,XmNexposeCallback,resize_graph,NULL);    

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 0); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNbottomWidget, scrolledWindowGraph); ac++;
    XtSetArg(args[ac], XmNleftOffset, 10); ac++;
    XtSetValues(toggle_dot, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNtopOffset, 0); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNbottomWidget, scrolledWindowGraph); ac++;
    XtSetArg(args[ac], XmNleftWidget, toggle_dot); ac++;
    XtSetArg(args[ac], XmNleftOffset, 10); ac++;
    XtSetArg(args[ac], XmNrightOffset, 10); ac++;
    XtSetValues(toggle_global, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 150); ac++;
    XtSetArg(args[ac], XmNrightOffset, 150); ac++;
    XtSetValues(dismiss_pushButton_graph, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 30); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 50); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(scrolledWindowGraph, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNtopWidget, scrolledWindowGraph); ac++;
    XtSetArg(args[ac], XmNleftWidget, scrolledWindowGraph); ac++;
    XtSetArg(args[ac], XmNrightWidget, scrolledWindowGraph); ac++;
    XtSetArg(args[ac], XmNtopOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(graph_area, args, ac);
    
    return( graph_shell );
}

