#ifndef _MESSBOX_
#define _MESSBOX_

/*----------------------------------------------------------------------------
 *	M E S S B O X . H
 *--------------------------------------------------------------------------*/


/*
*
*	Author: Patrick GLANDAZ
*		Laboratoire de Biomathematiques
*		URBB B3E INSERM U263
*		Faculte de Medecine Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert, July 1992 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is not, in any way, usable for commercial purpose.
*
*/

#define	   NOTHING_ANSWERED		1
#define	   OK_ANSWER			2
#define    CANCEL_ANSWER		3
#define    YES_ANSWER			4
#define	   NO_ANSWER			5

#define	   NB_DIR_TAB			10

#define	   k_QuestionD_mb		1
#define	   k_ErrorD_mb			2
#define	   k_PromptD_mb			3
#define	   k_MessageD_mb		4
#define	   k_FileSelectD_mb		5

/*--- Fonctions utilisees --------------------------------------------------*/

int	   display_message ();
int	   display_question ();
int	   display_error ();
char	   *display_prompt ();
char	   *display_fileselect ();

#endif
