#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- 18 modifications in this file -------------*/

#endif
/* --------------------------------------------------------------------------------------
			G_INTERFACE3.C
   ------------------------------------------------------------------------------------*/
/* cree les Widgets de G_neuron, les variables correspondantes
   sont declarees dans "G_interface.h" 

   Devolu au modele phenomenologique
*/

# if 0
			    top_levelG	(cf G_neuron2.c)
				|
	--------------------- Form_G --------------------
	|			|			|
   Drawing_A1			Row_Column_Menu		Push_Button_Calcul
   Drawing_A2			|
   Drawing_A3		  Menu_Bar_Main
(fabrique_drawing_areas())	|
		---------------------------------
		|				|
		File				Parameters
		  - Read Neuron			  - Conductance -> fabrique_scrolled_window_conductance()
		  - Write Back Neuron		  - PSP		-> fabrique_scrolled_window_PSP()
		  - Save Neuron As		  - NMDA	-> fabrique_form_NMDA()
		  - Plot Potential		  - Equilibrium	-> fabrique_scrolled_window_equilibrium()
		  - Quit			  - Activ-Inact -> fabrique_scrolled_window_activ()
						  - Simulation	-> fabrique_form_simulation()
		                                  - Scales      -> fabrique_form_Echelles()
# endif



#undef MAIN

#include "G_neuron.h"
#include "G_interface.h"
#include "G_reference.h"
#include "G_synap.h"

XmString  result;
int       n;
Arg       wargs[10];

Pixmap	equa_bits, equa_pix;
GC	eq_gc;
unsigned int equa_width, equa_height;


extern REFERENCE  reference1,reference2,reference3;


#define	DIAL_WIDTH	230
#define	DIAL_HEIGHT	270

/*   f o n c t i o n    u t i l e */

/*-------------------------------------------------------*/			
void fabrique_scrolled_window_phenom()
/*-------------------------------------------------------*/
# if 0
		Top_Level_Phenom
			|
		Scrolled_Window_Phenom
			|
		Row_Column_Phenom
			|
			widgets DeXDDial :
			DeXInput_Mb_Capacity
			DeXInput_G_Syn_EPSP
			DeXInput_G_Na
			DeXInput_G_Ca
			DeXInput_G_K_Ia
			DeXInput_G_K_Iahp
			DeXInput_Input_Crt
			DeXInput_G_Syn_IPSP
			DeXInput_G_K
			DeXInput_G_K_Im
			DeXInput_G_K_Ic
			DeXInput_G_Leak
# endif
{

        int		n;
	Arg		wargs[50];
	XmString	titre,
	                string1,
			string2,
			string3,
			string4,
			string5,
			string6,
			string7,
			string8,
			string9,
			string10,
			string11,
			string12,
			string13,
			string14,
			string15;

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	XmString	string26;
#endif

	XColor		rgb,
			def;

#if DEBUG
	printf("Dans fabrique_scrolled_window_phenom\n");
#endif

	if(flag_Phenom != 0)	/* si flag = 1 : la fenetre existe deja */
	{
		XtPopup(Top_Level_Phenom,XtGrabNone);
		return;
	} 


	
	/*---------- toplevel pour les parametres de Phenom ----------*/

	Top_Level_Phenom = XtCreateApplicationShell("topc",
							 topLevelShellWidgetClass,
							 wargs,
							 0);
	sprintf(buffer,"Phenomenologic models [%s]",model_name);
	XtVaSetValues(Top_Level_Phenom,
		      XmNtitle, buffer,
		      XmNx, w_x_1,
		      XmNy, (flag_horizontal? w_y_h1: w_y_v1), NULL);

	/*---- scrolledwindow pour la Phenom ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, ((screen_height - 120)/2));n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	XtSetArg(wargs[n], XmNwidth, (.46 * (screen_width - 20)));n++;
	Scrolled_Window_Phenom = XtCreateManagedWidget("Phenom",
							   xmScrolledWindowWidgetClass,
							   Top_Level_Phenom,
							   wargs, n);
	XtAddCallback(Top_Level_Phenom, XmNdestroyCallback, fermeture_Phenom, NULL);
							   
	/*---- container pour les widgets de Phenom ----*/

	/*************************************/
	
	n = 0;
	XtSetArg(wargs[n], XmNresizePolicy, XmRESIZE_GROW); n++;

	Phenom_form = XmCreateForm(Scrolled_Window_Phenom,
		"form",
		wargs, 
		n);
	XtManageChild(Phenom_form);

	/* Couleur de la fleche */
	XAllocNamedColor(XtDisplay(Top_Level_Phenom),
			 DefaultColormap(XtDisplay(Top_Level_Phenom),
			 DefaultScreen(XtDisplay(Top_Level_Phenom))),
			 "red", &def, &rgb);


	/* les parametres */
	
	n = 0;
	sprintf(buffer,"%s model values",model_name);

	string1 = XmStringCreateSimple(buffer);	

	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNx, 250); n++;
	XtSetArg(wargs[n], XmNy, 450); n++;
	XtSetArg(wargs[n], XmNwidth, 286); n++;
	XtSetArg(wargs[n], XmNheight, 30); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 5); n++;
	XtSetArg(wargs[n], XmNleftOffset, 250); n++;
	label_Phenoms = XmCreateLabel(Phenom_form,
		"label",
		wargs, 
		n);
	XtManageChild(label_Phenoms);
	XmStringFree(string1);
	
	n = 0;

	string1 = XmStringCreateSimple("No parameter selected              ");	

	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNx, 10); n++;
	XtSetArg(wargs[n], XmNy, 590); n++;
	XtSetArg(wargs[n], XmNheight, 30); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 5); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	label_p_selection = XmCreateLabel(Phenom_form,
		"label_p_select",
		wargs, 
		n);
	XtManageChild(label_p_selection);
	XmStringFree(string1);
	
	n = 0;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 35); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNwidth, DIAL_WIDTH);n++;
	XtSetArg(wargs[n], XmNheight, DIAL_HEIGHT);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], DeXNindicatorColor, def.pixel); n++;
	XtSetArg(wargs[n], DeXNincrement, 1L); n++;
	XtSetArg(wargs[n], DeXNminimum, 0L); n++;
	XtSetArg(wargs[n], DeXNmaximum, 100L); n++;
	XtSetArg(wargs[n], DeXNturnStep,1L);  n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0); n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
	XtSetArg(wargs[n], DeXNvalue, 0L); n++;
	XtSetArg(wargs[n], DeXNlabelString, " "); n++;
	Dial_Phenoms = XtCreateManagedWidget("dialPhenoms",
					      DeXdDialWidgetClass,
					      Phenom_form,
					      wargs, n);
	register_widget_CB(Dial_Phenoms, (XtPointer)ID_Dial_Phenoms, NULL);
	create_event_CB(Dial_Phenoms, (XtPointer)ID_Dial_Phenoms, NULL);
	XtAddCallback(Dial_Phenoms, DeXNvalueChangedCallback, (XtPointer)callback_Phenoms, NULL);

	
	string1 = XmStringCreateSimple("Noise type:"); 
	string2 = XmStringCreateSimple("Gaussian"); 
	string3 = XmStringCreateSimple("Colored"); 
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
	string6 = XmStringCreateSimple("New noise"); 

#endif
	noise_toggleButton = XmVaCreateSimpleOptionMenu(Phenom_form,
		"noise_OM",
		string1, 'I', 0, (XtPointer)callback_toggle_noise,
		XmVaPUSHBUTTON, string2, 'G', NULL, NULL,
		XmVaPUSHBUTTON, string3, 'C', NULL, NULL,
#ifdef ADD_NOISE_MODEL
/* Adapt here with the new noise */
		XmVaPUSHBUTTON, string6, 'M', NULL, NULL,
#endif
		XmNorientation, XmVERTICAL,
		NULL);
	register_widget_CB(noise_toggleButton, (XtPointer)ID_noise_toggleButton, NULL);
	create_event_CB(noise_toggleButton, (XtPointer)ID_noise_toggleButton, NULL);
	XtManageChild(noise_toggleButton);

	n = 0;
	XtSetArg(wargs[n], XmNx, 320); n++;
	XtSetArg(wargs[n], XmNy, 393); n++;
	XtSetArg(wargs[n], XmNwidth, 200); n++;
	XtSetArg(wargs[n], XmNheight, 62); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNtopWidget, Dial_Phenoms); n++;
	XtSetArg(wargs[n], XmNtopOffset, 10); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetValues(noise_toggleButton,wargs,n);
	XmStringFree(string1);
	XmStringFree(string2);
	XmStringFree(string3);
#ifdef ADD_NOISE_MODEL
/* Adapt here with the new method */
	XmStringFree(string6);
#endif


	/* Les radioBoxes */

	sprintf(buffer,"Resting potential: %.2f mV",p_rest_pot);
	string1 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Firing threshold: %.2f mV",seuil);
	string2 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Postspike potential: %.2f mV",pot_post_spike);
	string3 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Postspike threshold: %.2f mV",seuil_post_spike);
	string4 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Threshold fatigue: %.2f mV",fatigue);
	string5 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Membrane time cste: %.2f ms",tau_mb_pot);
	string6 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Threshold time cste: %.2f ms",tau_seuil);
	string7 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Shunt time cste: %.2f ms",shunt_tau);
	string8 = XmStringCreateSimple(buffer);

	/* now the cond burster parameters */

	sprintf(buffer,"Burst threshold: %.2f mV",seuil_burst);
	string9 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Postspike burst pot: %.2f mV",burst_post_spike);
	string10 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Min burst duration: %.2f ms",duree_burst_min);
	string11 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Max burst duration: %.2f ms",duree_burst_max);
	string12 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Spike frequency: %.2f sp/s",freq_spike);
	string13 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Max frequency: %.0f sp/s",freq_max);
	string14 = XmStringCreateSimple(buffer);
	sprintf(buffer,"Composition factor: %.0f",compose_fact);
	string15 = XmStringCreateSimple(buffer);
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	sprintf(buffer,"Parameter: %.2f",parameter);
	string26 = XmStringCreateSimple(buffer);
#endif

	n = 0;
	XtSetArg(wargs[n], XmNshadowType, XmSHADOW_IN); n++;
	XtSetArg(wargs[n], XmNx, 250); n++;
	XtSetArg(wargs[n], XmNy, 620); n++;
	XtSetArg(wargs[n], XmNwidth, 220); n++;
	XtSetArg(wargs[n], XmNheight, 376); n++; 
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 250); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightOffset, 5); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 35); n++;
	frame_RB = XmCreateFrame(Phenom_form,"frameRB1",wargs,n);
	XtManageChild(frame_RB);

	
	/*---- scrolledwindow pour la radio_box ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, 370);n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	XtSetArg(wargs[n], XmNwidth, 220);n++;
	frame_scrolled = XtCreateManagedWidget("frame_scrolled",
							   xmScrolledWindowWidgetClass,
							   frame_RB,
							   wargs, n);

	n = 0;
	XtSetArg(wargs[n], XmNisHomogeneous, False); n++;
	radioBox = XmCreateRadioBox(frame_scrolled,
		"radioBox",
		wargs, 
		n);
	register_widget_CB(frame_scrolled, (XtPointer)ID_radioBox, NULL);
	create_event_CB(frame_scrolled, (XtPointer)ID_radioBox, NULL);
	XtManageChild(radioBox);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	toggleButton1 = XmCreateToggleButton(radioBox,
		"toggleButton1",
		wargs, 
		n);
	XtManageChild(toggleButton1);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string2); n++;
	toggleButton2 = XmCreateToggleButton(radioBox,
		"toggleButton2",
		wargs, 
		n);
	XtManageChild(toggleButton2);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string3); n++;
	toggleButton3 = XmCreateToggleButton(radioBox,
		"toggleButton3",
		wargs, 
		n);
	XtManageChild(toggleButton3);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string4); n++;
	toggleButton4 = XmCreateToggleButton(radioBox,
		"toggleButton4",
		wargs, 
		n);
	XtManageChild(toggleButton4);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string5); n++;
	toggleButton5 = XmCreateToggleButton(radioBox,
		"toggleButton5",
		wargs, 
		n);
	XtManageChild(toggleButton5);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string6); n++;
	toggleButton6 = XmCreateToggleButton(radioBox,
		"toggleButton6",
		wargs, 
		n);
	XtManageChild(toggleButton6);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string7); n++;
	toggleButton7 = XmCreateToggleButton(radioBox,
		"toggleButton7",
		wargs, 
		n);
	XtManageChild(toggleButton7);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string8); n++;
	toggleButton8 = XmCreateToggleButton(radioBox,
		"toggleButton8",
		wargs, 
		n);
	XtManageChild(toggleButton8);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string9); n++;
	toggleButton9 = XmCreateToggleButton(radioBox,
		"toggleButton9",
		wargs, 
		n);
	XtManageChild(toggleButton9);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string10); n++;
	toggleButton10 = XmCreateToggleButton(radioBox,
		"toggleButton10",
		wargs, 
		n);
	XtManageChild(toggleButton10);
	
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string11); n++;
	toggleButton11 = XmCreateToggleButton(radioBox,
		"toggleButton11",
		wargs, 
		n);
	XtManageChild(toggleButton11);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string12); n++;
	toggleButton12 = XmCreateToggleButton(radioBox,
		"toggleButton12",
		wargs, 
		n);
	XtManageChild(toggleButton12);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string13); n++;
	toggleButton13 = XmCreateToggleButton(radioBox,
		"toggleButton13",
		wargs, 
		n);
	XtManageChild(toggleButton13);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string14); n++;
	toggleButton14 = XmCreateToggleButton(radioBox,
		"toggleButton14",
		wargs, 
		n);
	XtManageChild(toggleButton14);

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 160); n++;
	XtSetArg(wargs[n], XmNheight, 25); n++;
	XtSetArg(wargs[n], XmNlabelString, string15); n++;
	toggleButton15 = XmCreateToggleButton(radioBox,
		"toggleButton15",
		wargs, 
		n);
	XtManageChild(toggleButton15);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 200); n++;
	XtSetArg(wargs[n], XmNheight, 28); n++;
	XtSetArg(wargs[n], XmNlabelString, string24); n++;
	toggleButton24 = XmCreateToggleButton(radioBox1,
		"toggleButton24",
		wargs, 
		n);
	XtManageChild(toggleButton24);
#endif

	XmStringFree(string1);
	XmStringFree(string2);
	XmStringFree(string3);
	XmStringFree(string4);
	XmStringFree(string5);
	XmStringFree(string6);
	XmStringFree(string7);
	XmStringFree(string8);
	XmStringFree(string9);
	XmStringFree(string10);
	XmStringFree(string11);
	XmStringFree(string12);
	XmStringFree(string13);
	XmStringFree(string14);
	XmStringFree(string15);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	XmStringFree(string24);
#endif

	XtAddCallback(toggleButton1,  XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)1);
	XtAddCallback(toggleButton2,  XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)2);
	XtAddCallback(toggleButton3,  XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)3);
	XtAddCallback(toggleButton4,  XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)4);
	XtAddCallback(toggleButton5,  XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)5);
	XtAddCallback(toggleButton6,  XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)6);
	XtAddCallback(toggleButton7,  XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)7);
	XtAddCallback(toggleButton8,  XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)8);
	XtAddCallback(toggleButton9,  XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)9);
	XtAddCallback(toggleButton10, XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)10);
	XtAddCallback(toggleButton11, XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)11);
	XtAddCallback(toggleButton12, XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)12);
	XtAddCallback(toggleButton13, XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)13);
	XtAddCallback(toggleButton14, XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)14);
	XtAddCallback(toggleButton15, XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)15);
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	XtAddCallback(toggleButton24, XmNvalueChangedCallback, (XtPointer)retour_Phenoms, (XtPointer)24);
#endif


	XtManageChild(Scrolled_Window_Phenom);
	XtRealizeWidget(Top_Level_Phenom);

	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_Phenom), palette);

	XmToggleButtonSetState(toggleButton1,TRUE,TRUE);

	flag_Phenom = 1;
}

/*-------------------------------------------------------*/			
void fabrique_scrolled_window_inputs()
/*-------------------------------------------------------*/
# if 0
		Top_Level_Inputs
			|
		Scrolled_Window_Inputs
			|
		Row_Column_Inputs
			|
			widgets DeXDDial :
			DeXInput_Mb_Capacity
			DeXInput_G_Syn_EPSP
			DeXInput_G_Na
			DeXInput_G_Ca
			DeXInput_G_K_Ia
			DeXInput_G_K_Iahp
			DeXInput_Input_Crt
			DeXInput_G_Syn_IPSP
			DeXInput_G_K
			DeXInput_G_K_Im
			DeXInput_G_K_Ic
			DeXInput_G_Leak
# endif
{

        int		n;
	Arg		wargs[50];
	XmString	titre,
	                string1,
			string2,
			string3,
			string4,
			string5,
			string6,
			string7,
			string8,
			string9,
			string10,
			string11,
			string21,
			string22,
			string23,
			string24,
			string25;
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	XmString	string26;
#endif

	XColor		rgb,
			def;


	if(flag_Inputs != 0)	/* si flag = 1 : la fenetre existe deja */
	{
		XtPopup(Top_Level_Inputs,XtGrabNone);
		return;
	} 


	
	/*---------- toplevel pour les parametres de Inputs ----------*/

	Top_Level_Inputs = XtCreateApplicationShell("topc",
							 topLevelShellWidgetClass,
							 wargs,
							 0);
	XtVaSetValues(Top_Level_Inputs,
		      XmNtitle, "Simulation and stimulation parameters",
		      XmNx, (flag_horizontal? w_x_0: w_x_1),
		      XmNy, (flag_horizontal? w_y_h1: w_y_v1), NULL);

	
	/*---- scrolledwindow pour la Inputs ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, ((screen_height - 120)/2));n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	XtSetArg(wargs[n], XmNwidth, (.46 * (screen_width - 20)));n++;
	Scrolled_Window_Inputs = XtCreateManagedWidget("Inputs",
							   xmScrolledWindowWidgetClass,
							   Top_Level_Inputs,
							   wargs, n);
	XtAddCallback(Top_Level_Inputs, XmNdestroyCallback, fermeture_Inputs, NULL);
							   
	/*---- container pour les widgets de Inputs ----*/

	/*************************************/
	
	n = 0;
	XtSetArg(wargs[n], XmNresizePolicy, XmRESIZE_GROW); n++;
	/*
	XtSetArg(wargs[n], XmNwidth, (screen_width/2)); n++;
	XtSetArg(wargs[n], XmNheight, (screen_height - 55)); n++;
	*/
	Inputs_form = XmCreateForm(Scrolled_Window_Inputs,
		"form",
		wargs, 
		n);
	XtManageChild(Inputs_form);

	n = 0;

	string1 = XmStringCreateSimple("Simulation parameters");	

	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNx, 10); n++;
	XtSetArg(wargs[n], XmNy, 3); n++;
	XtSetArg(wargs[n], XmNwidth, DIAL_WIDTH); n++;
	XtSetArg(wargs[n], XmNheight, 20); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 3); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	label_sim_par = XmCreateLabel(Inputs_form,
		"labelsp",
		wargs, 
		n);
	XtManageChild(label_sim_par);
	XmStringFree(string1);
	

	/* Input Dial */
	/*---- widgets DeXInput et DeXdDial----*/

	/* Couleur de la fleche */
	XAllocNamedColor(XtDisplay(Top_Level_Inputs),
			 DefaultColormap(XtDisplay(Top_Level_Inputs),
			 DefaultScreen(XtDisplay(Top_Level_Inputs))),
			 "red", &def, &rgb);

	/* 1/ Input_Current */

	n = 0;
	XtSetArg(wargs[n], XmNx, 10); n++;
	XtSetArg(wargs[n], XmNy, 25); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 25); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNwidth, DIAL_WIDTH);n++;
	XtSetArg(wargs[n], XmNheight, DIAL_HEIGHT);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], DeXNindicatorColor, def.pixel); n++;
	XtSetArg(wargs[n], DeXNincrement, 1L); n++;
	XtSetArg(wargs[n], DeXNturnStep,1000L); n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 3); n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
	XtSetArg(wargs[n], DeXNvalue, 0L); n++; 
	if (flag_Phenom)
	{  
	  XtSetArg(wargs[n], DeXNlabelString, "Input (mV)"); n++;
	  XtSetArg(wargs[n], DeXNminimum, -40000L);n++;
	  XtSetArg(wargs[n], DeXNmaximum, 50000L); n++;
	}
	else
	{  
	  XtSetArg(wargs[n], DeXNlabelString, "Input (mA)"); n++;
	  XtSetArg(wargs[n], DeXNminimum, -10000L);n++;
	  XtSetArg(wargs[n], DeXNmaximum, 60000L); n++;
	}

	DeXInput_Input_Crt = XtCreateManagedWidget("inputcurrent",
						       DeXdDialWidgetClass,
						       Inputs_form,
						       wargs, n);
	XtAddCallback(DeXInput_Input_Crt, DeXNvalueChangedCallback, (XtPointer)callback_input_crt, NULL);
	register_widget_CB(DeXInput_Input_Crt, (XtPointer)ID_DeXInput_Input_Crt, NULL);
	create_event_CB(DeXInput_Input_Crt, (XtPointer)ID_DeXInput_Input_Crt, NULL);

	/*	Simulation */
	
	n = 0;
	XtSetArg(wargs[n], XmNx, 10); n++;
	XtSetArg(wargs[n], XmNy, 290); n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	XtSetArg(wargs[n], XmNtopOffset, 290); n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 200);n++;
	XtSetArg(wargs[n], DeXNvalue, duree_simul);n++;
	XtSetArg(wargs[n], DeXNlabelString, "Duration (ms)");n++;
	Repeat_Simulation_Duration = XtCreateManagedWidget("dureesimulation",
							     DeXinputWidgetClass,
							     Inputs_form,
							     wargs, n);
	XtAddCallback(Repeat_Simulation_Duration, DeXNokCallback, (XtPointer)callback_duree_simul, 0);
	register_widget_CB(Repeat_Simulation_Duration, (XtPointer)ID_Repeat_Simulation_Duration, NULL);
	create_event_CB(Repeat_Simulation_Duration, (XtPointer)ID_Repeat_Simulation_Duration, NULL);
	XtManageChild(Repeat_Simulation_Duration);
							     
	n = 0;
	XtSetArg(wargs[n], XmNx, 250); n++;
	XtSetArg(wargs[n], XmNy, 290); n++;
	XtSetArg(wargs[n], XmNwidth, 200); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 250); n++;
	XtSetArg(wargs[n], XmNtopOffset, 290); n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 4);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 10000);n++;
	XtSetArg(wargs[n], DeXNvalue, (int)(time_step*10000));n++;
	XtSetArg(wargs[n], DeXNlabelString, "Time Step (ms)");n++;
	Repeat_Time_Step = XtCreateManagedWidget("timestep",
						   DeXinputWidgetClass,
						   Inputs_form,
						   wargs, n);
	XtAddCallback(Repeat_Time_Step, DeXNokCallback, (XtPointer)callback_duree_simul, (XtPointer)1);
	register_widget_CB(Repeat_Time_Step, (XtPointer)ID_Repeat_Time_Step, NULL);
	create_event_CB(Repeat_Time_Step, (XtPointer)ID_Repeat_Time_Step, NULL);
	XtManageChild(Repeat_Time_Step);

	n = 0;
	string1 = XmStringCreateSimple("Fixed Duration Stim"); 
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNx, 250); n++;
	XtSetArg(wargs[n], XmNy, 260); n++;
	XtSetArg(wargs[n], XmNwidth, 284); n++;
	XtSetArg(wargs[n], XmNheight, 30); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftOffset, 250); n++;
	XtSetArg(wargs[n], XmNtopOffset, 260); n++;
	EDFixedDurationStim_pushButton = XmCreatePushButton(Inputs_form,
		"EDFixedDurationStim_pushButton",
		wargs,
		n);       
	XmStringFree(string1);
	XtAddCallback (EDFixedDurationStim_pushButton,XmNactivateCallback,
		       callback_fixed_duration_stim,(XtPointer)NULL);
	register_widget_CB(EDFixedDurationStim_pushButton, 
			   (XtPointer)ID_EDFixedDurationStim_pushButton, NULL);
	create_event_CB(EDFixedDurationStim_pushButton, 
			(XtPointer)ID_EDFixedDurationStim_pushButton, NULL);
	XtManageChild(EDFixedDurationStim_pushButton);
	

	/* Scales Start_Stimulation, Stop_Stimulation et Stimulation_Duration */
	

	sprintf(buffer,"Start Stim in %% (%.0f ms)",(float)(debut_stim));
	titre = XmStringCreateSimple(buffer);
	n = 0;
	XtSetArg(wargs[n], XmNx, 250); n++;
	XtSetArg(wargs[n], XmNy, 25); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 25); n++;
	XtSetArg(wargs[n], XmNleftOffset, 250); n++;
	XtSetArg(wargs[n], XmNwidth, 284); n++;
	XtSetArg(wargs[n], XmNheight,70 ); n++;
	XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(wargs[n], XmNscaleWidth, 284); n++;
	XtSetArg(wargs[n], XmNscaleHeight, 20); n++;
	XtSetArg(wargs[n], XmNborderWidth, 1); n++;
	XtSetArg(wargs[n], XmNminimum, 0); n++;
	XtSetArg(wargs[n], XmNmaximum,40); n++;
	XtSetArg(wargs[n], XmNvalue, 20); n++;
	XtSetArg(wargs[n], XmNshowValue, True); n++;
	XtSetArg(wargs[n], XmNbottomOffset, 5); n++;
	XtSetArg(wargs[n], XmNdecimalPoints, 0); n++;
	XtSetArg(wargs[n], XmNtitleString, titre); n++;
        Repeat_Start_Stimulation = XmCreateScale(Inputs_form,"debutstimulation",wargs,n);
	XmStringFree (titre);

	XtAddCallback (Repeat_Start_Stimulation, XmNvalueChangedCallback,
		       (XtPointer)callback_debut_stim, (XtPointer)NULL);
	register_widget_CB(Repeat_Start_Stimulation, 
			   (XtPointer)ID_Repeat_Start_Stimulation, NULL);
	create_event_CB(Repeat_Start_Stimulation, (XtPointer)ID_Repeat_Start_Stimulation, NULL);
	XtManageChild(Repeat_Start_Stimulation);

	sprintf(buffer,"Stop Stim in %% (%.0f ms)",(float)(fin_stim));
	titre = XmStringCreateSimple(buffer);
	n = 0;
	XtSetArg(wargs[n], XmNx, 250); n++;
	XtSetArg(wargs[n], XmNy, 105); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 105); n++;
	XtSetArg(wargs[n], XmNleftOffset, 250); n++;
	XtSetArg(wargs[n], XmNwidth, 284); n++;
	XtSetArg(wargs[n], XmNheight,70 );n++;
	XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(wargs[n], XmNscaleWidth, 284); n++;
	XtSetArg(wargs[n], XmNscaleHeight, 20); n++;
	XtSetArg(wargs[n], XmNborderWidth, 1); n++;
	XtSetArg(wargs[n], XmNminimum, 20); n++;
	XtSetArg(wargs[n], XmNmaximum, 100); n++;
	XtSetArg(wargs[n], XmNvalue, 40); n++;
	XtSetArg(wargs[n], XmNshowValue, True); n++;
	XtSetArg(wargs[n], XmNbottomOffset, 5); n++;
	XtSetArg(wargs[n], XmNdecimalPoints, 0); n++;
	XtSetArg(wargs[n], XmNtitleString, titre); n++;
        Repeat_Stop_Stimulation = XmCreateScale(Inputs_form,"finstimulation",wargs,n);
	XmStringFree (titre);
	XtAddCallback (Repeat_Stop_Stimulation, XmNvalueChangedCallback,
		       (XtPointer)callback_fin_stim, (XtPointer)NULL);
	register_widget_CB(Repeat_Stop_Stimulation, 
			   (XtPointer)ID_Repeat_Stop_Stimulation, NULL);
	create_event_CB(Repeat_Stop_Stimulation, 
			(XtPointer)ID_Repeat_Stop_Stimulation, NULL);
	XtManageChild(Repeat_Stop_Stimulation);
	

	duree_stim = fin_stim-debut_stim;
	sprintf(buffer,"Duration Stim in %% (%.0f ms)",(float)(duree_stim));
	titre = XmStringCreateSimple(buffer);
        n = 0;
	XtSetArg(wargs[n], XmNx, 250); n++;
	XtSetArg(wargs[n], XmNy, 185); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 185); n++;
	XtSetArg(wargs[n], XmNleftOffset, 250); n++;
	XtSetArg(wargs[n], XmNwidth, 284); n++;
	XtSetArg(wargs[n], XmNheight,70 );n++;
	XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(wargs[n], XmNscaleWidth, 284); n++;
	XtSetArg(wargs[n], XmNscaleHeight, 20); n++;
	XtSetArg(wargs[n], XmNborderWidth, 1); n++;
	XtSetArg(wargs[n], XmNminimum, 0); n++;
	XtSetArg(wargs[n], XmNmaximum, 80); n++;
	XtSetArg(wargs[n], XmNvalue, 20); n++;
	XtSetArg(wargs[n], XmNshowValue, True); n++;
	XtSetArg(wargs[n], XmNbottomOffset, 5); n++;
	XtSetArg(wargs[n], XmNdecimalPoints, 0); n++;
	XtSetArg(wargs[n], XmNtitleString, titre); n++;
        Repeat_Stimulation_Duration = XmCreateScale(Inputs_form,"dureestimulation",wargs,n);
	XmStringFree (titre);
	XtAddCallback (Repeat_Stimulation_Duration, XmNvalueChangedCallback,
		       (XtPointer)callback_duree_stim, (XtPointer)NULL);
	register_widget_CB(Repeat_Stimulation_Duration, 
			   (XtPointer)ID_Repeat_Stimulation_Duration, NULL);
	create_event_CB(Repeat_Stimulation_Duration, 
			(XtPointer)ID_Repeat_Stimulation_Duration, NULL);
	XtManageChild(Repeat_Stimulation_Duration);	

	/* Separateur */
	
	n = 0;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 370); n++;
	XtSetArg(wargs[n], XmNheight, 20); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_NONE); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 370); n++;
	XtSetArg(wargs[n], XmNleftOffset, 0); n++;
	XtSetArg(wargs[n], XmNrightOffset, 0); n++;
	separator = XmCreateSeparator(Inputs_form,
		"separator",
		wargs, 
		n);
	XtManageChild(separator);
	
	/*	Update automatique ou manuel */

	n = 0;
	string1 = XmStringCreateSimple("Update"); 
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNsensitive, False); n++;
	XtSetArg(wargs[n], XmNx, 10); n++;
	XtSetArg(wargs[n], XmNy, 390); n++;
	XtSetArg(wargs[n], XmNwidth, 90); n++;
	XtSetArg(wargs[n], XmNheight, 45); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 390); n++;
	XtSetArg(wargs[n], XmNleftOffset, 10); n++;
	update_pushButton = XmCreatePushButton(Inputs_form,
		"update_pushButton",
		wargs, 
		n);
	register_widget_CB(update_pushButton, (XtPointer)ID_update_pushButton, NULL);
	create_event_CB(update_pushButton, (XtPointer)ID_update_pushButton, NULL);
	XtManageChild(update_pushButton);
	XmStringFree(string1);
	
	string1 = XmStringCreateSimple("Update "); 
	string2 = XmStringCreateSimple("Automatic"); 
	string3 = XmStringCreateSimple("Manual"); 
	update_toggleButton = XmVaCreateSimpleOptionMenu(Inputs_form,
		"update_OM",
		string1, 'U', 0, (XtPointer)callback_toggle_update,
		XmVaPUSHBUTTON, string2, 'A', NULL, NULL,
		XmVaPUSHBUTTON, string3, 'N', NULL, NULL,
		NULL);
	register_widget_CB(update_toggleButton, (XtPointer)ID_update_toggleButton, NULL);
	create_event_CB(update_toggleButton, (XtPointer)ID_update_toggleButton, NULL);
	XtManageChild(update_toggleButton);

	n = 0;
	XtSetArg(wargs[n], XmNx, 140); n++;
	XtSetArg(wargs[n], XmNy, 393); n++;
	XtSetArg(wargs[n], XmNwidth, 190); n++;
	XtSetArg(wargs[n], XmNheight, 62); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 393); n++;
	XtSetArg(wargs[n], XmNleftOffset, 110); n++;
	XtSetValues(update_toggleButton,wargs,n);
	XmStringFree(string1);
	XmStringFree(string2);
	XmStringFree(string3);

	
	string1 = XmStringCreateSimple("Plot:"); 
	string2 = XmStringCreateSimple("Currents/Currents"); 
	string3 = XmStringCreateSimple("Interspike/Rate"); 
	string4 = XmStringCreateSimple("Currents/Interspike"); 
	string5 = XmStringCreateSimple("Currents/Rate"); 

	plot_toggleButton = XmVaCreateSimpleOptionMenu(Inputs_form,
		"plot_OM",
		string1, 'I', 0, (XtPointer)callback_toggle_plot,
		XmVaPUSHBUTTON, string2, 'C', NULL, NULL,
		XmVaPUSHBUTTON, string3, 'I', NULL, NULL,
		XmVaPUSHBUTTON, string4, 'A', NULL, NULL,
		XmVaPUSHBUTTON, string5, 'R', NULL, NULL,
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
		XmVaPUSHBUTTON, string6, 'M', NULL, NULL,
#endif
		NULL);
	register_widget_CB(plot_toggleButton, (XtPointer)ID_plot_toggleButton, NULL);
	create_event_CB(plot_toggleButton, (XtPointer)ID_plot_toggleButton, NULL);
	XtManageChild(plot_toggleButton);

	n = 0;
	XtSetArg(wargs[n], XmNx, 320); n++;
	XtSetArg(wargs[n], XmNy, 393); n++;
	XtSetArg(wargs[n], XmNwidth, 200); n++;
	XtSetArg(wargs[n], XmNheight, 62); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 393); n++;
	XtSetArg(wargs[n], XmNleftOffset, 300); n++;
	XtSetValues(plot_toggleButton,wargs,n);
	XmStringFree(string1);
	XmStringFree(string2);
	XmStringFree(string3);
	XmStringFree(string4);
	XmStringFree(string5);
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
	XmStringFree(string6);
#endif
#if 0
	/* Separateur */
	
	n = 0;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 435); n++;
	XtSetArg(wargs[n], XmNheight, 20); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopOffset, 435); n++;
	XtSetArg(wargs[n], XmNleftOffset, 0); n++;
	XtSetArg(wargs[n], XmNrightOffset, 0); n++;
	separator1 = XmCreateSeparator(Inputs_form,
		"separator1",
		wargs, 
		n);
	XtManageChild(separator1);
#endif

	XtAddCallback(update_pushButton, XmNactivateCallback, (XtPointer)callback_update, NULL);
	
	

	XtManageChild(Scrolled_Window_Inputs);
	XtRealizeWidget(Top_Level_Inputs);

	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_Inputs), palette);

	flag_Inputs = 1;
}




