/*---------------------------------------------------------------------------
	A V L . H  : Declaration des fonctions de gestion des AVL
---------------------------------------------------------------------------*/
/*
*
*	Author: Yann HERRY
*		Laboratoire de Biomathematiques
*		URBB B3E INSERM U263
*		Faculte de Medecine Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert, Mai 1993 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is not, in any way, usable for commercial purpose.
*
*/

#include "typavl.h"

extern struct NOEUD *INSERER(struct element *, ARBRE_AVL *, int );
extern void ENLEVER(struct element *, ARBRE_AVL *, int );
/*
extern struct element MIN(ARBRE_AVL );
*/
extern struct element tete(ARBRE_AVL *);

extern void parcours(ARBRE_AVL);
extern void liste(ARBRE_AVL);

extern struct NOEUD *search_listeD(int, ARBRE_AVL *);
extern struct NOEUD *search_avl(int, ARBRE_AVL *);


extern int  modif_avl(int, int, int, int, int);
extern void modif_matrix(void);
extern int  sup_avl(int, int);
extern void clear_avl(ARBRE_AVL *);
extern int  Create_Cle(int, int);

