#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- no modification in this file -------------*/

#endif

/*------------------------------------------------------------------
 *	S Y N A P . H
 *----------------------------------------------------------------*/

/* permet de stocker les valeurs du poids des connexions et des
   temps d'arrivee des inputs  et les caractristiques du PSP activ par le
   recepteur qui a ce transmetteur
*/
   
typedef struct SYNAP
{
	float	weight,		/* poids synaptique */
			t_arrivee,	/* temps d'arrivee de l'input */
			syn,		/* utile au calcul de G_Syn */
			g_Syn,		/* la conductance de l'ion */
			rev_pot,	/* pot de reversion */
			G_syn;		/* la conductance totale */
	float	tau_attack;
	float	tau_decay;
	float	tau_a_psp;
	float	tau_d_psp;
	float	syn_pos;
	float	syn_neg;
	int	transmetteur;	/* type de transmetteur */
  	int     num_transm;     /* numero du transmetteur */
    char    nom[20];
} SYNAP;

SYNAP	*tab_syn;
SYNAP   *tab_transitoire;
SYNAP   *tab_tempo;

typedef struct SYNAP_NMDA
{
	float	weight,
		t_arrivee;
}SYNAP_NMDA;

SYNAP_NMDA *tab_NMDA;
